<?php

// Digital Shop version 3.0.4
// Copyright (C) 2008-2014 JF Nutbroek <jfnutbroek@gmail.com>
// See the included End User License Agreement (EULA)

session_start();

if (isset($_REQUEST['captchaimage'])) {createcaptcha();exit;}

require_once('inc/configuration.php');
require_once('inc/css.php');
require_once('inc/languages.php');
require_once('inc/easyphpthumbnail.class.php');

// Enable shop transparency
if ($transparentshop)
	$shopcolor='transparent';
	
// Disable highlight
if (!$shophighlight)
	$highlightcolor='transparent';

// Check for logout
if (isset($_REQUEST['logout'])) {
	session_unset();
	session_destroy();
	require_login();
}

if ($admin_ip!='') {
	$valid_ips=explode(',',$admin_ip);
        if (!in_array($_SERVER['REMOTE_ADDR'],$valid_ips)) {
		header("HTTP/1.0 401 Unauthorized");
		exit;
	}
}

// Check for valid login
$_SESSION['validlogin']=false;
$_SESSION['requirelogin']=true;
$captchaerror='';
if (isset($_REQUEST['requirelogin'])) {
        if (isset($_REQUEST['captcha'])) {$captchauser=strtolower($_REQUEST['captcha']);} else {$captchauser='';}
        if (isset($_SESSION['digitalshopcaptchacode'])) {$captchacode=$_SESSION['digitalshopcaptchacode'];} else {$captchacode='';}
	$valid_users=explode(',',$login);
	foreach ($valid_users as $key => $validuser)
		$valid_users[$key]=md5($validuser . date('d'));
	if (isset($_REQUEST['new_user']) && isset($_REQUEST['new_password'])) {
                if ($captchacode==$captchauser) {
                        if (in_array(md5($_REQUEST['new_user'] . date('d')),$valid_users)) {
                        	$user_index=array_search(md5($_REQUEST['new_user'] . date('d')),$valid_users);
                        	if ($valid_users[$user_index+1]!=md5($_REQUEST['new_password'] . date('d'))) {
                        		require_login();
                        	} else {
                        		$_SESSION['digitalshop_user']=md5($_REQUEST['new_user'] . date('d'));
                        		$_SESSION['digitalshop_passw']=md5($_REQUEST['new_password'] . date('d'));
					$_REQUEST['help']=1;
                        	}
                        } else {
                        	require_login();
                        }
                } else {
                        $captchaerror='Wrong code - please try again.';
                        require_login();
                }
	// Check if current session is still valid
	} else if (isset($_SESSION['digitalshop_passw']) && isset($_SESSION['digitalshop_user'])) {
		if (in_array($_SESSION['digitalshop_user'],$valid_users)) {
			$user_index=array_search($_SESSION['digitalshop_user'],$valid_users);
			if ($valid_users[$user_index+1]!=$_SESSION['digitalshop_passw']) {require_login();}
		} else {
			require_login();
		}
	// Session data and form data is invalid
	} else {
		require_login();
	}
	// Login data corresponds with registered data
	$_SESSION['validlogin']=true;$_SESSION['requirelogin']=false;
}

if (!$_SESSION['validlogin']) {require_login();}

// Determine path to data dir
$homedir = str_replace(chr(92),chr(47),getcwd());
if ($data_dir_path=='') {$moveto=$homedir.'/data/';} else {$moveto=$data_dir_path.'data/';}

if (isset($_REQUEST['help'])) {help();}

if (isset($_REQUEST['couponcode'])) {couponcode($_REQUEST['couponcode'],$_REQUEST['value'],$_REQUEST['expire'],$_REQUEST['maxcntr']);}

// Connect to database
$conn=mysql_connect($host,$user,$password) or die ('Error connecting to MySQL database. <br /> Please verify your configuration.');
if ($database=='') {mysql_select_db('digitalshop');} else {mysql_select_db($database);}

if (isset($_REQUEST['start'])) {$_SESSION['start']=intval($_REQUEST['start']);} else if (!isset($_SESSION['start'])) {$_SESSION['start']=1;}
if ($_SESSION['start']<=0) {$_SESSION['start']=1;}

$sortarray=array('id','name','price','digid','email','txnid','sold','category','country','expire','cntr','maxcntr','coupon','aid','emailpay','invoice');
if (isset($_REQUEST['sort'])) {
	if ($_REQUEST['sort']==$_SESSION['sort']) {
		if ($_SESSION['sortorder']=='ASC') {$_SESSION['sortorder']='DESC';} else {$_SESSION['sortorder']='ASC';}
	} else {
		if (in_array($_REQUEST['sort'],$sortarray))
			$_SESSION['sort']=$_REQUEST['sort'];
	}
} else if (!isset($_SESSION['sort'])) {
	$_SESSION['sort']='id';
	$_SESSION['sortorder']='ASC';
}

// Upload a file or edit shop content 
$errormessage='';$filename='';$filesize='';$filetype='';$description='';$price='';$content='';$category='';
if (isset($_FILES['uploadcontent']) || isset($_REQUEST['editshop'])) {
	unset($_SESSION['menu']);
	if (isset($_FILES['uploadcontent'])) {
		// Check for upload errors		
		if ($_FILES['uploadcontent']['error']==UPLOAD_ERR_INI_SIZE) {unset($_FILES['uploadcontent']); $errormessage="Filesize not allowed on server. Please use FTP.";}
		if ($_FILES['uploadcontent']['error']==UPLOAD_ERR_PARTIAL) {unset($_FILES['uploadcontent']); $errormessage="Upload interrupted";}
	}
	if ($errormessage=='') {
		// No errors - upload digital content
		if (isset($_FILES['uploadcontent'])) {
			$filename=htmlentities(str_replace('..','',str_replace('/','',$_FILES['uploadcontent']['name'])));
			$filesize=$_FILES['uploadcontent']['size'];
			$filetype=$_FILES['uploadcontent']['type'];
		}
		if (isset($_REQUEST['description'])) {
			$description=mysql_real_escape_string($_REQUEST['description']);
			$description=str_replace('<start>','<START>',$description);
			$description=str_replace('<stop>','<STOP>',$description);
			$description=str_replace('</start>','',$description);
			$description=str_replace('</stop>','',$description);
		} else {
			$description='';
		}
		if ($_REQUEST['price']=='') {$_REQUEST['price']='0.00';}
		if (isset($_REQUEST['price'])) {$price=mysql_real_escape_string(number_format(floatval(str_replace(',','.',$_REQUEST['price'])),2,'.',''));} else {$price='';}
                if (isset($_REQUEST['discount'])) {$discount=mysql_real_escape_string(number_format(floatval(max(0,min(intval($_REQUEST['discount']),100))),0,'.',''));} else {$discount='';}
		if (isset($_REQUEST['category'])) {$category=mysql_real_escape_string(trim($_REQUEST['category']));} else {$category='';}
		if (isset($_REQUEST['subcat'])) {$subcat=mysql_real_escape_string(trim($_REQUEST['subcat']));} else {$subcat='';}
		if (isset($_REQUEST['title'])) {$title=mysql_real_escape_string($_REQUEST['title']);} else {$title='';}
		if (isset($_REQUEST['editshop'])) {$id=mysql_real_escape_string($_REQUEST['editshop']);} else {$id='n/a';}
		// Make sure subcategory name does not exist as category or subcategory already
		if ($subcat!='') {
			$querycat="SELECT DISTINCT category, subcat FROM digitalshop WHERE subcat='$subcat' AND category !=''";
			$resultcat=mysql_query($querycat);
			if ($resultcat && mysql_num_rows($resultcat)) {
				while ($resultcat && $rowcat=mysql_fetch_array($resultcat)) {
					if ($rowcat[category]!=trim($_REQUEST['category'])) {
						$subcat='';
						$errormessage="Updated, but subcategory name has been rejected (already exists in another main category).";
					}
				}
			}
			if ($subcat!='') {
				$querycat="SELECT DISTINCT category FROM digitalshop WHERE category='$subcat' AND category !=''";
				$resultcat=mysql_query($querycat);
				if ($resultcat && mysql_num_rows($resultcat)) {
					$subcat='';
					$errormessage="Updated, but subcategory name has been rejected (already exists as a main category name).";
				}
			}
		}
		if (isset($_FILES['uploadcontent'])) {$query="SELECT id, rname FROM digitalshop WHERE name = '$filename'";} else {$query="SELECT name, rname FROM digitalshop WHERE id = '$id'";}
		$result=mysql_query($query);
		if ($result && !mysql_num_rows($result) && $filesize!=0) {
			// Filename does not exist in database - new upload
			$randomfilename=md5(uniqid(rand(),true));
			if (move_uploaded_file($_FILES['uploadcontent']['tmp_name'],$moveto.$randomfilename)) {
				if ($chmod_level!='') {chmod($moveto.$randomfilename,octdec($chmod_level));}
				$query="INSERT INTO digitalshop (name, size, type, descr, price, rname, category, disc, title, subcat) VALUES ('$filename', '$filesize', '$filetype', '$description' , '$price', '$randomfilename', '$category', '$discount', '$title', '$subcat')";
				mysql_query($query) or die('Error, mysql insert failed');	
				$fileid=mysql_insert_id();$icon_ok=false;
				// Upload icon
				if (isset($_FILES['uploadicon'])) {
					$icon_filename=htmlentities(str_replace('..','',str_replace('/','',$_FILES['uploadicon']['name'])));
					if (move_uploaded_file($_FILES['uploadicon']['tmp_name'],$homedir.'/gfx/'.$fileid.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))))) {
						if ($chmod_level!='') {chmod($homedir.'/gfx/'.$fileid.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))),octdec($chmod_level));}
						$icon_ok=true;
					}
				}
				if (!$icon_ok) {
					// Add icon automatically based on extension
					$upload_extension=strtolower(substr($filename,strrpos($filename,'.')+1,strlen($filename)));
					if (in_array($upload_extension,array('jpg','jpeg','png','gif','psd','psp','tif','drw','eps','svg'))) {
						copy($homedir.'/gfx/sample_icons/96px/image.png',$homedir.'/gfx/'.$fileid.'.png');
					} else if (in_array($upload_extension,array('doc','docx','log','msg','rtf','txt','wpd','wps','odt','indd','qxd','qxp','rels'))) {
						copy($homedir.'/gfx/sample_icons/96px/document.png',$homedir.'/gfx/'.$fileid.'.png');
					} else if (in_array($upload_extension,array('aac','aif','iff','mp3','mpa','ra','wav','wma'))) {
						copy($homedir.'/gfx/sample_icons/96px/sound.png',$homedir.'/gfx/'.$fileid.'.png');
					} else if (in_array($upload_extension,array('3g2','3gp','asf','asx','avi','flv','mov','mp4','mpg','rm','swf','vob','wmv'))) {
						copy($homedir.'/gfx/sample_icons/96px/video.png',$homedir.'/gfx/'.$fileid.'.png');
					} else if (in_array($upload_extension,array('accdb','blg','csv','dat','efx','pdb','pps','ppt','pptx','sdb','sdf','sql','vcf','wks','xls','xlsx'))) {
						copy($homedir.'/gfx/sample_icons/96px/spreadsheet.png',$homedir.'/gfx/'.$fileid.'.png');
					} else if (in_array($upload_extension,array('7z','deb','gz','pkg','rar','sit','sitx','zip','zipx'))) {
						copy($homedir.'/gfx/sample_icons/96px/zipped.png',$homedir.'/gfx/'.$fileid.'.png');
					} else if ($upload_extension=='pdf') {
						copy($homedir.'/gfx/sample_icons/96px/pdf.png',$homedir.'/gfx/'.$fileid.'.png');
					}
				}
			} else {
				// Upload failed
				unset($_FILES['uploadcontent']); 
				$errormessage="Upload failed";			
			}
		} else if (isset($_REQUEST['overwrite']) || isset($_REQUEST['editshop'])) {
			// Filename exists in database and overwrite option is enabled
			if (isset($_FILES['uploadcontent'])) {
				$row=mysql_fetch_array($result);
				if (file_exists($moveto.$row[rname])) {unlink($moveto.$row[rname]);}
				if (move_uploaded_file($_FILES['uploadcontent']['tmp_name'],$moveto.$row[rname])) {
					if ($chmod_level!='') {chmod($moveto.$row[rname],octdec($chmod_level));}
					if ($description!='') {$query_1=", descr = '$description'";} else {$query_1='';}
					if (intval($price)!=0) {$query_2=", price = '$price'";} else {$query_2='';}
					if ($category!='') {$query_3=", category = '$category'";} else {$query_3='';}
                                        if (intval($discount)!=0) {$query_4=", disc = '$discount'";} else {$query_4='';}
					if ($title!='') {$query_5=", title = '$title'";} else {$query_5='';}
					if ($subcat!='') {$query_6=", subcat = '$subcat'";} else {$query_6='';}
					$query="UPDATE digitalshop SET size = '$filesize', type = '$filetype' $query_1 $query_2 $query_3 $query_4 $query_5 $query_6 WHERE name = '$filename'";
					// Upload icon
					if (isset($_FILES['uploadicon'])) {
						$icon_filename=htmlentities(str_replace('..','',str_replace('/','',$_FILES['uploadicon']['name'])));
						if (move_uploaded_file($_FILES['uploadicon']['tmp_name'],$homedir.'/gfx/'.$row[id].strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename)))))
							if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[id].strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))),octdec($chmod_level));}
					}
				} else {
					// Upload failed
					unset($_FILES['uploadcontent']); 
					$errormessage="Upload failed";						
				}
			} else {
				$query="UPDATE digitalshop SET descr = '$description', price = '$price', category = '$category', disc = '$discount', title = '$title', subcat = '$subcat' WHERE id = '$id'";
				// Upload icon
				if (isset($_FILES['uploadicon'])) {
					$icon_filename=htmlentities(str_replace('..','',str_replace('/','',$_FILES['uploadicon']['name'])));
					if (move_uploaded_file($_FILES['uploadicon']['tmp_name'],$homedir.'/gfx/'.$id.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename)))))
						if ($chmod_level!='') {chmod($homedir.'/gfx/'.$id.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))),octdec($chmod_level));}
				}				
			}
			mysql_query($query) or die('Error, mysql overwrite failed');
		} else {
			// Filename exists in database
			unset($_FILES['uploadcontent']); 
			$errormessage="Filename already exists in $shopname";
		}
	}
}

// Change template & shop colors
if (isset($_REQUEST['enablelayout'])) {
	if (isset($_REQUEST['templates'])) {
		$template=$_REQUEST['templates'];
		if ($template!='nochange') {
			$dir=opendir($homedir.'/shoptemplates/'.$template);
			while ($file=readdir($dir)) {
				if ($file!='.' && $file!='..') {
					if (substr($file,-3)=='css')
						copy($homedir.'/shoptemplates/'.$template.'/'.$file,$homedir.'/inc/'.$file);
					else if (!is_dir($file))
						copy($homedir.'/shoptemplates/'.$template.'/'.$file,$homedir.'/shopgfx/'.$file);
				}
			}
			closedir($dir);
		}	
	}
	if ($fp=fopen($homedir.'/inc/css.php','wb')) {
		fwrite($fp,"<?php\n");
		fwrite($fp,"// Color configuration file Digital Shop\n");
		if (isset($_REQUEST['pagecolor'])) {fwrite($fp,'$pagecolor=\'#'.preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['pagecolor']).str_repeat('0',6-strlen(preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['pagecolor'])))."';\n");$pagecolor=$_REQUEST['pagecolor'];}
		if (isset($_REQUEST['shopcolor'])) {fwrite($fp,'$shopcolor=\'#'.preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['shopcolor']).str_repeat('0',6-strlen(preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['shopcolor'])))."';\n");$shopcolor=$_REQUEST['shopcolor'];}
		if (isset($_REQUEST['highlightcolor'])) {fwrite($fp,'$highlightcolor=\'#'.preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['highlightcolor']).str_repeat('0',6-strlen(preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['highlightcolor'])))."';\n");$highlightcolor=$_REQUEST['highlightcolor'];}
		if (isset($_REQUEST['textcolor'])) {fwrite($fp,'$textcolor=\'#'.preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['textcolor']).str_repeat('0',6-strlen(preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['textcolor'])))."';\n");$textcolor=$_REQUEST['textcolor'];}
		if (isset($_REQUEST['linkcolor'])) {fwrite($fp,'$linkcolor=\'#'.preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['linkcolor']).str_repeat('0',6-strlen(preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['linkcolor'])))."';\n");$linkcolor=$_REQUEST['linkcolor'];}
		if (isset($_REQUEST['pricecolor'])) {fwrite($fp,'$pricecolor=\'#'.preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['pricecolor']).str_repeat('0',6-strlen(preg_replace("/[^a-fA-F0-9]/","",$_REQUEST['pricecolor'])))."';\n");$pricecolor=$_REQUEST['pricecolor'];}
		if (isset($_REQUEST['enablebackground'])) {fwrite($fp,'$enablebackground=true'.";\n");$enablebackground=true;} else {fwrite($fp,'$enablebackground=false'.";\n");$enablebackground=false;}
		if (isset($_REQUEST['transparentshop'])) {fwrite($fp,'$transparentshop=true'.";\n");$transparentshop=true;} else {fwrite($fp,'$transparentshop=false'.";\n");$transparentshop=false;}
		if (isset($_REQUEST['shophighlight'])) {fwrite($fp,'$shophighlight=false'.";\n");$shophighlight=false;} else {fwrite($fp,'$shophighlight=true'.";\n");$shophighlight=true;}
		fwrite($fp,'?>');
		fclose($fp);
		if ($chmod_level!='') {chmod($homedir.'/inc/css.php',octdec($chmod_level));}
	}
	header("Location: ./digitaladmin.php?requirelogin=1&albumlayout=1&refresh=" . time());
	exit;
	
}

// Enable or disable album options
if (isset($_REQUEST['enablealbum'])) {
	$lastid=intval($_REQUEST['enablealbum'])+1;
	for($i=1;$i<$lastid;$i++) {
		$query="SELECT id, name, rname FROM digitalshop WHERE id = '$i'";
		$result=mysql_query($query);
		if ($result && mysql_num_rows($result)) {
			$row=mysql_fetch_array($result);
			if (is_dir($moveto . $row[rname])) {
				if (isset($_REQUEST['album_'.$i])) {
					if (!file_exists($moveto . $row[rname] . '/photoalbum.php') && !file_exists($moveto . $row[rname] . '/mp3album.php')) {
						touch($moveto . $row[rname] . '/photoalbum.php');
						chmod($moveto . $row[rname] . '/photoalbum.php',octdec($chmod_level));
                                                // Rename all files to number between 01 and 99
                                                $imagefiles=array();
						$mp3=false;
                                                if ($dir=opendir($moveto.$row[rname])) {
                                                	while ($filename=readdir($dir)) {
                                                		if (($filename!='.') && ($filename!='..') && ($filename!='.htaccess') && !is_dir($filename)) {
                                                			$extension=strtolower(substr($filename,strrpos($filename,'.')+1,strlen($filename)));
									if ($extension=='mp3') {$mp3=true;}
									if ($filename!=='photoalbum.php') {
										$fmtime=filemtime($moveto.$row[rname].'/'.$filename);
										$imagefiles["$fmtime"]=$filename;
									}
                                                		}
                                                		if (count($imagefiles)==99)
                                                			break;							
                                                	}
                                                }
						ksort($imagefiles);
						$images=array();
						foreach($imagefiles as $key => $image) {
							$images[]=$image;
						}
						if ($mp3)
							rename($moveto . $row[rname] . '/photoalbum.php',$moveto . $row[rname] . '/mp3album.php');
                                                if (!file_exists($homedir.'/gfx/' . $row[name])) {
							mkdir($homedir.'/gfx/' . $row[name]);
							chmod($homedir.'/gfx/' . $row[name],octdec($chmod_level));
						}
						$names=array();
						if (is_readable('gfx/' . $row[name] . '/names.txt')) {
							if ($fp=@fopen('gfx/' . $row[name] . '/names.txt','r')) {
								if (filesize('gfx/' . $row[name] . '/names.txt')>0) {
									$names=explode('|',fread($fp,filesize('gfx/' . $row[name] . '/names.txt')));
								}
								fclose($fp);
							}
						}
						$fp=fopen($homedir.'/gfx/' . $row[name] . '/names.txt','ab'); 
                                                foreach($images as $key => $image) {
							$newname=str_repeat('0',2-strlen($key)).$key.'.';
							$imageoriginalname=substr($image,0,strrpos($image,'.'));
							if (strlen($imageoriginalname)>2 && !in_array($newname, $names)) {
								$upper=substr($image,0,strrpos($image,'.')+1).strtoupper(substr($image,strrpos($image,'.')+1,strlen($image)));
								$lower=substr($image,0,strrpos($image,'.')+1).strtolower(substr($image,strrpos($image,'.')+1,strlen($image)));
								$extension=strtolower(substr($image,strrpos($image,'.')+1,strlen($image)));
								$specialfile=false;
								$upperspecial="";
								$lowerspecial="";
								$upperspecialjpg="";
								$lowerspecialjpg="";								
								if (!in_array($extension, array('jpg','jpeg','png','gif','mp3'))) {
									$specialfile=true;
									$extension="png";
									$upperspecial=substr($image,0,strrpos($image,'.')+1).strtoupper($extension);
									$lowerspecial=substr($image,0,strrpos($image,'.')+1).$extension;
									$extension="jpg";
									$upperspecialjpg=substr($image,0,strrpos($image,'.')+1).strtoupper($extension);
									$lowerspecialjpg=substr($image,0,strrpos($image,'.')+1).$extension;									
								}
								if (!$specialfile && file_exists($homedir.'/gfx/'.$row[name]."/$upper")) {
									rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
									rename($homedir.'/gfx/'.$row[name]."/$upper",$homedir.'/gfx/'.$row[name].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
								} else if (!$specialfile && file_exists($homedir.'/gfx/'.$row[name]."/$lower")) {
									rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));                                             		
									rename($homedir.'/gfx/'.$row[name]."/$lower",$homedir.'/gfx/'.$row[name].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
								} else if ($specialfile) {
									if (file_exists($homedir.'/gfx/'.$row[name]."/$upperspecial")) {
										rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
										rename($homedir.'/gfx/'.$row[name]."/$upperspecial",$homedir.'/gfx/'.$row[name].'/'.$newname."png");
									} else if (file_exists($homedir.'/gfx/'.$row[name]."/$lowerspecial")) {
										rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
										rename($homedir.'/gfx/'.$row[name]."/$lowerspecial",$homedir.'/gfx/'.$row[name].'/'.$newname."png");
									} else if (file_exists($homedir.'/gfx/'.$row[name]."/$lowerspecialjpg")) {
										rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
										rename($homedir.'/gfx/'.$row[name]."/$lowerspecialjpg",$homedir.'/gfx/'.$row[name].'/'.$newname."jpg");
									} else if (file_exists($homedir.'/gfx/'.$row[name]."/$upperspecialjpg")) {
										rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
										rename($homedir.'/gfx/'.$row[name]."/$upperspecialjpg",$homedir.'/gfx/'.$row[name].'/'.$newname."jpg");
									} else {
										rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
										$extension=strtolower(substr($image,strrpos($image,'.')+1,strlen($image)));
										if (in_array($extension,array('psd','psp','tif','drw','eps','svg'))) {
											copy($homedir.'/gfx/sample_icons/96px/image.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/image.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}											
										} else if (in_array($extension,array('doc','docx','log','msg','rtf','txt','wpd','wps','odt','indd','qxd','qxp','rels'))) {
											copy($homedir.'/gfx/sample_icons/96px/document.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/document.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}											
										} else if (in_array($extension,array('aac','aif','iff','mpa','ra','wav','wma'))) {
											copy($homedir.'/gfx/sample_icons/96px/sound.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/sound.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}											
										} else if (in_array($extension,array('3g2','3gp','asf','asx','avi','flv','mov','mp4','mpg','rm','swf','vob','wmv'))) {
											copy($homedir.'/gfx/sample_icons/96px/video.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/video.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}											
										} else if (in_array($extension,array('accdb','blg','csv','dat','efx','pdb','pps','ppt','pptx','sdb','sdf','sql','vcf','wks','xls','xlsx'))) {
											copy($homedir.'/gfx/sample_icons/96px/spreadsheet.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/spreadsheet.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}											
										} else if (in_array($extension,array('7z','deb','gz','pkg','rar','sit','sitx','zip','zipx'))) {
											copy($homedir.'/gfx/sample_icons/96px/zipped.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/zipped.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}											
										} else if ($extension=='pdf') {
											copy($homedir.'/gfx/sample_icons/96px/pdf.png',$homedir.'/gfx/'.$row[name].'/'.$newname.'png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$newname.'png',octdec($chmod_level));}
											copy($homedir.'/gfx/sample_icons/96px/pdf.png',$homedir.'/gfx/'.$i.'.png');
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$i.'.png',octdec($chmod_level));}												
										}
									}
								} else if ($mp3) {
									// Copy and create MP3 sample track
									$mp3filename=$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image)));
									rename($moveto.$row[rname]."/$image",$mp3filename);
									$mp3size=ceil(($mp3_samplesize/100)*filesize($mp3filename));
									$fpmp3=fopen($mp3filename,"rb");
									$mp3data=fread($fpmp3,$mp3size);
									fclose($fpmp3);
									$fpmp3=fopen($homedir.'/gfx/'.$row[name].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))),"w");
									fwrite($fpmp3,$mp3data);
									fclose($fpmp3);
									chmod($homedir.'/gfx/'.$row[name].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))),octdec($chmod_level));
								} else {
									// Create thumbnail
									$thumb = new easyphpthumbnail;
									$thumb -> Thumblocation = $homedir.'/gfx/'.$row[name] .'/';
									$thumb -> Thumbsize = max(680,$photo_thumbsize);
									$thumb -> Chmodlevel = $chmod_level;
									rename($moveto.$row[rname]."/$image",$moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
									$thumb -> Createthumb($moveto.$row[rname].'/'.$newname.strtolower(substr($image,strrpos($image,'.')+1,strlen($image))));
								}
								fwrite($fp,rtrim($newname,'.') .'|' . $imageoriginalname . '|');
							}
                                                }
                                                fclose($fp);
                                                if ($chmod_level!='') {chmod($homedir.'/gfx/' . $row[name] . '/names.txt',octdec($chmod_level));}
                                        }
				} else if (is_dir($moveto . $row[rname]) && (file_exists($moveto . $row[rname] . '/photoalbum.php') || file_exists($moveto . $row[rname] . '/mp3album.php'))) {
					if (file_exists($moveto . $row[rname] . '/photoalbum.php'))
						unlink($moveto . $row[rname] . '/photoalbum.php');
					else
						unlink($moveto . $row[rname] . '/mp3album.php');
				}
				if (isset($_REQUEST['thumbnails_'.$i])) {
					if (!file_exists($moveto . $row[rname] . '/watermark.php') && file_exists($homedir.'/shopgfx/copyright.png')) {
						// Stamp all thumbnails with watermark
						$watermark=imagecreatefrompng($homedir.'/shopgfx/copyright.png');
						$wpos=explode(' ',str_replace('%','',$watermarkposition));
						if ($dir=opendir($homedir.'/gfx/'.$row[name])) {
							while ($filename=readdir($dir)) {
								if (($filename!='.') && ($filename!='..') && !is_dir($filename)) {
									$extension=strtolower(substr($filename,strrpos($filename,'.')+1,strlen($filename)));
									if ($extension=='jpg' || $extension=='jpeg' || $extension=='png' || $extension=='gif') {
										$size=GetImageSize($homedir.'/gfx/'.$row[name].'/'.$filename);
										switch($size[2]) {
											case 1:
												if (imagetypes() & IMG_GIF) {$im=imagecreatefromgif($homedir.'/gfx/'.$row[name].'/'.$filename);}
												break;
											case 2:
												if (imagetypes() & IMG_JPG) {$im=imagecreatefromjpeg($homedir.'/gfx/'.$row[name].'/'.$filename);}
												break;
											case 3:
												if (imagetypes() & IMG_PNG) {$im=imagecreatefrompng($homedir.'/gfx/'.$row[name].'/'.$filename);}
												break;
										}
										if ($size[2]==1 || $size[2]==2 || $size[2]==3) {
											imagecopymerge($im,$watermark,min(max(imagesx($im)*($wpos[0]/100)-0.5*imagesx($watermark),0),imagesx($im)-imagesx($watermark)),min(max(imagesy($im)*($wpos[1]/100)-0.5*imagesy($watermark),0),imagesy($im)-imagesy($watermark)),0,0,imagesx($watermark),imagesy($watermark),intval($transparency));
											switch($size[2]) {
												case 1:
													imagegif($im,$homedir.'/gfx/'.$row[name].'/'.$filename);
													break;
												case 2:
													imagejpeg($im,$homedir.'/gfx/'.$row[name].'/'.$filename,90);
													break;
												case 3:
													imagepng($im,$homedir.'/gfx/'.$row[name].'/'.$filename);
													break;
											}
											if ($chmod_level!='') {chmod($homedir.'/gfx/'.$row[name].'/'.$filename,octdec($chmod_level));}
											imagedestroy($im);
										}
									}
								}
							}
						}
					}
				}		
				if (isset($_REQUEST['xxx_'.$i])) {
					if (is_dir($moveto . $row[rname])) {
						if (!file_exists($moveto . $row[rname] . '/xxx.php')) {
							touch($moveto . $row[rname] . '/xxx.php');
							chmod($moveto . $row[rname] . '/xxx.php',octdec($chmod_level));
						}
					}
				} else if (is_dir($moveto . $row[rname]) && file_exists($moveto . $row[rname] . '/xxx.php')) {
					unlink($moveto . $row[rname] . '/xxx.php');
				}
			}
		}	
	}
	$_REQUEST['albumconfig']=1;
}

// Remove a file or directory
if (isset($_REQUEST['removefileid'])) {
	$id=mysql_real_escape_string($_REQUEST['removefileid']);
	$query="SELECT rname,name  FROM digitalshop WHERE id = '$id'";
	$result=mysql_query($query);
	if ($result && mysql_num_rows($result)) {
		$row=mysql_fetch_array($result);
		if (is_dir($moveto.$row[rname])) {
			if ($dir=opendir($moveto.$row[rname])) {
				while ($file=readdir($dir)) {
					if (($file!='.') && ($file!='..')) {
						unlink($moveto.$row[rname].'/'.$file);
					}
				}
				closedir($dir);
			}
			rmdir($moveto.$row[rname]);	
		} else if (file_exists($moveto.$row[rname])) {
			unlink($moveto.$row[rname]);
		}
		if (is_dir($homedir.'/gfx/'.$row[name])) {
			if ($dir=opendir($homedir.'/gfx/'.$row[name])) {
				while ($file=readdir($dir)) {
					if (($file!='.') && ($file!='..')) {
						unlink($homedir.'/gfx/'.$row[name].'/'.$file);
					}
				}
				closedir($dir);
			}
			rmdir($homedir.'/gfx/'.$row[name]);	
		} else if (file_exists($homedir.'/gfx/'.$row[name])) {
			unlink($homedir.'/gfx/'.$row[name]);
		}		
		$query="DELETE FROM digitalshop WHERE id = '$id'";
		$result=mysql_query($query);
	}
}

// Remove a blocked ip
if (isset($_REQUEST['removeip'])) {
	$id=mysql_real_escape_string($_REQUEST['removeip']);
	$query="DELETE FROM digitalshopaccess WHERE id = '$id'";
	$result=mysql_query($query);
}

// Remove a key 
if (isset($_REQUEST['removedigid'])) {
	$id=mysql_real_escape_string($_REQUEST['removedigid']);
	$query="DELETE FROM digitalshopkey WHERE digid = '$id'";
	$result=mysql_query($query);
}

// Remove an email address 
if (isset($_REQUEST['deletemail'])) {
	$id=mysql_real_escape_string($_REQUEST['deletemail']);
	$query="DELETE FROM digitalshopkey WHERE email = '$id'";
	$result=mysql_query($query);
}

// Remove a bank transfer
if (isset($_REQUEST['removetransfer'])) {
	$id=intval($_REQUEST['id']);
	$query="DELETE FROM digitalshoptransfer WHERE id = '$id'";
	$result=mysql_query($query);
}

// Remove a category
if (isset($_REQUEST['deletecategory'])) {
	$id=mysql_real_escape_string($_REQUEST['deletecategory']);
	$query="UPDATE digitalshop SET category = '' WHERE category = '$id' AND subcat = ''";
	$result=mysql_query($query);
	$query="UPDATE digitalshop SET subcat = '' WHERE subcat = '$id'";
	$result=mysql_query($query);	
	unset($_SESSION['menu']);
}

// Edit a category
if (isset($_REQUEST['editcategory'])) {
	$id=mysql_real_escape_string($_REQUEST['editcategory']);
	$newname=mysql_real_escape_string($_REQUEST['newname']);
	$query="UPDATE digitalshop SET category = '$newname' WHERE category = '$id'";
	$result=mysql_query($query);
	$query="UPDATE digitalshop SET subcat = '$newname' WHERE subcat = '$id'";
	$result=mysql_query($query);	
	unset($_SESSION['menu']);
}

// Edit a file or album name
if (isset($_REQUEST['editfilename']) && isset($_REQUEST['oldfilename'])) {
	$id=mysql_real_escape_string($_REQUEST['editfilename']);
	$newname=$_REQUEST['newfilename'];
	$oldname=$_REQUEST['oldfilename'];
	if (file_exists($homedir.'/gfx/'.$oldname)) {
                if (rename($homedir.'/gfx/'.$oldname,$homedir.'/gfx/'.$newname)) {
			$query="UPDATE digitalshop SET name = '$newname' WHERE id = '$id'";
			$result=mysql_query($query);
		}
	} else {
		$query="UPDATE digitalshop SET name = '$newname' WHERE id = '$id'";
		$result=mysql_query($query);		
	}
}

// Process a bank transfer
$bank_transfer_msg='';
if (isset($_REQUEST['process'])) {
	$id=intval($_REQUEST['process']);
	$query="SELECT * FROM digitalshoptransfer WHERE id = '$id'";
	$result=mysql_query($query);
	if ($result && mysql_num_rows($result)) {
		$row=mysql_fetch_array($result);
		$ids=explode("-", ltrim($row[ordercode],'DS'));
		$tax=0;
		$check_amount=0;		
		$txn_id=$row[invoice];
		$payer_email=$row[email];
		$country=$row[country];
		$amount=floatval($row[price]);
		if (array_key_exists($country,$countries)) {$countryinvoice=$countries[$country];} else {$countryinvoice='';}
		// Check for coupon and affiliate ID
		$unset=array();
		$coupon='';
		$aid='';
		$aid_emailpay='';
		$aid_bank='';
		$couponvalue=0;
		$couponcntr=0;
		foreach($ids as $key => $id) {
			if (substr($id,0,1)=='C' && $check_amount==0) {
				// Check for valid coupon
				$testid=mysql_real_escape_string($id);
				$query="SELECT * FROM digitalshopcoupon WHERE coupon = '$testid'";
				$resultcoupon=mysql_query($query);
				if ($resultcoupon && mysql_num_rows($resultcoupon)) {
					$row=mysql_fetch_array($resultcoupon);
					$id=$row[coupon];
					if ($row[expire]>time() && $row[cntr]<$row[maxcntr]) {
						// Valid coupon
						$check_amount=floatval($row[value]);
						$unset[]=$id;
						$coupon=$id;
						$couponvalue=$row[value];
						$couponcntr=$row[cntr]+1;
					} else {
						$bank_transfer_msg.="Coupon expired or used. Refund might be required.\n\n";			
					}
				} else {
					$bank_transfer_msg.="Coupon does not exist. Refund might be required.\n\n";		
				}
			} else if (substr($id,0,1)=='C') {
				// Only 1 coupon per order
				$unset[]=$id;
			}
			if ($affiliate && substr($id,0,1)=='A' && $aid=='') {
				// Check for valid affiliate
				$testaid=mysql_real_escape_string(ltrim($id,'A'));
				$query="SELECT aid, emailpay, bank FROM digitalshopaffiliate WHERE aid = '$testaid'";
				$resultaid=mysql_query($query);
				if ($resultaid && mysql_num_rows($resultaid)) {
					$row=mysql_fetch_array($resultaid);
					$aid=$row[aid];
					$aid_emailpay=$row[emailpay];
					$aid_bank=$row[bank];
					$unset[]=$id;
				} else {
					// Affiliate is unknown - no need to cancel order
					$unset[]=$id;		
				}
			} else if (substr($id,0,1)=='A') {
				// Only 1 affiliate per order
				$unset[]=$id;
			}	
		}
		foreach($unset as $id) {
			$key=array_search($id,$ids);
			unset($ids[$key]);
		}
		$ids=array_values($ids);
		// CHECK	
		if (!$log) {									
			$query="SELECT * FROM digitalshopkey WHERE txnid = '$txn_id'";					// CHECK4: Verify txn_id does not exist
			$result=mysql_query($query);
			if ($result && !mysql_num_rows($result)) {								
				$names=array();$prices=array();
				foreach($ids as $id) {									// CHECK5: Verify if payment amount is correct
					if (strlen($id)>4) {$multiplier=(strlen($id)-3)/2;$id=intval(substr($id,0,3));} else {$multiplier=1;}
					$query="SELECT name, price, disc FROM digitalshop WHERE id = '$id'";
					$result=mysql_query($query);
					if ($result && mysql_num_rows($result)) {
						$row=mysql_fetch_array($result);
						if ($multiplier!=1) {$quantity="($multiplier)";} else {$quantity='';}
						$names[]="$row[name] $quantity";
						if (floatval($row[disc])>0) {
						        $row[price]=floatval(str_replace(',','',$row[price]))-(floatval(str_replace(',','',$row[price]))*(floatval($row[disc])/100));
						}
						$row[price]=number_format(floatval($row[price]),2,'.',',');
						$prices[]=number_format(floatval(str_replace(',','',$row[price]))*$multiplier,2,'.',',');
						$check_amount=$check_amount+(floatval(str_replace(',','',$row[price]))*$multiplier);
					}
				}
				if ($check_amount<=$amount) {	// Check 7: Make sure amount is correct (higher amounts are accepted - taxes)
					// New VALID transaction!
					$keys=array();
					foreach($ids as $key => $id) {
						$keys[]=createkey($id,$payer_email,$txn_id,$country,$prices[$key]);
					}
					if (!digitalshopmailkey($payer_email,$mailfrom,$mailbcc,$keys,$names,$txn_id)) {
						$bank_transfer_msg="Unable to send email with key to buyer $payer_email";
					} else {
						if (array_key_exists($country,$add_taxes)) {$tax=$amount-($amount/(1+($add_taxes[$country]/100)));} 
						if ($coupon!='') {
							// Increase coupon counter
							$query="UPDATE digitalshopcoupon SET cntr = '$couponcntr' WHERE coupon = '$coupon'";
							$result=mysql_query($query);
						}
						if ($aid!='') {
							// Affiliate commission
							$netorder=$amount-$tax;
							$deduct=$netorder*($reduction/100);
							$payaid=number_format(floatval(($netorder-$deduct)*($commission/100)),3,'.',',');			
							$timestamp=time();
							$query="INSERT INTO digitalshopcommission (aid, stamp, txnid, credit, debet) VALUES ('$aid', '$timestamp', '$txn_id', '$payaid', '0')";
							$result=mysql_query($query);
							//Check Affiliate balance
							$credit=0;
							$debet=0;
							$query="SELECT SUM(credit + 0) as spaid FROM digitalshopcommission WHERE aid = '$aid'";
							$result=mysql_query($query);
							if ($result && mysql_num_rows($result)) {
								$row=mysql_fetch_array($result);
								$credit=$row[spaid];
							}
							$query="SELECT SUM(debet + 0) as spaid FROM digitalshopcommission WHERE aid = '$aid'";
							$result=mysql_query($query);
							if ($result && mysql_num_rows($result)) {
								$row=mysql_fetch_array($result);
								$debet=$row[spaid];
							}
							if (($credit-$debet)>$commission) {
								// Affiliate needs to receive payment warn administrator
								digitalshopmailcommission($shopcontact,$mailfrom,'',$aid,$credit,$debet,$aid_emailpay,$aid_bank);
							}
						}
						// Transaction OK - send reply to Autohorize.net
						$bank_transfer_msg="Transaction processed - download key sent by email";
						$id=intval($_REQUEST['process']);
						$query="DELETE FROM digitalshoptransfer WHERE id = '$id'";
						$result=mysql_query($query);
					}
				} else {
					$bank_transfer_msg='Total amount or currency is incorrect';
				}
			} else {
				$bank_transfer_msg='Transaction ID already exists. Order already processed?';			
			}
		}
	}
}

// Remove an affiliate
if (isset($_REQUEST['removeaffiliate'])) {
	$id=intval($_REQUEST['removeaffiliate']);
	$query="DELETE FROM digitalshopaffiliate WHERE id = '$id'";
	$result=mysql_query($query);
	$aid=mysql_real_escape_string($_REQUEST['aid']);
	$query="DELETE FROM digitalshopcommission WHERE id = '$aid'";
	$result=mysql_query($query);
}

// Update affiliate balance
if (isset($_REQUEST['affiliateid'])) {
	$id=intval($_REQUEST['affiliateid']);
	$query="SELECT aid FROM digitalshopaffiliate WHERE id = '$id'";
	$result=mysql_query($query);
	if ($result && mysql_num_rows($result)) {
		$row=mysql_fetch_array($result);
		$aid=$row[aid];
		$paid=mysql_real_escape_string(number_format(floatval(str_replace(',','.',$_REQUEST['paid'])),2,'.',''));
		$txn_id=mysql_real_escape_string($_REQUEST['txn_id']);
		$stamp=explode('-',$_REQUEST['stamp']);
		$timestamp=mktime(0,0,0,intval($stamp[1]),intval($stamp[2]),intval($stamp[0]));
		if ($_REQUEST['paid']>0) {
			$query="INSERT INTO digitalshopcommission (aid, stamp, txnid, credit, debet) VALUES ('$aid', '$timestamp', '$txn_id', '0', '$paid')";
		} else {
			$paid=mysql_real_escape_string(number_format(floatval(str_replace(',','.',abs($_REQUEST['paid']))),2,'.',''));
			$query="INSERT INTO digitalshopcommission (aid, stamp, txnid, credit, debet) VALUES ('$aid', '$timestamp', '$txn_id', '$paid', '0')";
		}
		$result=mysql_query($query);
	}
}

// Reactivate a key 
if (isset($_REQUEST['reactivateid'])) {
	$id=mysql_real_escape_string($_REQUEST['reactivateid']);
	$query="UPDATE digitalshopkey SET expire = '0', cntr = '0' WHERE digid = '$id'";
	$result=mysql_query($query);
}

// Reset download counter
if (isset($_REQUEST['resetid'])) {
	$id=mysql_real_escape_string($_REQUEST['resetid']);
	$query="UPDATE digitalshopkey SET cntr = '0' WHERE digid = '$id'";
	$result=mysql_query($query);
}

// Update email address
if (isset($_REQUEST['customerid'])) {
	$id=mysql_real_escape_string($_REQUEST['customerid']);
	$email=mysql_real_escape_string($_REQUEST['editemail']);
	$query="UPDATE digitalshopkey SET email = '$email' WHERE id = '$id'";
	$result=mysql_query($query);
}

// Add a coupon
if (isset($_REQUEST['coupon']) && isset($_REQUEST['value'])) {
	$value=mysql_real_escape_string(number_format(floatval(str_replace(',','.',-1*floatval($_REQUEST['value']))),2,'.',''));
	$expire=time()+intval($_REQUEST['expire'])*60*60;
	$maxcntr=max(1,intval($_REQUEST['maxcntr']));
	createcoupon($value,$expire,$maxcntr);
}

// Block/ban IP 
if (isset($_REQUEST['blockip'])) {
	$expire=2147483647; // January 19th 2038
	$ip=mysql_real_escape_string(trim($_REQUEST['blockip']));
	$query="INSERT INTO digitalshopaccess (ip, expire, cntr) VALUES ('$ip', '$expire', '8')";
	$result=mysql_query($query);			
}

// Add the admin vote
if (isset($_REQUEST['ratings']) && (isset($_REQUEST['increase']) || isset($_REQUEST['decrease']))) {
	if (isset($_REQUEST['increase'])) {
                $id=intval($_REQUEST['increase']);
                $correction=1;
        } else if (isset($_REQUEST['decrease'])) {
                $id=intval($_REQUEST['decrease']);
                $correction=-1;
        }
	$queryrating="SELECT COUNT(id) as votes, SUM(vote) AS rating FROM digitalshoprating WHERE prodid = '$id'";
	$resultrating=mysql_query($queryrating);
	if ($resultrating && mysql_num_rows($resultrating)) {
		$rowrating=mysql_fetch_array($resultrating);
		$votes=$rowrating[votes];
                $rating=$rowrating[rating];
                if ($votes>0)
                        $stars=round($rating/$votes);
                else
                        $stars=0;
	} else {
    		$votes=0;
                $rating=0;
		$stars=0;            
        }
        if (($stars+$correction)>5) {$correction=0;};
        if (($stars+$correction)<0) {$correction=0;};        
	$query="SELECT * FROM digitalshoprating WHERE ip = 'admin' AND prodid = '$id'";
        $result=mysql_query($query);
        if ($result && !mysql_num_rows($result)) {
                $requiredrating=($stars+$correction)*($votes+1);
                $correction=($requiredrating-$rating);
		$query="INSERT INTO digitalshoprating (prodid, vote, ip) VALUES ('$id', '$correction', 'admin')";
		$result=mysql_query($query);
	} else if ($result) {
                $requiredrating=($stars+$correction)*$votes;
                $correction=($requiredrating-$rating);
                $row=mysql_fetch_array($result);
                $correction=$row[vote]+$correction;
                $query="UPDATE digitalshoprating SET vote = '$correction' WHERE ip = 'admin' AND prodid = '$id'";
                $result=mysql_query($query);
	}
}

// Remove a coupon
if (isset($_REQUEST['coupon']) && isset($_REQUEST['removecoupon'])) {
	$id=mysql_real_escape_string($_REQUEST['removecoupon']);
	$query="DELETE FROM digitalshopcoupon WHERE coupon = '$id'";
	$result=mysql_query($query);
	if (file_exists($homedir.'/shopgfx/coupons/'.basename($_REQUEST['removecoupon']).'.png'))
		unlink($homedir.'/shopgfx/coupons/'.basename($_REQUEST['removecoupon']).'.png');
}

// Add a file 
if (isset($_REQUEST['addfile']) && isset($_SESSION['ftpfiles'])) {
	if (!isset($_REQUEST['massupload'])) {
		$_SESSION['ftpfiles']=array();
		$_SESSION['ftpfiles'][]=$_REQUEST['addfile'];
	} else {
		unset($_SESSION['menu']);
	}
	// Get information for mass upload
	if (isset($_REQUEST['description'])) {
		$description=mysql_real_escape_string($_REQUEST['description']);
		$description=str_replace('<start>','<START>',$description);
		$description=str_replace('<stop>','<STOP>',$description);
		$description=str_replace('</start>','',$description);
		$description=str_replace('</stop>','',$description);
	} else {
		$description='';
	}
	if ($_REQUEST['price']=='') {$_REQUEST['price']='0.00';}
	if (isset($_REQUEST['price'])) {$price=mysql_real_escape_string(number_format(floatval(str_replace(',','.',$_REQUEST['price'])),2,'.',''));} else {$price='';}
	if (isset($_REQUEST['discount'])) {$discount=mysql_real_escape_string(number_format(floatval(max(0,min(intval($_REQUEST['discount']),100))),0,'.',''));} else {$discount='';}
	if (isset($_REQUEST['category'])) {$category=mysql_real_escape_string(trim($_REQUEST['category']));} else {$category='';}
	if (isset($_REQUEST['subcat'])) {$subcat=mysql_real_escape_string(trim($_REQUEST['subcat']));} else {$subcat='';}
	if (isset($_REQUEST['title'])) {$title=mysql_real_escape_string($_REQUEST['title']);} else {$title='';}
	// Upload icon
	$randomiconfilename='';
	$icon_ok=false;
	if (isset($_FILES['uploadicon'])) {
		$randomiconfilename=md5(uniqid(rand(),true));
		$icon_filename=htmlentities(str_replace('..','',str_replace('/','',$_FILES['uploadicon']['name'])));
		if (move_uploaded_file($_FILES['uploadicon']['tmp_name'],$homedir.'/gfx/'.$randomiconfilename.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))))) {
			if ($chmod_level!='') {chmod($homedir.'/gfx/'.$randomiconfilename.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))),octdec($chmod_level));}
			$randomiconfilename=$randomiconfilename.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename)));
			$icon_ok=true;
		}
	}
	foreach($_SESSION['ftpfiles'] as $name) {
		$name=str_replace('..','',str_replace('/','',$name));
		$newtitle=str_replace('[filename]',str_replace('_',' ',substr($name,0,strrpos($name,'.'))),$title);
		$newdescription=str_replace('[filename]',str_replace('_',' ',substr($name,0,strrpos($name,'.'))),$description);
		if (is_dir($moveto.$name)) {
			$size=0;
			if ($dir=opendir($moveto.$name)) {
				while ($file=readdir($dir)) {
					if (($file!='.') && ($file!='..') && ($file!='.htaccess')) {
						$size=$size+filesize($moveto.$name.'/'.$file);
					}
				}
				closedir($dir);
			}
			$type='Directory';
			if (file_exists($moveto.'.htaccess')) {
				copy($moveto.'.htaccess',$moveto.$name.'/.htaccess');
				if ($chmod_level!='') {chmod($moveto.$name.'/.htaccess',octdec($chmod_level));}
			}
		} else {
			$size=0;
			$type='';
			if (file_exists($moveto.$name)) {
				$size=filesize($moveto.$name);
				$type=filemimetype(strtolower(substr($name,strrpos($name,'.')+1,strlen($name))));
			}
		}
		$query="SELECT id, rname, descr, title, disc, price, category, subcat FROM digitalshop WHERE name = '$name'";
		$result=mysql_query($query);
		$icon_id=0;
		if ($result && mysql_num_rows($result) && !is_dir($moveto.$name)) {	
			// File already exists
			$row=mysql_fetch_array($result);
			$icon_id=$row[id];
			if (file_exists($moveto.$row[rname])) {unlink($moveto.$row[rname]);}
			if (rename($moveto.$name,$moveto.$row[rname])) {
				if ($chmod_level!='') {chmod($moveto.$row[rname],octdec($chmod_level));}
				$name=mysql_real_escape_string($name);
				if ($newdescription=='') {$newdescription=$row[descr];}
				if ($newtitle=='') {$newtitle=$row[title];}
				if ($discount=='' || $discount==0) {$discount=$row[disc];}
				if ($price=='' || $price=='0.00') {$price=$row[price];}
				if ($category=='') {$category=$row[category];}
				if ($subcat=='') {$subcat=$row[subcat];}
				if (count($_SESSION['ftpfiles'])>1)
					$query="UPDATE digitalshop SET size = '$size', type = '$type', descr = '$newdescription', price = '$price', category = '$category', subcat = '$subcat', title = '$newtitle', disc = '$discount' WHERE name = '$name'";
				else
					$query="UPDATE digitalshop SET size = '$size', type = '$type' WHERE name = '$name'";
				mysql_query($query) or die('Error, mysql update failed');
			}			
		} else if ($result && !mysql_num_rows($result)) {
			// New file or directory
			$randomfilename=md5(uniqid(rand(),true));	
			if (rename($moveto.$name,$moveto.$randomfilename)) {
				if ($chmod_level!='') {chmod($moveto.$randomfilename,octdec($chmod_level));}
				if ($type=='Directory')
					$newtitle=str_replace('[filename]',str_replace('_',' ',$name),$title);				
				$name=mysql_real_escape_string($name);
				$query="INSERT INTO digitalshop (name, size, type, descr, price, rname, category, subcat, title, disc) VALUES ('$name', '$size', '$type', '$newdescription' , '$price', '$randomfilename', '$category', '$subcat', '$newtitle', '$discount')";
				mysql_query($query) or die('Error, mysql insert failed');
				$icon_id=mysql_insert_id();
			}
		}
		if (!$icon_ok) {
			// Add icon automatically based on extension
			$upload_extension=strtolower(substr($name,strrpos($name,'.')+1,strlen($name)));
			if (in_array($upload_extension,array('jpg','jpeg','png','gif','psd','psp','tif','drw','eps','svg'))) {
				copy($homedir.'/gfx/sample_icons/96px/image.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			} else if (in_array($upload_extension,array('doc','docx','log','msg','rtf','txt','wpd','wps','odt','indd','qxd','qxp','rels'))) {
				copy($homedir.'/gfx/sample_icons/96px/document.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			} else if (in_array($upload_extension,array('aac','aif','iff','mp3','mpa','ra','wav','wma'))) {
				copy($homedir.'/gfx/sample_icons/96px/sound.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			} else if (in_array($upload_extension,array('3g2','3gp','asf','asx','avi','flv','mov','mp4','mpg','rm','swf','vob','wmv'))) {
				copy($homedir.'/gfx/sample_icons/96px/video.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			} else if (in_array($upload_extension,array('accdb','blg','csv','dat','efx','pdb','pps','ppt','pptx','sdb','sdf','sql','vcf','wks','xls','xlsx'))) {
				copy($homedir.'/gfx/sample_icons/96px/spreadsheet.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			} else if (in_array($upload_extension,array('7z','deb','gz','pkg','rar','sit','sitx','zip','zipx'))) {
				copy($homedir.'/gfx/sample_icons/96px/zipped.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			} else if ($upload_extension=='pdf') {
				copy($homedir.'/gfx/sample_icons/96px/pdf.png',$homedir.'/gfx/'.$icon_id.'.png');
				if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.'.png',octdec($chmod_level));}
			}
		} else {
			if (file_exists($homedir.'/gfx/'.$icon_id.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename)))))
				unlink($homedir.'/gfx/'.$icon_id.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))));
			copy($homedir.'/gfx/'.$randomiconfilename,$homedir.'/gfx/'.$icon_id.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))));
			if ($chmod_level!='') {chmod($homedir.'/gfx/'.$icon_id.strtolower(substr($icon_filename,strrpos($icon_filename,'.'),strlen($icon_filename))),octdec($chmod_level));}
		}
	}
	if ($icon_ok)
		unlink($homedir.'/gfx/'.$randomiconfilename);
	unset($_SESSION['ftpfiles']);
	unset($_REQUEST['massupload']);
	$_REQUEST['showdigitalshop']=1;
	$_REQUEST['start']=1;
}

// Add a manual sale
if (isset($_REQUEST['txn_id']) && isset($_REQUEST['payer_email']) && isset($_REQUEST['ordercode']) && isset($_REQUEST['country'])) {
	$txn_id=$_REQUEST['txn_id'];$payer_email=$_REQUEST['payer_email'];$country=$_REQUEST['country'];
	$ids=explode("-",$_REQUEST['ordercode']);
	$tax=0;
	if (isset($_REQUEST['tax'])) {
		if (isset($_REQUEST['taxamount'])) {$tax=floatval($_REQUEST['taxamount']);}
	}
	// Construct new ordercode
	$compactcode='';
	foreach($ids as $product) {
		if ($compactcode=='') {
			$compactcode=$compactcode . $product . '-';
		} else if (strlen($product)==5) {
			$orders=explode('-',rtrim($compactcode,'-'));
			$exist=false;
			foreach ($orders as $key => $order){
				if (substr($order,0,3)==substr($product,0,3)) {
					$orders[$key]=$order.substr($product,3,4);
					$exist=true;
				}
			}
			if (!$exist) {$orders[]=$product;}
			$compactcode=implode('-',$orders) . '-';
		} else {
			$compactcode=$compactcode . $product . '-';
		}
	}
	$compactcode=rtrim($compactcode,'-');	
	$ids=explode("-",$compactcode);
	if ($txn_id!='' && $payer_email!='') {
		$keys=array();$names=array();$prices=array();$check_amount=0;
		foreach($ids as $id) {
			if ($id>0) {
				$originalid=$id;
				if (strlen($id)>4) {$multiplier=(strlen($id)-3)/2;$id=intval(substr($id,0,3));} else {$multiplier=1;}
				$query="SELECT name, price, disc FROM digitalshop WHERE id = '$id'";
				$result=mysql_query($query);
				if ($result && mysql_num_rows($result)) {
					$row=mysql_fetch_array($result);
					if ($multiplier!=1) {$quantity="($multiplier $lang_86)";} else {$quantity='';}
					$names[]="$row[name] $quantity";
					if ($row[disc]>0) {
						$row[price]=floatval(str_replace(',','',$row[price]))-(floatval(str_replace(',','',$row[price]))*(floatval($row[disc])/100));
					}
					$row[price]=number_format(floatval($row[price]),2,'.',',');
					$prices[]=number_format(floatval(str_replace(',','',$row[price]))*$multiplier,2,'.',',');
					$check_amount=$check_amount+$multiplier*floatval(str_replace(',','',$row[price]));
					if (isset($_REQUEST['sendinvoice'])) {
						if (isset($_REQUEST['tax'])) 
							$gross=str_replace(',','',number_format((floatval(str_replace(',','',$row[price]))+($tax/100)*floatval(str_replace(',','',$row[price])))*$multiplier,3,'.',','));
						else
							$gross=str_replace(',','',$row[price]);
					} else {
						$gross=str_replace(',','',$row[price]);
					}
					$keys[]=createkey($originalid,$payer_email,$txn_id,$country,$gross);
				} else {
					$names[]='File does not exist';
				}
			}
		}
		if (!digitalshopmailkey($payer_email,$mailfrom,$mailbcc,$keys,$names,$txn_id)) {
			die('Unable to email customer the key');
		}
		if (isset($_REQUEST['sendinvoice'])) {	
			if (array_key_exists($country,$countries)) {$countryinvoice=$countries[$country];} else {$countryinvoice='';}
				if (!digitalshopmailinvoice($payer_email,$mailfrom,$mailbcc,$keys,$names,$txn_id,$prices,$check_amount,$check_amount,$countryinvoice,$tax)) {
					die('Unable to email customer the invoice (key was sent)');			
			}
		}
	}
}

// Download the customer list
if (isset($_REQUEST['customerlist'])) {
	if ($_REQUEST['customerlist']==1) {
		$csvdata='Purchased,Country,Key,Transaction ID,Email,File ID,Filename,Expires,Download counter'. "\r\n";
	} else if ($_REQUEST['customerlist']==2) {
		$csvdata="Purchased,Country,Transaction ID,Filename,Revenue $currency,PayPal Fee $currency". "\r\n";
	} else {
		$csvdata="Affiliate ID,Affiliate Payment email address,Online Bank,Transaction Date,Transaction ID,Commission Due $currency,Commission Paid $currency". "\r\n";
	}
	if ($_REQUEST['customerlist']==3) {
		$query="SELECT * FROM digitalshopcommission ORDER BY stamp";
		$result=mysql_query($query);	
		if ($result && mysql_num_rows($result)) {
			while ($row=mysql_fetch_array($result)) {
				$sold=date('Y-m-d H:i',$row[stamp]);
				$emailpay='';
				$query2="SELECT emailpay, bank FROM digitalshopaffiliate WHERE aid = '$row[aid]'";
				$result2=mysql_query($query2);	
				if ($result2 && mysql_num_rows($result2)) {
					$row2=mysql_fetch_array($result2);
					$emailpay=$row2[emailpay];
					$bank=$row2[bank];
				}
				$csvdata.='A'.$row[aid].','.$emailpay.','.$bank.','.$sold.','.$row[txnid].','.$row[credit].','.$row[debet]."\r\n";			
			}
			// Output file to browser
			header("Pragma: public");
			header("Expires: 0");
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
			header("Cache-Control: public");
			header("Content-Type: application/octet-stream");
			header("Content-Disposition: attachment; filename=commissions.csv;");
			header("Content-Transfer-Encoding: binary");
			echo $csvdata;
			exit;
		}
	} else {
		$query="SELECT * FROM digitalshopkey ORDER BY email";
		$result=mysql_query($query);	
		if ($result && mysql_num_rows($result)) {
			while ($row=mysql_fetch_array($result)) {
				$expires='Expired';
				if (time()<$row[expire]) {
					$expires=ceil(($row[expire]-time())/3600) . ' hrs';
				}
				if ($row[expire]==0) {$expires='Unused';}
				if (intval($row[sold])==0) {
					$sold='#N/A';
				} else {
					$sold=date('Y-m-d H:i',$row[sold]);
				}
				if ($row[country]=='') {
					$country='#N/A';
				} else {
					$country=$row[country];
				}			
				$filename='#N/A';
				if (strlen($row[fileid])>4) {$idcheck=intval(substr($row[fileid],0,3));} else {$idcheck=$row[fileid];}
				$query2="SELECT * FROM digitalshop WHERE id = '$idcheck'";
				$result2=mysql_query($query2);
				if ($result2 && mysql_num_rows($result2)) {
					$row2=mysql_fetch_array($result2);
					$filename=$row2[name];
				}
				if ($_REQUEST['customerlist']==1)
					$csvdata.=$sold.','.$country.','.$row[digid].','.$row[txnid].','.$row[email].','.$row[fileid].','.$filename.','.$expires.','.$row[cntr]."\r\n";
				else
					$csvdata.=$sold.','.$country.','.$row[txnid].','.$filename.','.$row[gross].','.$row[fee]."\r\n";			
			}
			// Output file to browser
			header("Pragma: public");
			header("Expires: 0");
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
			header("Cache-Control: public");
			header("Content-Type: application/octet-stream");
			header("Content-Disposition: attachment; filename=customerlist.csv;");
			header("Content-Transfer-Encoding: binary");
			echo $csvdata;
			exit;
		}
	}
}

// Update RSS Feed
if (isset($_REQUEST['writerssfeed'])) {
	if ($fp=fopen($homedir.'/inc/rsscontent.php','wb')) {
		fwrite($fp,"<?php\n");
		fwrite($fp,"// RSS Feed for Digital Shop\n");
		if (isset($_REQUEST['rss_title'])) {fwrite($fp,'$rss_title' . "=html_entity_decode('" . htmlentities(stripslashes($_REQUEST['rss_title']), ENT_QUOTES) . "');\n");}
		if (isset($_REQUEST['rss_description'])) {fwrite($fp,'$rss_description' . "=html_entity_decode('" . htmlentities(stripslashes($_REQUEST['rss_description']), ENT_QUOTES) . "');\n");}
		if (isset($_REQUEST['rss_itemtitle'])) {fwrite($fp,'$rss_itemtitle' . "=html_entity_decode('" . htmlentities(stripslashes($_REQUEST['rss_itemtitle']), ENT_QUOTES) . "');\n");}		
		if (isset($_REQUEST['rss_itemlink'])) {fwrite($fp,'$rss_itemlink' . "=html_entity_decode('" . htmlentities(stripslashes($_REQUEST['rss_itemlink']), ENT_QUOTES) . "');\n");}
		fwrite($fp,'$rss_lastbuilddate=' . "'" . date(DATE_RSS) . "';\n");
		if (isset($_REQUEST['rss_itemdescription'])) {fwrite($fp,'$rss_itemdescription' . "=html_entity_decode('" . htmlentities(stripslashes($_REQUEST['rss_itemdescription']), ENT_QUOTES) . "');\n");}
		fwrite($fp,'?>');
		fclose($fp);
		if ($chmod_level!='') {chmod($homedir.'/inc/rsscontent.php',octdec($chmod_level));}
	}
}

// Mass Email
if (isset($_REQUEST['emailmessage'])) {
        $emailto=array();
        $emailstatus='';
        if (isset($_REQUEST['subject'])) {$subject=$_REQUEST['subject'];} else {$subject=$shopname;}
	if (isset($_REQUEST['createcoupon']) && isset($_REQUEST['couponvalue']) && isset($_REQUEST['couponexpire'])) {
		$value=number_format(str_replace(',','.',-1*floatval($_REQUEST['couponvalue'])),2,'.','');
		$expire=time()+intval($_REQUEST['couponexpire'])*60*60;
		$_SESSION['masscoupons']=array();
		$_SESSION['masscoupons'][0]=$value;
		$_SESSION['masscoupons'][1]=$expire;
	}
        $emailmessage=$_REQUEST['emailmessage'];
	if (isset($_REQUEST['emailid'])) {
		$emailid=intval($_REQUEST['emailid']);
		if ($emailid==-1) {
			if ($mailbcc=='') {$emailto[]=$shopcontact;} else {$emailto[]=$mailbcc;}
		} else if ($emailid==-2) {
                        if ($mailbcc=='') {$emailto[]=$shopcontact;} else {$emailto[]=$mailbcc;}
			$query="SELECT DISTINCT email FROM digitalshopkey";
			$result=mysql_query($query);
			if ($result && mysql_num_rows($result)) {
				while ($row=mysql_fetch_array($result)) {$emailto[]=$row[email];}
			}
                        // Count and store in session if more than 5 emails
                        if (count($emailto)>5) {
                                $_SESSION['emailto']=$emailto;
                                $_SESSION['subject']=$subject;
                                $_SESSION['emailmessage']=$emailmessage;
                                $_SESSION['totalemails']=count($emailto);
                                $_SESSION['failedemails']=array();                                
                        }
		} else if ($emailid==-3) {
                        if ($mailbcc=='') {$emailto[]=$shopcontact;} else {$emailto[]=$mailbcc;}
			$query="SELECT DISTINCT email FROM digitalshopaffiliate";
			$result=mysql_query($query);
			if ($result && mysql_num_rows($result)) {
				while ($row=mysql_fetch_array($result)) {$emailto[]=$row[email];}
			}
                        // Count and store in session if more than 5 emails
                        if (count($emailto)>5) {
                                $_SESSION['emailto']=$emailto;
                                $_SESSION['subject']=$subject;
                                $_SESSION['emailmessage']=$emailmessage;
                                $_SESSION['totalemails']=count($emailto);
                                $_SESSION['failedemails']=array();                                
                        }			
		} else {
                        if ($mailbcc=='') {$emailto[]=$shopcontact;} else {$emailto[]=$mailbcc;}
			$query="SELECT DISTINCT email FROM digitalshopkey WHERE fileid = '$emailid'";
			$result=mysql_query($query);
			if ($result && mysql_num_rows($result)) {
				while ($row=mysql_fetch_array($result)) {$emailto[]=$row[email];}
			}
			// Renew keys
			if (isset($_REQUEST['renewkeysmassemail'])) {
				$query="UPDATE digitalshopkey SET expire = '0', cntr = '0' WHERE fileid = '$emailid'";
				mysql_query($query) or die('Error, mysql key renewal failed - email(s) not send');
			}
                        // Count and store in session if more than 5 emails
                        if (count($emailto)>5) {
                                $_SESSION['emailto']=$emailto;
                                $_SESSION['subject']=$subject;
                                $_SESSION['emailmessage']=$emailmessage;
                                $_SESSION['totalemails']=count($emailto);
                                $_SESSION['failedemails']=array();
                        }
		}
                if (count($emailto)<=5) {
                        $fail='';$failcounter=0;
                        foreach ($emailto as $to) {
                                if (!massmail($to,$mailfrom,$subject,$emailmessage)) {
                                        $fail.="$to<br />";
					$failcounter += 1;
                                }
                        }
			unset($_SESSION['masscoupons']);
                        $emailstatus='Email send to ' . (count($emailto) - $failcounter) . " user(s)<br /><br />";
                        if ($fail!='') {
                                $emailstatus.="Unable to email the following addresses:<br /><br />";
                                $emailstatus.=$fail;
                        }
                }
        }
        if (isset($_SESSION['emailto'])) {
                $size=min(5,count($_SESSION['emailto']));
                for($i=0,$size;$i<$size;++$i) {
                        $lastkey=count($_SESSION['emailto'])-1;
                        if (!massmail($_SESSION['emailto'][$lastkey],$mailfrom,$_SESSION['subject'],$_SESSION['emailmessage'])) {
                                $_SESSION['failedemails'][]=$_SESSION['emailto'][$lastkey];
                        }
                        array_pop($_SESSION['emailto']);
                }
                if (count($_SESSION['emailto'])<1) {
			if (count($_SESSION['failedemails'])>0) {
				$emailstatus='Email send to ' . ($_SESSION['totalemails'] - count($_SESSION['failedemails'])) . " user(s)<br /><br />";
			} else  {
				$emailstatus='Email send to ' . $_SESSION['totalemails'] . " user(s)<br /><br />";
			}
                        if (count($_SESSION['failedemails'])>0) {
                                $emailstatus.="Unable to email the following addresses:<br /><br />";
                                foreach ($_SESSION['failedemails'] as $fail) {
                                        $emailstatus.=$fail . "<br />";
                                }      
                        }
                        unset($_SESSION['totalemails']);			
                        unset($_SESSION['emailto']);
			$subject=$_SESSION['subject'];
                        unset($_SESSION['subject']);
			$emailmessage=$_SESSION['emailmessage'];
                        unset($_SESSION['emailmessage']);
                        unset($_SESSION['failedemails']);
			unset($_SESSION['masscoupons']);
                }
        }
} else {
	$emailmessage='';
	$emailstatus='';
	$subject='';
}

// Show html forms
if (file_exists($homedir.'/inc/install.php')) {

	// Install database tables
	html_header();
	echo "<table style=\"width : 100%;\">\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr><tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">\n";
	$install_success = false;
	include('inc/install.php');
	if ($install_success) {
		if (unlink($homedir.'/inc/install.php')) {
			echo "</td></tr><tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">The file 'inc/install.php' has been removed. You can proceed to use the shop.</td></tr>\n";
			echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Please <em>respect</em> the copyright.<p>If you did not pay for this script visit:</p><a href=\"http://www.mywebmymail.com/digitalshop/digitalshop.php\">http://www.mywebmymail.com/digitalshop/digitalshop.php</a><p>and place an order.</p></td></tr>\n";
		} else {
			echo "</td></tr><tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Unable to delete the file 'inc/install.php'. Please remove manually.</td></tr>\n";
		}
	} else {
		echo "</td></tr><tr><td colspan=\"2\" style=\"color : #FF0000;font-weight : bold;text-align : center;\">There were problems with the database. Please check your configuration in 'inc/configuration.php'</td></tr>\n";
	}
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	html_footer();

} else if (!isset($_FILES['uploadcontent']) && !isset($_REQUEST['showdigitalshop']) && !isset($_REQUEST['editshop']) && !isset($_REQUEST['showcustomers']) && !isset($_REQUEST['albumconfig']) && !isset($_REQUEST['albumlayout']) && !isset($_REQUEST['manualsale']) && !isset($_REQUEST['massemail']) && !isset($_REQUEST['access']) && !isset($_REQUEST['rssfeed']) && !isset($_REQUEST['editcustomer']) && !isset($_REQUEST['coupon']) && !isset($_REQUEST['ratings']) && !isset($_REQUEST['revenue']) && !isset($_REQUEST['buynow']) && !isset($_REQUEST['affiliate']) && !isset($_REQUEST['editaffiliate']) && !isset($_REQUEST['bank']) && !isset($_REQUEST['managecategories']) && !isset($_REQUEST['createicons'])) {

	// Show main form
	html_header();
	echo "<div id=\"uploaddiv\"><table class=\"contenttable\"  style=\"width : 100%;\">\n";
	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";
	if ($errormessage!='') {
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Error</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"color : #FF0000;font-weight : bold;text-align : center;\">$errormessage</td></tr>\n";
		echo "<tr><td colspan=\"2\" >&nbsp;</td></tr>\n";
	}
	if (isset($_REQUEST['massupload'])) {
		$massupload=true;
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Notice</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"color : #FF0000;font-weight : bold;text-align : center;\">These settings will be applied to all uploaded files.<br />You can use [filename] in the title & description field as a placeholder for the filename.</td></tr>\n";
		echo "<tr><td colspan=\"2\" >&nbsp;</td></tr>\n";		
	} else {
		$massupload=false;
	}
	$description='';$price='0.00';$overwrite_selected='';$category='';$discount='';$subcat='';
	if (isset($_REQUEST['txn_id']) && isset($_REQUEST['payer_email']) && isset($_REQUEST['fileid'])) {
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;\">Manual purchase has been processed</td></tr>\n";
	}
	if (!isset($_REQUEST['edit']) && !$massupload) {
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">File to add to the shop:</td><td style=\"text-align : left;\"><input type=\"file\" name=\"uploadcontent\" class=\"input\" /></td></tr>\n";
	} else if (!$massupload) {
		$id=mysql_real_escape_string($_REQUEST['edit']);
		$query="SELECT name, descr, price, category, disc, title, subcat FROM digitalshop WHERE id = '$id'";
		$result=mysql_query($query);
		if ($result && mysql_num_rows($result)) {
			$row=mysql_fetch_array($result);
			$description=$row[descr];$price=$row[price];$category=stripslashes($row[category]);$subcat=stripslashes($row[subcat]);$filename=html_entity_decode($row[name]);$discount=$row[disc];$title=stripslashes($row[title]);
		}		
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">File ID:</td><td style=\"text-align : left;\">$id ($filename)<input type=\"hidden\" name=\"editshop\" value=\"$id\" /></td></tr>\n";
	}
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Product icon (max. 96px):</td><td style=\"text-align : left;\"><input type=\"file\" name=\"uploadicon\" class=\"input\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Price:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"price\" class=\"input\" size=\"6\" value=\"$price\" /> $currency</td></tr>\n";
        echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Discount:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"discount\" class=\"input\" size=\"6\" value=\"$discount\" /> %</td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Title:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"title\" class=\"input\" size=\"24\" maxlength=\"127\" value=\"$title\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Category:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"category\" class=\"input\" size=\"12\" value=\"$category\" />\n";
	// Show available categories
	$main_cat=array();$sub_cat=array();
	$querycat="SELECT DISTINCT category FROM digitalshop WHERE category!=''";
	$resultcat=mysql_query($querycat);
	if ($resultcat && mysql_num_rows($resultcat)) {
		while ($rowcat=mysql_fetch_array($resultcat)) {
			$main_cat[]=$rowcat[category];
		}
	}
	$querycat="SELECT DISTINCT subcat FROM digitalshop WHERE subcat!=''";
	$resultcat=mysql_query($querycat);
	if ($resultcat && mysql_num_rows($resultcat)) {
		while ($rowcat=mysql_fetch_array($resultcat)) {
			if (!in_array($rowcat[subcat],$main_cat))
				$sub_cat[]=$rowcat[subcat];
		}
	}
	$selectcategory="<select name=\"categories\" class=\"input\" onchange=\"this.blur();document.forms[0].category.value=document.forms[0].categories.options[document.forms[0].categories.options.selectedIndex].value;\"><option value=\"\">General</option>";
	if (count($main_cat)>0) {
		foreach($main_cat as $cat) {
			if ($cat!=$category) {$selectcategory.="<option value=\"$cat\">$cat</option>";} else {$selectcategory.="<option value=\"$cat\" selected>$cat</option>";}
		}
	}
	$selectcategory.='</select>';
	echo "$selectcategory";
	echo "</td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Sub-category:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"subcat\" class=\"input\" size=\"12\" value=\"$subcat\" />\n";
	$selectcategory="<select name=\"subcats\" class=\"input\" onchange=\"this.blur();document.forms[0].subcat.value=document.forms[0].subcats.options[document.forms[0].subcats.options.selectedIndex].value\"><option value=\"\">No sub-category</option>";
	if (count($sub_cat)>0) {
		foreach($sub_cat as $cat) {
			if ($cat!=$subcat) {$selectcategory.="<option value=\"$cat\">$cat</option>";} else {$selectcategory.="<option value=\"$cat\" selected>$cat</option>";}
		}	
	}
	$selectcategory.='</select>';
	echo "$selectcategory";
	echo "</td></tr>\n";
	if (!isset($_REQUEST['edit']) && !$massupload)
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Overwrite existing file:</td><td style=\"text-align : left;\"><input type=\"checkbox\" name=\"overwrite\" class=\"input\" value=\"true\" /></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Description:</td></tr>\n";
	if ($wysiwyg_editor ) {
		echo "<tr><td colspan=\"2\" style=\"padding-left : 55px;text-align : center;\">\n";
		echo "<script language=\"JavaScript\" type=\"text/javascript\">\n";
		echo "<!--\n";
		echo "initRTE('inc/cbrte/images/', 'inc/cbrte/', '', true);\n";
		echo "var rte1 = new richTextEditor('description');\n";
		$content = rteSafe($description);
		echo "rte1.html = '$content';\n";
		echo "rte1.width = 760;\n";
		echo "rte1.height = 300;\n";	
		echo "rte1.build();\n";
		echo "//-->\n";
		echo "</script>\n";
		echo "</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><span style=\"font-style : italic;font-size : 8pt;text-align : center;\">Click 'View source' and add &lt;START&gt;&lt;STOP&gt; tags to hide text/images from initial display</span></td></tr>\n";
	} else {
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><textarea class=\"input\" name=\"description\" cols=\"80\" rows=\"15\">" . stripslashes($description) . "</textarea></td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><span style=\"font-style : italic;font-size : 8pt;text-align : center;\">Add &lt;START&gt;&lt;STOP&gt; tags to hide text/images from initial display</span></td></tr>\n";
	}
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	if (!$massupload)
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"submit\" name=\"upload\" value=\"Update database\" class=\"button\" onclick=\"CollapseDiv('uploaddiv');ExpandDiv('throbberdiv');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	else
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"hidden\" name=\"massupload\" value=\"1\" /><input type=\"hidden\" name=\"addfile\" value=\"1\" /><input type=\"submit\" name=\"upload\" value=\"Add ".  count($_SESSION['ftpfiles']) ." new products uploaded by FTP\" class=\"button\" onclick=\"CollapseDiv('uploaddiv');ExpandDiv('throbberdiv');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	echo "</table></div>\n";
	echo "<div id=\"throbberdiv\" style=\"display: none\"><table class=\"contenttable\" style=\"width : 100%;height : 200px;\"><tr><td style=\"vertical-align : middle;text-align : center;\">\n";
	echo "<div id=\"alternativecontent\"><img src=\"3dgfx/throbber_blue.gif\" alt=\"throbber\" style=\"border : 0px;\" /></div>\n";
	echo "</td></tr><tr><td style=\"text-align : center;\">Please wait ...</td></tr></table></div>\n";
	html_footer();
	
} else if (isset($_REQUEST['showdigitalshop'])) {	

	// Show list with filenames in database
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	$find='';
        $selectedcategory='';
        if (isset($_REQUEST['categories'])) {
		$search=mysql_real_escape_string($_REQUEST['categories']);
		if ($search!='') {
			$find="WHERE category LIKE '%$search%' or subcat LIKE '%$search%'";
			$selectedcategory=$_REQUEST['categories'];
		}
	}
	$searcholdfile = '';
        if (isset($_REQUEST['searchfile']) && !isset($_REQUEST['productdetails'])) {
		$search=mysql_real_escape_string($_REQUEST['searchfile']);
		if ($search!='') {
			if ($find!='')
				$find.=" AND name LIKE '%$search%'";
			else
				$find="WHERE name LIKE '%$search%'";
			$searcholdfile=$_REQUEST['searchfile'];
		}
	}
	$offset=($_SESSION['start']-1)*$results_page_admin;
        if (isset($_REQUEST['productdetails']))
                echo "<tr><td style=\"width : 50px;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=id&amp;requirelogin=1\" style=\"font-weight : bold;\">ID</a></td><td style=\"width : 100%;font-weight : bold;text-align : left;\"><a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=name&amp;requirelogin=1\" style=\"font-weight : bold;\">Name</a> / <a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=category&amp;requirelogin=1\" style=\"font-weight : bold;\">Category</a></td><td style=\"width : 494px;font-weight : bold;text-align : left;\">Description</td><td style=\"width : 100px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=price&amp;requirelogin=1\" style=\"font-weight : bold;padding-right : 10px;\">Price $currency</a></td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
        else
                echo "<tr><td style=\"width : 50px;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=id&amp;requirelogin=1\" style=\"font-weight : bold;\">ID</a></td><td style=\"width : 100%;font-weight : bold;text-align : left;\"><a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=name&amp;requirelogin=1\" style=\"font-weight : bold;\">Name</a> / <a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=category&amp;requirelogin=1\" style=\"font-weight : bold;\">Category</a></td><td style=\"width : 344px;font-weight : bold;text-align : left;\">Description</td><td style=\"width : 100px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?showdigitalshop=1&amp;sort=price&amp;requirelogin=1\" style=\"font-weight : bold;padding-right : 10px;\">Price $currency</a></td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='price' && $_SESSION['sort']!='name' && $_SESSION['sort']!='id' && $_SESSION['sort']!='category') {$_SESSION['sort']='id';}
	if ($_SESSION['sort']=='price')
		$query="SELECT id, name, type, size, descr, price, rname, category, disc, title FROM digitalshop $find ORDER BY price + 0 " . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	else
		$query="SELECT id, name, type, size, descr, price, rname, category, disc, title FROM digitalshop $find ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);
	// Check if we have reached the last item (blank page), start again at last page
	while ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;
                $offset=($_SESSION['start']-1)*$results_page_admin;
		if ($_SESSION['sort']=='price')
			$query="SELECT id, name, type, size, descr, price, rname, category, disc, title FROM digitalshop $find ORDER BY price + 0 " . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		else		
			$query="SELECT id, name, type, size, descr, price, rname, category, disc, title  FROM digitalshop $find ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}
	if ($result && !mysql_num_rows($result)) {
		if (isset($_REQUEST['addfile'])) {
			echo "<tr><td colspan=\"4\" style=\"text-align : center;font-weight : bold;\">Congratulations, first file added!</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr><tr><td colspan=\"4\"><input type=\"button\" value=\"Continue\" class=\"button\" style=\"width : 90px;\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;showdigitalshop=1');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
		} else {
			echo "<tr><td colspan=\"4\" style=\"font-weight : bold;\">Digital shop is empty</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";	
		}
	} else if ($result) {
		while ($row=mysql_fetch_array($result)) {
                        if (isset($_REQUEST['productdetails'])) {
				if (strlen($row[name])>20)
					$filename=substr($row[name],0,20).'..';
				else
					$filename=$row[name];
                        } else {
				if (strlen($row[name])>40)
					$filename=substr($row[name],0,40).'..';
				else
					$filename=$row[name];
			}
			// Check statistics
			$downloads='None';$active_keys='None';$expired_keys='None';$customers='None';$unused='None';$revenue=0;$multiplier=0;
			$trailer=str_repeat('0',3-strlen($row[id])).$row[id];
			$query2="SELECT * FROM digitalshopkey WHERE fileid = '$row[id]' OR fileid REGEXP '^$trailer'";
			$result2=mysql_query($query2);
			if ($result2 && mysql_num_rows($result2)) {
				$customers=mysql_num_rows($result2);
				while ($row2=mysql_fetch_array($result2)) {
					$downloads=$downloads+$row2[cntr];
					if (time()<$row2[expire]) {$active_keys=$active_keys+1;}
					if ($row2[expire]!=0) {$expired_keys=$expired_keys+1;}
					if ($row2[expire]==0) {$unused=$unused+1;}
					if (strlen($row2[fileid])>4) {
						$multiplier=$multiplier+intval((strlen($row2[fileid])-3)/2);
					}
				}
			}
			if ($multiplier!=0) 
				$revenue=$row[price]*$multiplier;
			else
				$revenue=$row[price]*$customers;
			$category=$row[category];
			if ($row[title]=='')
				$title="-- no title specified -- <br /><br />";
			else
				$title=stripslashes($row[title]).'<br /><br />';
			if ($category=='') {$category='General';}
			if ($row[type]=='Directory') {$deletename='entire directory';} else {$deletename='product';}
			$filedate=time();
			if (file_exists($moveto.$row[rname])) {
				$filedate=filemtime($moveto.$row[rname]);
			}
			if (floatval($row[price])==0) {$zero='color : #FF0000;';} else {$zero='';}
			if (intval($row[disc])==0) {
				$discount_html='';
			} else if (intval($row[disc])==100) {
				$discount_html="<em>FREE</em><br /><br />";
				$row[price]='0.00';
			} else {
				$discount_html="Discount<br />" . number_format(floatval($row[disc]),0,'.',',') . "%<br /><br />";
				$row[price]=$row[price]-($row[price]*($row[disc]/100));
			}
			// Reduce text size
			if (isset($_REQUEST['productdetails'])) {
				$details=intval($_REQUEST['productdetails']);
			} else {
				$details='';
			}
			$productdescription=stripslashes(nl2br($row[descr]));
			if (strlen($productdescription)>$readmore && $details!=$row[id]) {
				$wrapped=wordwrap($productdescription,$readmore,'[cut]',1);
				$wrappedexploded=explode('[cut]',$wrapped);
				$productdescription=$wrappedexploded[0]."<a href=\"digitaladmin.php?requirelogin=1&amp;showdigitalshop=1&amp;start=" . $_SESSION['start'] . "&amp;productdetails=$row[id]\" title=\"$filename\"> <br /><br /><b>Expand</b></a>";
			}			
			
			// Check if file exists
			if (file_exists($moveto.$row[rname])) {$exists='';} else {$exists="<br /><span style=\"color : #FF0000;font-weight : bold;\">File/Directory has been deleted!</span>";}
                        if (isset($_REQUEST['productdetails']) && $_REQUEST['productdetails']==$row[id]) {
                                echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\">\n";
        			echo "<td style=\"vertical-align : top;font-weight : bold;text-align : left;padding-left : 10px;\">$row[id]</td>\n";
        			echo "<td style=\"vertical-align : top;text-align : left;\"><span style=\"font-weight : bold;\">$filename</span><br />" .  date ('F d Y H:i:s',$filedate) .
        			"<br /><a href=\"javascript: deleteid('$filename','digitaladmin.php?requirelogin=1&amp;removefileid=$row[id]&amp;showdigitalshop=1');\" title=\"delete\">delete $deletename</a><br /><br />Size: $row[size] bytes<br />Type: $row[type]<br />Customers: $customers<br />Downloads: $downloads<br />Active keys: $active_keys<br />Expired keys: $expired_keys<br />Unused keys: $unused<br />"
        			 . "Category: <b>$category</b></td><td style=\"vertical-align : top;text-align : left;\"><b>". $title . '</b>' . $productdescription . "<br /><br /><a href=\"digitaladmin.php?requirelogin=1&amp;edit=$row[id]\" title=\"edit\">edit</a><br />$exists</td>\n";
        			echo "<td style=\"vertical-align : top;text-align : right;padding-right : 10px;font-weight : bold;$zero\">". number_format(floatval($row[price]),2,'.',',') . "<br /><br />$discount_html<a href=\"digitaladmin.php?requirelogin=1&amp;edit=$row[id]\" title=\"edit\">edit</a><br /></td></tr>\n";
        			echo "<tr><td colspan=\"4\">&nbsp;</td></tr>";
                        } else {
				$title=strip_tags($title);
				if (strlen($title)>40)
					$title=substr($title,0,40).'..';
                                echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\">\n";
        			echo "<td style=\"vertical-align : top;font-weight : bold;text-align : left;padding-left : 10px;\">$row[id]</td>\n";
				if (!isset($_REQUEST['productdetails'])) 
					echo "<td style=\"vertical-align : top;text-align : left;\" nowrap=\"nowrap\"><a href=\"digitaladmin.php?requirelogin=1&amp;showdigitalshop=1&amp;start=" . $_SESSION['start'] . "&amp;productdetails=$row[id]&amp;categories=$selectedcategory\">$filename</a> <a href=\"javascript: editname('$row[name]','digitaladmin.php?requirelogin=1&amp;oldfilename=$row[name]&amp;editfilename=$row[id]&amp;showdigitalshop=1');\" title=\"edit\"><img src=\"shopgfx/edit.gif\" style=\"width : 14px;height : 14px;border : 0px;padding-left : 5px;\" alt=\"edit\" title=\"Edit name\" /></a></td>";
        			else
					echo "<td style=\"vertical-align : top;text-align : left;\" nowrap=\"nowrap\"><a href=\"digitaladmin.php?requirelogin=1&amp;showdigitalshop=1&amp;start=" . $_SESSION['start'] . "&amp;productdetails=$row[id]&amp;categories=$selectedcategory\">$filename</a> </td>";				
				echo "<td style=\"vertical-align : top;text-align : left;\">$title</td>\n";
        			echo "<td style=\"vertical-align : top;text-align : right;padding-right : 10px;font-weight : bold;$zero\">". number_format(floatval($row[price]),2,'.',',') . "</td></tr>\n";                                                            
                        }
		}
	}
	// Check for files uploaded by FTP
	if ($dir=opendir($moveto)) {
		$_SESSION['ftpfiles']=array();
		while ($file=readdir($dir)) {
			if ((strpos($file,'.')>0) && ($file!='.') && ($file!='..') && !is_dir($moveto.$file) && ($file!='.htaccess')) {
				$query="SELECT id, rname FROM digitalshop WHERE name = '" . mysql_real_escape_string($file) ."'";$result=mysql_query($query);
				if ($result && mysql_num_rows($result)) {$linktext='<span style="font-weight : bold;">update</span> file in shop';} else {$linktext='add to shop';}
				$_SESSION['ftpfiles'][]=$file;
				$filename=htmlentities($file);
				$size=filesize($moveto.$file);
				$type=filemimetype(strtolower(substr($file,strrpos($file,'.')+1,strlen($file))));
				echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"color : #FF0000;font-weight : bold;vertical-align : top;text-align : left;padding-left : 10px;\">new</td><td style=\"font-weight : bold;vertical-align : top;text-align : left;\">$file<br />Size: $size bytes<br />Type: $type</td><td style=\"vertical-align : top;text-align : left;\"><a href=\"digitaladmin.php?requirelogin=1&amp;addfile=$filename&amp;showdigitalshop=1\" title=\"add\">$linktext</a></td><td>&nbsp; </td></tr>\n";
			} else if (is_dir($moveto.$file) && ($file!='.') && ($file!='..') && strlen($file)<32) {
				$linktext='add directory to shop';
				$_SESSION['ftpfiles'][]=$file;
				$filename=htmlentities($file);
				$size=0;
				if ($dircollection=opendir($moveto.$file)) {
					while ($filecollection=readdir($dircollection)) {
						if (($filecollection!='.') && ($filecollection!='..') && ($filecollection!='.htaccess')) {
							$size=$size+filesize($moveto.$file.'/'.$filecollection);
						}
					}
					closedir($dircollection);
				}
				$type='Directory';
				echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"color : #FF0000;font-weight : bold;vertical-align : top;text-align : left;padding-left : 10px;\">new</td><td style=\"font-weight : bold;vertical-align : top;text-align : left;\">$file<br />Size: $size bytes<br />Type: $type</td><td style=\"vertical-align : top;text-align : left;\"><a href=\"digitaladmin.php?requirelogin=1&amp;addfile=$filename&amp;showdigitalshop=1\" title=\"add\">$linktext</a></td><td>&nbsp; </td></tr>\n";				
			}
		}
		closedir($dir);
	}		
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	// Divide shop content over multiple pages
	$query="SELECT id FROM digitalshop $find";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;showdigitalshop=1&amp;requirelogin=1&amp;categories=$selectedcategory&amp;searchfile=$searcholdfile\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;showdigitalshop=1&amp;requirelogin=1&amp;categories=$selectedcategory&amp;searchfile=$searcholdfile\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";
        // Display categories
        $querycat="SELECT DISTINCT category FROM digitalshop WHERE category!=''";$resultcat=mysql_query($querycat);$selectcategory='';
	if ($resultcat && mysql_num_rows($resultcat)) {
		$selectcategory="Filter by: <select name=\"categories\" class=\"input\" onchange=\"document.forms[0].submit();\">";
                if ($selectedcategory=='')
                        $selectcategory.="<option value=\"\" selected>All</option>";
                else
                        $selectcategory.="<option value=\"\">All</option>";
		while ($rowcat=mysql_fetch_array($resultcat)) {
			$cat=$rowcat[category];
			if ($cat!='') {
				if ($cat!=$selectedcategory) {$selectcategory.="<option value=\"$cat\">$cat</option>";} else {$selectcategory.="<option value=\"$cat\" selected>$cat</option>";}
			}
		}
		$querycat="SELECT DISTINCT subcat FROM digitalshop WHERE subcat!=''";$resultcat=mysql_query($querycat);
		if ($resultcat && mysql_num_rows($resultcat)) {
			while ($rowcat=mysql_fetch_array($resultcat)) {
				$cat=$rowcat[subcat];
				if ($cat!='') {
					if ($cat!=$selectedcategory) {$selectcategory.="<option value=\"$cat\">$cat</option>";} else {$selectcategory.="<option value=\"$cat\" selected>$cat</option>";}
				}
			}
		}
		$selectcategory.='</select>';
	}
	if (isset($_SESSION['ftpfiles']) && count($_SESSION['ftpfiles'])>2) {
		$massupload="<input type=\"button\" value=\"Add/update all new products at once\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&massupload=1');\" onmouseover=\"this.style.cursor='pointer'\" />";
	} else {
		$massupload='&nbsp;';
	}
	echo "<table width=\"100%\" class=\"contenttable\"><tr><td style=\"text-align : left;\"><input type=\"text\" name=\"searchfile\" class=\"input\" value=\"$searcholdfile\" /> <input type=\"submit\" name=\"findfile\" value=\"Find file\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td><td style=\"text-align : left;\">$massupload</td>\n";
	echo "<td style=\"text-align : right;\"><input type=\"hidden\" name=\"showdigitalshop\" value=\"1\" />$selectcategory</td></tr></table>\n";        
	html_footer();
	
} else if (isset($_REQUEST['showcustomers'])) {	
	
	// Show list with customers in database
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	if (isset($_REQUEST['search'])) {
		$search=mysql_real_escape_string($_REQUEST['search']);
		$find="WHERE digid LIKE '%$search%' OR email LIKE '%$search%' OR txnid LIKE '%$search%'";
                $results_page_admin=50;
	} else {
		$find='';
	}
	$offset=($_SESSION['start']-1)*$results_page_admin;	
	echo "<tr><td style=\"width : 160px;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?showcustomers=1&amp;sort=txnid&amp;requirelogin=1\" style=\"font-weight : bold;\">txn_id</a> &amp; <a href=\"digitaladmin.php?showcustomers=1&amp;sort=digid&amp;requirelogin=1\" style=\"font-weight : bold;\">key</a></td><td style=\"width : 244px;font-weight : bold;text-align : left;\"><a href=\"digitaladmin.php?showcustomers=1&amp;sort=email&amp;requirelogin=1\" style=\"font-weight : bold;\">Email address</a></td><td style=\"width : 200px;font-weight : bold;text-align : left;\">Product</td><td style=\"width : 80px;font-weight : bold;text-align : right;padding-right : 10px;\"><a href=\"digitaladmin.php?showcustomers=1&amp;sort=sold&amp;requirelogin=1\" style=\"font-weight : bold;\">Purchased</a></td><td style=\"width : 80px;font-weight : bold;text-align : right;padding-right : 10px;\"><a href=\"digitaladmin.php?showcustomers=1&amp;sort=country&amp;requirelogin=1\" style=\"font-weight : bold;\">Country</a></td><td style=\"width : 80px;font-weight : bold;text-align : right;padding-right : 10px;\">Expires</td></tr><tr><td colspan=\"5\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='txnid' && $_SESSION['sort']!='digid' && $_SESSION['sort']!='email' && $_SESSION['sort']!='sold' && $_SESSION['sort']!='country') {$_SESSION['sort']='txnid';}
	$query="SELECT * FROM digitalshopkey $find ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);$customers=true;
	// Check if we have reached the last item (blank page), start again at previous page
	if ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;$offset=($_SESSION['start']-1)*$results_page_admin;	
		$query="SELECT * FROM digitalshopkey $find ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}	
	if ($result && !mysql_num_rows($result)) {
                if (isset($_REQUEST['search']))
                         echo "<tr><td colspan=\"6\" style=\"font-weight : bold;text-align : center;\">Nothing found</td></tr>\n";	
                else
		         echo "<tr><td colspan=\"6\" style=\"font-weight : bold;text-align : center;\">No purchases have been registered</td></tr>\n";	
		$customers=false;
	} else if ($result) {
		while ($row=mysql_fetch_array($result)) {
			// Retrieve filename
			$filename="<span style=\"font-weight : bold;color : #FF0000;\">File not found!</span>";
			if (strlen($row[fileid])>4) {$multiplier='('.(strlen($row[fileid])-3)/2 . ')';$idcheck=intval(substr($row[fileid],0,3));} else {$multiplier='';$idcheck=$row[fileid];}
			$query2="SELECT * FROM digitalshop WHERE id = '$idcheck'";
			$result2=mysql_query($query2);
			if ($result2 && mysql_num_rows($result2)) {
				$row2=mysql_fetch_array($result2);
				$filename=wordwrap($row2[name],25,"<br />",true);
			}
			$expires='Expired';
			if (time()<$row[expire]) {
				$expires=ceil(($row[expire]-time())/3600) . '<br />hrs';
			}
			if ($row[expire]==0) {$expires='Unused';}
			if (intval($row[sold])==0) {
				$sold='--';
			} else {
				$sold=date('Y-m-d',$row[sold]);
			}
			if ($row[country]=='') {
				$country='--';
			} else {
				$country=$row[country];
			}
			if ($expires=='Expired') {$htmlcode="<br /><a href=\"javascript: reactivateid('$row[digid]','digitaladmin.php?requirelogin=1&amp;reactivateid=$row[digid]&amp;showcustomers=1');\" title=\"reactivate\">reactivate</a>";} else {$htmlcode='';}
			echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"vertical-align : top;text-align : left;padding-left : 10px;\">$row[txnid]<br />$row[digid]<br /></td><td style=\"vertical-align : top;text-align : left;\">" . wordwrap($row[email],30,"<br />",true) . "<a href=\"javascript: deletemail('$row[email]','digitaladmin.php?requirelogin=1&amp;deletemail=' + escape('$row[email]') + '&amp;showcustomers=1');\" title=\"delete\"> <img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"delete\" title=\"Delete all purchases/keys from this customer\" /><br /><a href=\"javascript: deleteid('$row[digid]','digitaladmin.php?requirelogin=1&amp;removedigid=$row[digid]&amp;showcustomers=1');\" title=\"delete\">delete key</a> / <a href=\"digitaladmin.php?requirelogin=1&amp;editcustomer=$row[id]\" title=\"edit\">edit address</a></td><td style=\"vertical-align : top;text-align : left;\">$filename $multiplier<br /><span style=\"font-weight : bold;\">$row[cntr]</span> downloads <a href=\"javascript: resetid('$row[digid]','digitaladmin.php?requirelogin=1&amp;resetid=$row[digid]&amp;showcustomers=1');\" title=\"reset\">reset</a><br /></td><td style=\"vertical-align : top;text-align : center;\">$sold</td><td style=\"vertical-align : top;text-align : center;\">$country</td><td style=\"vertical-align : top;text-align : right;padding-right : 10px;\">$expires$htmlcode</td></tr>\n";
		}
	}
	echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	// Divide content over multiple pages
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	$query="SELECT id FROM digitalshopkey";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1 && !isset($_REQUEST['search'])) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;showcustomers=1&amp;requirelogin=1\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;showcustomers=1&amp;requirelogin=1\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";	
	if ($customers || isset($_REQUEST['search'])) {
		echo "<table width=\"100%\"><tr><td colspan=\"2\">&nbsp;</td></tr><tr><td style=\"text-align : left;\"><input type=\"button\" name=\"downloadlist\" value=\"Download customer list\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;customerlist=1');\" onmouseover=\"this.style.cursor='pointer'\" /></td>\n";
		echo "<td style=\"text-align : right;\"><input type=\"hidden\" name=\"showcustomers\" value=\"1\" /><input type=\"text\" name=\"search\" class=\"input\" value=\"\" /> <input type=\"submit\" name=\"find\" value=\"Find txn_id, key or email\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr></table>\n";
	}
	html_footer();

} else if (isset($_REQUEST['editcustomer'])) {	
	
	// Edit customer
	html_header();
	echo "<table style=\"width : 100%;\">\n";
	$id=mysql_real_escape_string($_REQUEST['editcustomer']);
	$query="SELECT digid, email FROM digitalshopkey WHERE id = '$id'";
	$result=mysql_query($query);
	if ($result && mysql_num_rows($result)) {
		$row=mysql_fetch_array($result);
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;width : 50%;\">Customer ID:</td><td style=\"font-weight : bold;text-align : left;\">$id</td></tr>\n";
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;width : 50%;\">Email address:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"editemail\" size=\"24\" class=\"input\" value=\"$row[email]\" /></td></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr><tr><td colspan=\"2\"><input type=\"hidden\" name=\"showcustomers\" value=\"1\" /><input type=\"hidden\" name=\"customerid\" value=\"$id\" /><input type=\"submit\" name=\"updatecustomer\" value=\"Update Email address\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	} else {
		echo "<tr><td colspan=\"2\">No email address / customer found</td></tr>\n";
	}
	echo "</table>\n";
	html_footer();

} else if (isset($_REQUEST['createicons'])) {	
	
	// Create all icons
	html_header();
	echo "<table style=\"width : 100%;\">\n";
	$generated=0;
        $query="SELECT id, name, rname, type, size, descr, price, disc, title FROM digitalshop WHERE price > 0";
	$result=mysql_query($query);
        if ($result && !mysql_num_rows($result)) {
                echo "<tr><td colspan=\"2\" style=\"font-weight : bold;\">No products, no icons created</td></tr>\n";	
        } else if ($result) {
		$units=explode(' ','B KB MB GB TB PB');
                while ($row=mysql_fetch_array($result)) {
			$filesize=$row[size];
			for ($i=0;$filesize>1024;$i++) {$filesize=$filesize/1024;}
			$filesize=round($filesize,1).' '.$units[$i];
                        if ($row[disc]>0) 
                                $row[price]=$row[price]-($row[price]*($row[disc]/100));
			if ((!file_exists('gfx/' . $row[id] . '.png') && !file_exists('gfx/' . $row[id] . '.jpg') && !file_exists('gfx/' . $row[id] . '.gif'))) {
				createicon($row[name],$filesize,$row[id],$row[type]);
				$generated+=1;
                        }                               
			$price=number_format(floatval($row[price]),2,'.',',');
			if (!file_exists('gfx/' . $price . '.png')) {
				priceicon($price);
				$generated+=1;
			}
                }
        }
	if ($generated>0) {
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;\">$generated icons created.</td></tr>\n";
	} else {
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;\">No new icons created. Delete old icons first if you wish to recreate icons.</td></tr>\n";
	}
	echo "</table>\n";
	html_footer();

} else if (isset($_REQUEST['managecategories'])) {	
	
	// Manage categories
	html_header();
	echo "<table style=\"width : 100%;\">\n";
	echo "<tr><td colspan=\"4\">&nbsp;<input type=\"hidden\" name=\"oldname\" value=\"\" /><input type=\"hidden\" name=\"newname\" value=\"\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;\">Category name</td><td style=\"font-weight : bold;text-align : center;\">Category Relation</td><td style=\"font-weight : bold;\">Edit</td><td style=\"font-weight : bold;text-align : left;\">Delete</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	$querycat="SELECT DISTINCT category FROM digitalshop WHERE category !=''";
	$resultcat=mysql_query($querycat);
	if ($resultcat && mysql_num_rows($resultcat)) {
		while ($resultcat && $rowcat=mysql_fetch_array($resultcat)) {
			$querycat2="SELECT category FROM digitalshop WHERE category ='$rowcat[category]' AND subcat != ''";
			$resultcat2=mysql_query($querycat2);
			if ($resultcat2 && mysql_num_rows($resultcat2)) {
				echo "<tr><td style=\"text-align : right;\">$rowcat[category]</td><td style=\"text-align : center;\">Main category</td><td><a href=\"javascript: editcategory('$rowcat[category]','digitaladmin.php?requirelogin=1&amp;editcategory=$rowcat[category]&amp;managecategories=1');\" title=\"edit\"><img src=\"shopgfx/edit.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"edit\" title=\"Edit main category\" /></a></td><td style=\"text-align : left;\">Delete subcategory first</a></td></tr>\n";
			} else {
				echo "<tr><td style=\"text-align : right;\">$rowcat[category]</td><td style=\"text-align : center;\">Main category</td><td><a href=\"javascript: editcategory('$rowcat[category]','digitaladmin.php?requirelogin=1&amp;editcategory=$rowcat[category]&amp;managecategories=1');\" title=\"edit\"><img src=\"shopgfx/edit.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"edit\" title=\"Edit main category\" /></a></td><td style=\"text-align : left;\"><a href=\"javascript: deleteid('$rowcat[category]','digitaladmin.php?requirelogin=1&amp;deletecategory=' + escape('$rowcat[category]') + '&amp;managecategories=1');\" title=\"delete\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"delete\" title=\"Delete main category\" /></a></td></tr>\n";			
			}
		}
	}
	$querycat="SELECT DISTINCT subcat FROM digitalshop WHERE subcat !=''";
	$resultcat=mysql_query($querycat);
	if ($resultcat && mysql_num_rows($resultcat)) {
		while ($resultcat && $rowcat=mysql_fetch_array($resultcat)) {
			$querycat2="SELECT category FROM digitalshop WHERE subcat ='$rowcat[subcat]'";
			$resultcat2=mysql_query($querycat2);
			if ($resultcat2 && mysql_num_rows($resultcat2)) {
				$rowcat2=mysql_fetch_array($resultcat2);
				echo "<tr><td style=\"text-align : right;\">$rowcat[subcat]</td><td style=\"text-align : center;\">Sub category of <em>$rowcat2[category]</em></td><td><a href=\"javascript: editcategory('$rowcat[subcat]','digitaladmin.php?requirelogin=1&amp;editcategory=$rowcat[subcat]&amp;managecategories=1');\" title=\"edit\"><img src=\"shopgfx/edit.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"edit\" title=\"Edit subcategory\" /></a></td><td style=\"text-align : left;\"><a href=\"javascript: deleteid('$rowcat[subcat]','digitaladmin.php?requirelogin=1&amp;deletecategory=' + escape('$rowcat[subcat]') +'&amp;managecategories=1');\" title=\"edit\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"delete\" title=\"Delete subcategory\" /></a></td></tr>\n";
			} else {
				echo "<tr><td style=\"text-align : right;\">$rowcat[subcat]</td><td style=\"text-align : center;\">Sub category</td><td><a href=\"javascript: editcategory('$rowcat[subcat]','digitaladmin.php?requirelogin=1&amp;editcategory=$rowcat[subcat]&amp;managecategories=1');\" title=\"edit\"><img src=\"shopgfx/edit.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"edit\" title=\"Edit subcategory\" /></a></td><td style=\"text-align : left;\"><a href=\"javascript: deleteid('$rowcat[subcat]','digitaladmin.php?requirelogin=1&amp;deletecategory=' + escape('$rowcat[subcat]') +'&amp;managecategories=1');\" title=\"edit\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;\" alt=\"delete\" title=\"Delete subcategory\" /></a></td></tr>\n";
			}
		}
	}
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	echo "<tr><td colspan=\"4\" style=\"font-size : 9px;\">Note: Create new (sub)categories by editing the product details (click menu option: Storage).</td></tr>\n";
	echo "</table>\n";
	html_footer();

} else if (isset($_REQUEST['affiliate'])) {	

	// Show affiliates and commission overview
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	$offset=($_SESSION['start']-1)*$results_page_admin;	
	echo "<tr><td colspan=\"5\" style=\"font-weight : bold;text-align : center;\">Affiliate Commission Overview</td></tr>\n";
	echo "<tr><td colspan=\"5\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"width : 134px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?affiliate=1&amp;sort=aid&amp;requirelogin=1\" style=\"font-weight : bold;\">AID code</a></td><td style=\"width : 350px;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?affiliate=1&amp;sort=emailpay&amp;requirelogin=1\" style=\"font-weight : bold;\">Email / Online bank</a></td><td style=\"width : 150px;font-weight : bold;text-align : right;\">Due $currency</td><td style=\"width : 150px;font-weight : bold;text-align : right;\">Paid $currency</td><td style=\"width : 160px;font-weight : bold;text-align : right;padding-right: 60px;\">Referrals</td></tr><tr><td colspan=\"5\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='emailpay' && $_SESSION['sort']!='aid') {$_SESSION['sort']='aid';}
	$query="SELECT id, aid, emailpay, hits, bank FROM digitalshopaffiliate ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);$downloadlist=true;
	// Check if we have reached the last item (blank page), start again at previous page
	if ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;$offset=($_SESSION['start']-1)*$results_page_admin;	
		$query="SELECT id, aid, emailpay, hits, bank FROM digitalshopaffiliate ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}
	if ($result && !mysql_num_rows($result)) {
		echo "<tr><td colspan=\"5\" style=\"font-weight : bold;\">No affiliates registered.</td></tr><tr><td colspan=\"5\">&nbsp;</td></tr>\n";	
		$downloadlist=false;
	} else if ($result) {
		while ($result && $row=mysql_fetch_array($result)) {
			$credit=0;
			$debet=0;
			$query="SELECT SUM(credit + 0) as spaid FROM digitalshopcommission WHERE aid = '$row[aid]'";
			$result2=mysql_query($query);
			if ($result2 && mysql_num_rows($result2)) {
				$row2=mysql_fetch_array($result2);
				$credit=$row2[spaid];
			}
			$query="SELECT SUM(debet + 0) as spaid FROM digitalshopcommission WHERE aid = '$row[aid]'";
			$result2=mysql_query($query);
			if ($result2 && mysql_num_rows($result2)) {
				$row2=mysql_fetch_array($result2);
				$debet=$row2[spaid];
			}			
			if ($credit>($debet+$commission)) {
				$paygreen='color : #339900;font-weight : bold;';
				$payred='color : #FF3300;font-weight : bold;';
			} else {
				$paygreen='';
				$payred='';			
			}
			$credit=number_format(floatval($credit),2,'.',',');
			$debet=number_format(floatval($debet),2,'.',',');
			echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\">\n";
			echo "<td style=\"vertical-align : top;font-weight : bold;text-align : right;\">A$row[aid] <a href=\"javascript: deleteid('AID: A$row[aid] ($row[emailpay])','digitaladmin.php?requirelogin=1&amp;affiliate=1&amp;removeaffiliate=$row[id]&amp;aid=$row[aid]');\" title=\"delete\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;padding-left : 5px;\" alt=\"delete\" title=\"Delete affiliate\" /></a></td>\n";
			echo "<td style=\"vertical-align : top;text-align : left;padding-left : 10px;\">$row[emailpay]<br />($row[bank]) <a href=\"digitaladmin.php?requirelogin=1&amp;editaffiliate=$row[id]\" title=\"add commission payment\">Add payment</a></td>\n";
                        echo "<td style=\"vertical-align : top;text-align : right;$paygreen\">$credit</td>\n";
			echo "<td style=\"vertical-align : top;text-align : right;$payred\">$debet</td>\n";
			echo "<td style=\"vertical-align : top;text-align : right;padding-right : 60px;\">$row[hits]</td></tr>\n";
		}
	}		
	echo "<tr><td colspan=\"5\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	// Divide shop content over multiple pages
	$query="SELECT id FROM digitalshopaffiliate";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;affiliate=1&amp;requirelogin=1\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;affiliate=1&amp;requirelogin=1\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";	
	if ($downloadlist) {
		$credit=0;
		$debet=0;
		$query="SELECT SUM(credit + 0) as spaid FROM digitalshopcommission";
		$result2=mysql_query($query);
		if ($result2 && mysql_num_rows($result2)) {
			$row2=mysql_fetch_array($result2);
			$credit=$row2[spaid];
		}
		$query="SELECT SUM(debet + 0) as spaid FROM digitalshopcommission";
		$result2=mysql_query($query);
		if ($result2 && mysql_num_rows($result2)) {
			$row2=mysql_fetch_array($result2);
			$debet=$row2[spaid];
		}
		$credit=number_format(floatval($credit),2,'.',',');
		$debet=number_format(floatval($debet),2,'.',',');
		$balance=number_format(floatval(($credit-$debet)),2,'.',',');
		echo "<table width=\"100%\"><tr><td colspan=\"2\">&nbsp;</td></tr><tr><td style=\"text-align : left;\"><input type=\"button\" name=\"downloadlist\" value=\"Download commission list\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;customerlist=3');\" onmouseover=\"this.style.cursor='pointer'\" /></td>\n";
		echo "<td style=\"text-align : right;font-size : 10px;\"><input type=\"hidden\" name=\"revenue\" value=\"1\" />Total due: $credit $currency / Total paid: $debet $currency / Balance: $balance $currency</td></tr></table>\n";
	}	
	html_footer();
	
} else if (isset($_REQUEST['bank'])) {	

	// Show bank payments overview
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	if ($bank_transfer_msg!='') {
		echo "<tr><td colspan=\"6\" style=\"font-weight : bold;text-align : center;color : #FF0000;\">$bank_transfer_msg</td></tr>\n";
		echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";	
	}
	$offset=($_SESSION['start']-1)*$results_page_admin;	
	echo "<tr><td colspan=\"6\" style=\"font-weight : bold;text-align : center;\">Bank Transfer overview (pending orders)</td></tr>\n";
	echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"width : 250px;font-weight : bold;text-align : left;\"><a href=\"digitaladmin.php?bank=1&amp;sort=email&amp;requirelogin=1\" style=\"font-weight : bold;\">Email</a></td><td style=\"width : 170px;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?bank=1&amp;sort=invoice&amp;requirelogin=1\" style=\"font-weight : bold;\">Invoice Number</a></td><td style=\"width : 130px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?bank=1&amp;sort=price&amp;requirelogin=1\" style=\"font-weight : bold;\">Amount $currency</a></td><td style=\"width : 150px;font-weight : bold;text-align : center;\">Ordercode</td><td style=\"width : 80px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?bank=1&amp;sort=country&amp;requirelogin=1\" style=\"font-weight : bold;\">Country</a></td><td style=\"width : 100px;font-weight : bold;text-align : right;\">Action</td></tr><tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='email' && $_SESSION['sort']!='invoice' && $_SESSION['sort']!='country' && $_SESSION['sort']!='price') {$_SESSION['sort']='email';}
	$query="SELECT * FROM digitalshoptransfer ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);
	// Check if we have reached the last item (blank page), start again at previous page
	if ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;$offset=($_SESSION['start']-1)*$results_page_admin;	
		$query="SELECT * FROM digitalshoptransfer ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}
	if ($result && !mysql_num_rows($result)) {
		echo "<tr><td colspan=\"6\" style=\"font-weight : bold;\">No bank transfers registered.</td></tr><tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	} else if ($result) {
		while ($result && $row=mysql_fetch_array($result)) {
			echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\">\n";
			echo "<td style=\"vertical-align : top;font-weight : bold;text-align : left;\">$row[email] <a href=\"javascript: deleteid('Bank transfer from $row[email] ($row[ordercode])','digitaladmin.php?requirelogin=1&amp;bank=1&amp;removetransfer=1&amp;id=$row[id]');\" title=\"delete\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;padding-left : 5px;\" alt=\"delete\" title=\"Delete this bank transfer\" /></a></td>\n";
			echo "<td style=\"vertical-align : top;text-align : left;padding-left : 10px;\">$row[invoice]<br />".  date("m.d.y - g:i a", substr($row[invoice],3)) . "</td>\n";
                        echo "<td style=\"vertical-align : top;text-align : right;\">". number_format(floatval($row[price]),2,'.',',') . "</td>\n";
			echo "<td style=\"vertical-align : top;text-align : center;\">$row[ordercode]</td>\n";
			echo "<td style=\"vertical-align : top;text-align : center;\">$row[country]</td>\n";
			echo "<td style=\"vertical-align : top;text-align : right;\"><a href=\"digitaladmin.php?bank=1&amp;process=$row[id]&amp;requirelogin=1\">Process</a></td></tr>\n";
		}
	}		
	echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	// Divide shop content over multiple pages
	$query="SELECT id FROM digitalshopaffiliate";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;affiliate=1&amp;requirelogin=1\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;affiliate=1&amp;requirelogin=1\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";	
	html_footer();

} else if (isset($_REQUEST['editaffiliate'])) {	
	
	// Edit affiliate
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	$id=intval($_REQUEST['editaffiliate']);
	$query="SELECT aid, emailpay FROM digitalshopaffiliate WHERE id = '$id'";
	$result=mysql_query($query);
	if ($result && mysql_num_rows($result)) {
		$row=mysql_fetch_array($result);
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;width : 50%;\">Affiliate ID:</td><td style=\"text-align : left;\">$row[aid]</td></tr>\n";
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;width : 50%;\">Affiliate payment email address/bank details:</td><td style=\"text-align : left;\">$row[emailpay]</td></tr>\n";
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Transaction ID:</td><td style=\"font-size : 10px;text-align : left;\"><input type=\"text\" name=\"txn_id\" class=\"input\" maxlength=\"17\" value=\"" . time() . "\" /> (or use the transaction ID)</td></tr>\n";
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;width : 50%;\">Payment:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"paid\" class=\"input\" size=\"6\" value=\"$commission\" /> $currency</td></tr>\n";
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;width : 50%;\">Paid on (date YYYY-MM-DD):</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"stamp\" size=\"12\" maxlength=\"10\" class=\"input\" value=\"" . date("Y-m-d") . "\" /> </td></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr><tr><td colspan=\"2\" style=\"font-size : 10px;text-align : center;\">Note:<br />A positive payment reflects paid commission (by you) to the affiliate<br />A negative payment is an extra commission for the affiliate<br />The <b>real</b> payment needs to be made in PayPal/Moneybookers or by Bank transfer.</td></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr><tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"hidden\" name=\"affiliate\" value=\"1\" /><input type=\"hidden\" name=\"affiliateid\" value=\"$id\" /><input type=\"submit\" name=\"updateaffiliate\" value=\"Add Payment\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	} else {
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\">No affiliate found</td></tr>\n";
	}
	echo "</table>\n";
	html_footer();


} else if (isset($_REQUEST['revenue'])) {	

	// Show products and revenue
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	$offset=($_SESSION['start']-1)*$results_page_admin;	
	echo "<tr><td style=\"width : 34px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?revenue=1&amp;sort=id&amp;requirelogin=1\" style=\"font-weight : bold;\">ID</a></td><td style=\"width : 100%;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?revenue=1&amp;sort=name&amp;requirelogin=1\" style=\"font-weight : bold;\">Name</a></td><td style=\"width : 50px;font-weight : bold;text-align : left;padding-left : 10px;\">Customers</td><td style=\"width : 150px;font-weight : bold;text-align : right;\">Revenue $currency</td><td style=\"width : 210px;font-weight : bold;text-align : right;padding-right : 100px;\">Fees $currency</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='name' && $_SESSION['sort']!='id') {$_SESSION['sort']='id';}
	$query="SELECT id, name FROM digitalshop ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);$downloadlist=true;
	// Check if we have reached the last item (blank page), start again at previous page
	if ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;$offset=($_SESSION['start']-1)*$results_page_admin;	
		$query="SELECT id, name FROM digitalshop ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}
	if ($result && !mysql_num_rows($result)) {
		echo "<tr><td colspan=\"4\" style=\"font-weight : bold;\">Digital shop is empty</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";	
		$downloadlist=false;
	} else if ($result) {
		while ($row=mysql_fetch_array($result)) {
			$revenue=0;$fees=0;
			$filename=$row[name];
			if (strlen($filename)>40)
				$filename=substr($filename,0,40).'..';
			$trailer=str_repeat('0',3-strlen($row[id])).$row[id];
			$query2="SELECT fileid, gross, fee FROM digitalshopkey WHERE fileid = '$row[id]' OR fileid REGEXP '^$trailer'";
			$result2=mysql_query($query2);$units=0;
			if ($result2 && mysql_num_rows($result2)) {
				$units=mysql_num_rows($result2);
				while ($row2=mysql_fetch_array($result2)) {
					$revenue=$revenue+floatval($row2[gross]);
					$fees=$fees+floatval($row2[fee]);
				}
				$revenue=number_format(floatval($revenue),2,'.',',');
				$fees=number_format(floatval($fees),2,'.',',');				
			} else {
				$revenue='0.00';
                                $fees='0.00';
			}
			echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\">\n";
			echo "<td style=\"vertical-align : top;font-weight : bold;text-align : right;\">$row[id]</td>\n";
			echo "<td style=\"vertical-align : top;text-align : left;padding-left : 10px;\">$filename</td>\n";
			echo "<td style=\"vertical-align : top;text-align : center;padding-left : 10px;\">$units</td>\n";
                        echo "<td style=\"vertical-align : top;text-align : right;\">$revenue</td>\n";
			echo "<td style=\"vertical-align : top;text-align : right;padding-right : 100px;\">$fees</td></tr>\n";
		}
	}		
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	// Divide shop content over multiple pages
	$query="SELECT id FROM digitalshop";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;revenue=1&amp;requirelogin=1\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;revenue=1&amp;requirelogin=1\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";	
	if ($downloadlist) {
		$credit=0;
		$debet=0;
		$query="SELECT SUM(gross + 0) as sgross, SUM(fee + 0) as sfee FROM digitalshopkey";
		$result=mysql_query($query);
		if ($result && mysql_num_rows($result)) {
			$row=mysql_fetch_array($result);
			$credit=$row[sgross];
			$debet=$row[sfee];
		}
		$credit=number_format(floatval($credit),2,'.',',');
		$debet=number_format(floatval($debet),2,'.',',');	
		echo "<table width=\"100%\"><tr><td colspan=\"2\">&nbsp;</td></tr><tr><td style=\"text-align : left;\"><input type=\"button\" name=\"downloadlist\" value=\"Download transaction list\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;customerlist=2');\" onmouseover=\"this.style.cursor='pointer'\" /></td>\n";
		echo "<td style=\"text-align : right;font-size : 10px;\"><input type=\"hidden\" name=\"revenue\" value=\"1\" />Total revenue: $credit $currency / Total fees: $debet $currency</td></tr></table>\n";
	}	
	html_footer();

} else if (isset($_REQUEST['ratings'])) {	

	// Show products with rating in database
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	$offset=($_SESSION['start']-1)*$results_page_admin;	
	echo "<tr><td style=\"width : 134px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?ratings=1&amp;sort=id&amp;requirelogin=1\" style=\"font-weight : bold;\">ID</a></td><td style=\"width : 300px;font-weight : bold;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?ratings=1&amp;sort=name&amp;requirelogin=1\" style=\"font-weight : bold;\">Name</a></td><td style=\"width : 200px;font-weight : bold;text-align : left;\">Current rating</td><td style=\"width : 210px;font-weight : bold;text-align : left;padding-left : 10px;\">Adjust rating</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='name' && $_SESSION['sort']!='id') {$_SESSION['sort']='id';}
	$query="SELECT id, name FROM digitalshop ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);
	// Check if we have reached the last item (blank page), start again at previous page
	if ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;$offset=($_SESSION['start']-1)*$results_page_admin;	
		$query="SELECT id, name FROM digitalshop ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}
	if ($result && !mysql_num_rows($result)) {
		echo "<tr><td colspan=\"4\" style=\"font-weight : bold;\">Digital shop is empty</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";	
	} else if ($result) {
		while ($row=mysql_fetch_array($result)) {
			$filename=htmlentities($row[name]);
			$queryrating="SELECT COUNT(id) as votes, SUM(vote) AS rating FROM digitalshoprating WHERE prodid = '$row[id]'";
			$resultrating=mysql_query($queryrating);
			if ($resultrating && mysql_num_rows($resultrating)) {
				$rowrating=mysql_fetch_array($resultrating);
				$votes=$rowrating[votes];
                                if ($votes>0)
                                        $stars=round($rowrating[rating]/$votes);
                                else
                                        $stars=0;                                
			} else {
				$stars=0;
                                $votes=0;
			}
			$rating="<div class=\"footer\" style=\"width : 100%;text-align : left;\">";
			for ($i=1;$i<=5;$i++) {
				if ($i<=$stars)
					$rating=$rating."<img src=\"shopgfx/stargoldsmall.png\" title=\"\" alt=\"\" style=\"border : 0px;\" />";
				if ($i>$stars)
					$rating=$rating."<img src=\"shopgfx/stargreysmall.png\" title=\"\" alt=\"\" style=\"border : 0px;\" />";
			}
			$rating.="<span style=\"padding-left : 30px;\">$votes $lang_94</span></div></form>";
			echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\">\n";
			echo "<td style=\"vertical-align : top;font-weight : bold;text-align : right;\">$row[id]</td>\n";
			echo "<td style=\"vertical-align : top;text-align : left;padding-left : 10px;\" nowrap=\"nowrap\"><a href=\"digitaladmin.php?requirelogin=1&showdigitalshop=1&productdetails=$row[id]\">$filename</a></td>\n";
                        echo "<td style=\"vertical-align : top;text-align : right;\">$rating</td>\n";
			echo "<td style=\"vertical-align : top;text-align : left;padding-left : 10px;\"><a href=\"digitaladmin.php?ratings=1&amp;increase=$row[id]&amp;requirelogin=1\"><img src=\"shopgfx/increase.png\" title=\"Increase with 1 star\" alt=\"\" style=\"border : 0px;padding-right : 10px;\" /><a href=\"digitaladmin.php?ratings=1&amp;decrease=$row[id]&amp;requirelogin=1\"><img src=\"shopgfx/decrease.png\" title=\"Decrease with 1 star\" alt=\"\" style=\"border : 0px;padding-left : 10px;\" /></td></tr>\n";
		}
	}		
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	// Divide shop content over multiple pages
	$query="SELECT id FROM digitalshop";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;ratings=1&amp;requirelogin=1\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;ratings=1&amp;requirelogin=1\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";	
	html_footer();

} else if (isset($_REQUEST['access'])) {	

        // Check for blocked IP's
	$query="SELECT * FROM digitalshopaccess";
	$result=mysql_query($query);
        if ($result && mysql_num_rows($result)) {
        	while ($row=mysql_fetch_array($result)) {
			if (($row[expire]-time())<0) {
				// Blocked access has expired
				$query2="DELETE FROM digitalshopaccess WHERE id = '$row[id]'";
				$result2=mysql_query($query2);	
			}
		}
        }
	// Show list with blocked ip's
	html_header();
	echo "<table class=\"contenttable\">\n";
        echo "<tr><td style=\"width : 244px;font-weight : bold;text-align : right;\">ID</td><td style=\"width : 200px;font-weight : bold;text-align : right;\">Hostname</td><td style=\"width : 200px;font-weight : bold;text-align : right;\">Expires in</td><td style=\"width : 200px;font-weight : bold;\">&nbsp;</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
		$query="SELECT * FROM digitalshopaccess ORDER BY id";
		$result=mysql_query($query);
		if ($result && !mysql_num_rows($result)) {
			echo "<tr><td colspan=\"4\" style=\"font-weight : bold;text-align : center;\">No blocked IP's</td></tr>\n";	
		} else if ($result) {
			while ($row=mysql_fetch_array($result)) {
				if ($row[expire]==2147483647)
					$expire='<b>blocked</b>';
				else
					$expire=ceil(($row[expire]-time())/60) . ' minutes';
				if ($row[cntr]>=2)
					echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"vertical-align : top;text-align : right;\">$row[id]</td><td style=\"vertical-align : top;text-align : right;\">$row[ip]</td><td style=\"vertical-align : top;text-align : right;\">$expire</td><td style=\"vertical-align : top;\"><a href=\"javascript: deleteid('ID $row[id]','digitaladmin.php?requirelogin=1&amp;removeip=$row[id]&amp;access=1');\" title=\"delete\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;padding-left : 5px;\" alt=\"delete\" title=\"Delete IP\" /></a></td></tr>\n";
			}
			echo "<tr><td colspan=\"4\">&nbsp;</td></tr>";
		}
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>";
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>";
	echo "<tr><td style=\"vertical-align : top;text-align : right;font-weight : bold;\">Block (ban) from shop:</td><td style=\"vertical-align : top;text-align : center;\"><input type=\"text\" name=\"blockip\" style=\"text-align : right;\" size=\"15\" class=\"input\" value=\"0.0.0.0\" /></td><td style=\"vertical-align : top;text-align : left;\"><input type=\"submit\" name=\"newblock\" value=\"Block\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /><input type=\"hidden\" name=\"access\" value=\"1\" /></td><td>&nbsp;</td></tr>\n";	
	echo "<tr><td colspan=\"4\">&nbsp;</td></tr>";
	echo "</table>\n";
	html_footer();

} else if (isset($_REQUEST['coupon'])) {	

	// Show list with coupons in database
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	$offset=($_SESSION['start']-1)*$results_page_admin;	
	echo "<tr><td style=\"width : 144px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?coupon=1&amp;sort=coupon&amp;requirelogin=1\" style=\"font-weight : bold;\">Coupon code</a></td><td style=\"width : 140px;font-weight : bold;text-align : right;\">Value $currency</td><td style=\"width : 140px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?coupon=1&amp;sort=expire&amp;requirelogin=1\" style=\"font-weight : bold;\">Expires in</a></td><td style=\"width : 140px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?coupon=1&amp;sort=cntr&amp;requirelogin=1\" style=\"font-weight : bold;\">Used</a></td><td style=\"width : 140px;font-weight : bold;text-align : right;\"><a href=\"digitaladmin.php?coupon=1&amp;sort=
	cntr&amp;requirelogin=1\" style=\"font-weight : bold;\">Maximum</a></td><td style=\"width : 140px;font-weight : bold;text-align : right;\">&nbsp;</td></tr><tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	if ($_SESSION['sort']!='expire' && $_SESSION['sort']!='cntr' && $_SESSION['sort']!='maxcntr' && $_SESSION['sort']!='coupon') {$_SESSION['sort']='expire';}
	$query="SELECT * FROM digitalshopcoupon ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
	$result=mysql_query($query);
	// Check if we have reached the last item (blank page), start again at previous page
	if ($result && !mysql_num_rows($result) && $_SESSION['start']>0) {
		$_SESSION['start']=$_SESSION['start']-1;$offset=($_SESSION['start']-1)*$results_page_admin;	
		$query="SELECT * FROM digitalshopcoupon ORDER BY " . mysql_real_escape_string($_SESSION['sort']) . ' ' . mysql_real_escape_string($_SESSION['sortorder']) . " LIMIT $offset,$results_page_admin";
		$result=mysql_query($query);
	}	
	if ($result && !mysql_num_rows($result)) {
		echo "<tr><td colspan=\"6\" style=\"font-weight : bold;\">No coupons are active</td></tr>\n";	
	} else if ($result) {
		while ($row=mysql_fetch_array($result)) {
			$expires='Expired';
			if (time()<$row[expire]) {
				$expires=ceil(($row[expire]-time())/3600) . ' hrs';
			}
			echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"vertical-align : top;text-align : right;\"><a href=\"#\" onclick=\"window.open('$shopurl/shopgfx/coupons/$row[coupon].png','Coupon $row[coupon]','menubar=0,resizable=0,width=550,height=350');\" >$row[coupon]<a/></td><td style=\"vertical-align : top;text-align : right;\">" . trim($row[value],'-') ."</td><td style=\"vertical-align : top;text-align : right;\">$expires</td><td style=\"vertical-align : top;text-align : right;\">$row[cntr]</td><td style=\"vertical-align : top;text-align : right;\">$row[maxcntr]</td><td style=\"vertical-align : top;text-align : left;\"><a href=\"javascript: deleteid('$row[coupon]','digitaladmin.php?requirelogin=1&amp;removecoupon=$row[coupon]&amp;coupon=1');\" title=\"delete\"><img src=\"shopgfx/delete.gif\" style=\"width : 14px;height : 14px;border : 0px;padding-left : 15px;\" alt=\"delete\" title=\"Delete coupon\" /></a></td></tr>\n";
		}
	}
	echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"vertical-align : top;text-align : right;font-weight : bold;\">New coupon:</td><td style=\"vertical-align : top;text-align : right;\"><input type=\"text\" name=\"value\" style=\"text-align : right;\" size=\"6\" class=\"input\" value=\"0.00\" /> $currency</td><td style=\"vertical-align : top;text-align : right;\"><input type=\"text\" name=\"expire\" style=\"text-align : right;\" size=\"4\" class=\"input\" value=\"240\" /> hrs</td><td style=\"vertical-align : top;text-align : right;\">Valid for:</td><td style=\"vertical-align : top;text-align : left;\"><input type=\"text\" name=\"maxcntr\" size=\"3\" style=\"text-align : center;\" class=\"input\" value=\"1\" /> purchase(s)</td><td style=\"vertical-align : top;text-align : right;\"><input type=\"hidden\" name=\"coupon\" value=\"1\" /><input type=\"submit\" name=\"newcoupon\" value=\"Add\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "<tr><td colspan=\"6\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	// Divide content over multiple pages
	echo "<table class=\"contenttable\" width=\"100%\"><tr><td style=\"text-align : center;\">\n";
	$query="SELECT id FROM digitalshopcoupon";
	$result=mysql_query($query);
	if ($result)
		$rows=mysql_num_rows($result);
	else
		$rows=0;
	$pages=ceil($rows/$results_page_admin);
	if ($pages>1 && !isset($_REQUEST['search'])) {
		echo "Page: ";
		for($page=1;$page<=$pages;$page++) {
		if ($_SESSION['start']==$page)
			echo "<a href=\"digitaladmin.php?start=$page&amp;coupon=1&amp;requirelogin=1\" style=\"text-decoration : underline;\">$page</a> ";
		else
			echo "<a href=\"digitaladmin.php?start=$page&amp;coupon=1&amp;requirelogin=1\">$page</a> ";
		}
	}
	echo "</td></tr></table>\n";
	html_footer();

} else if (isset($_REQUEST['albumconfig'])) {	

	// Show list with directories in data dir
	html_header();
	echo "<div id=\"dirdiv\"><table class=\"contenttable\" style=\"width : 100%;\">\n";
	if (isset($_REQUEST['enablealbum'])) {
		echo "<tr><td colspan=\"4\" style=\"font-weight : bold;\">Changes saved</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
		echo "<tr><td colspan=\"4\"><input type=\"button\" value=\"Continue\" class=\"button\" style=\"width : 90px;\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;albumconfig=1');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	} else {
		echo "<tr><td style=\"width : 244px;font-weight : bold;text-align : left;padding-left : 10px;\">Directory</td><td style=\"width : 200px;font-weight : bold;\">Enable album feature*</td><td style=\"width : 200px;font-weight : bold;\">Watermark photo</td><td style=\"width : 200px;font-weight : bold;padding-right : 10px;\">18+ content</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
		$query="SELECT id, name, type, size, descr, price, rname, category FROM digitalshop WHERE type = 'Directory' ORDER BY id";
		$result=mysql_query($query);
		if ($result && !mysql_num_rows($result)) {
			echo "<tr><td colspan=\"4\" style=\"font-weight : bold;\">Digital shop has no album directories</td></tr>\n";	
		} else if ($result) {
			while ($row=mysql_fetch_array($result)) {	
				if (file_exists($moveto.$row[rname].'/photoalbum.php') || file_exists($moveto.$row[rname].'/mp3album.php')) {$checked='checked="checked"';$disabled='';} else {$checked='';$disabled='disabled';}
				if (file_exists($moveto.$row[rname].'/xxx.php')) {$checkedxxx='checked="checked"';} else {$checkedxxx='';}
				echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"vertical-align : top;text-align : left;padding-left : 10px;\">$row[name]</td><td style=\"vertical-align : top;\"><input type=\"checkbox\" name=\"album_$row[id]\" value=\"true\" class=\"input\" onclick=\"this.form.thumbnails_$row[id].disabled=!this.checked;this.form.xxx_$row[id].disabled=!this.checked\" $checked /></td><td style=\"vertical-align : top;\"><input type=\"checkbox\" name=\"thumbnails_$row[id]\" value=\"true\" class=\"input\" $disabled /></td><td style=\"vertical-align : top;\"><input type=\"checkbox\" name=\"xxx_$row[id]\" value=\"true\" class=\"input\" $checkedxxx $disabled /></td></tr>\n";
				$lastid=$row[id];
			}
			echo "<tr><td colspan=\"4\">&nbsp;</td></tr>";
			echo "<tr><td colspan=\"4\" style=\"font-size : 10px;text-align : center;\">*) Should automatic creation fail, create the same directory with mp3 samples, thumbnails or ebook-icons in the 'gfx' directory</td></tr><tr><td colspan=\"4\">&nbsp;</td></tr>\n";
			echo "<tr><td colspan=\"4\" style=\"text-align : center;\"><input type=\"hidden\" name=\"enablealbum\" value=\"$lastid\" /><input type=\"submit\" value=\"Save changes\" class=\"button\" onclick=\"CollapseDiv('dirdiv');ExpandDiv('throbberdiv');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
		}
	}
	echo "</table></div>\n";
	echo "<div id=\"throbberdiv\" style=\"display: none\"><table class=\"contenttable\" style=\"width : 100%;height : 200px;\"><tr><td style=\"vertical-align : middle;text-align : center;\">\n";
        echo "<div id=\"alternativecontent\"><img src=\"3dgfx/throbber_blue.gif\" alt=\"throbber\" style=\"border : 0px;\" /></div>\n";
	echo "</td></tr><tr><td style=\"text-align : center;\">Please wait ...</td></tr></table></div>\n";   
	html_footer();
	
} else if (isset($_REQUEST['albumlayout'])) {	

	// Layout options
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Border*:</td>\n";
	$selecttemplate="<select name=\"templates\" class=\"input\"><option value=\"nochange\">Change border</option>";
	if ($dir=opendir($homedir.'/shoptemplates')) {
		while ($file=readdir($dir)) {
			if (is_dir($homedir.'/shoptemplates/'.$file) && $file!='.' && $file!='..') {
					$selecttemplate.="<option value=\"$file\">$file</option>";	
			}
		}
		closedir($dir);
	}	
	$selecttemplate.='</select>';
	if ($enablebackground) {$enablebackground_checked='checked=\"checked\"';} else {$enablebackground_checked='';}
	if ($transparentshop) {$transparentshop_checked='checked=\"checked\"';} else {$transparentshop_checked='';}
	if (!$shophighlight) {$shophighlight_checked='checked=\"checked\"';} else {$shophighlight_checked='';}	
	echo "<td style=\"text-align : left;\">$selecttemplate</td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>";
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Enable background image:</td><td style=\"text-align : left;\"><input type=\"checkbox\" name=\"enablebackground\" value=\"true\" $enablebackground_checked class=\"input\" /></td></tr>\n";
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Page background color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"pagecolor\" class=\"input\" value=\"" . trim($pagecolor,'#') . "\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_pagecolor\" class=\"input\" style=\"background-color: $pagecolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].pagecolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	if ($shopcolor=='transparent')
		echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Shop background color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"shopcolor\" class=\"input\" value=\"FAFAFA\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_shopcolor\" class=\"input\" style=\"background-color: $shopcolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].shopcolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	else
		echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Shop background color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"shopcolor\" class=\"input\" value=\"" . trim($shopcolor,'#') . "\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_shopcolor\" class=\"input\" style=\"background-color: $shopcolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].shopcolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Transparent shop background:</td><td style=\"text-align : left;\"><input type=\"checkbox\" name=\"transparentshop\" value=\"true\" $transparentshop_checked class=\"input\" /></td></tr>\n";	
	if (!$shophighlight)	
		echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Shop highlight color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"highlightcolor\" class=\"input\" value=\"F0F0F0\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_highlightcolor\" class=\"input\" style=\"background-color: $highlightcolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].highlightcolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	else
		echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Shop highlight color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"highlightcolor\" class=\"input\" value=\"" . trim($highlightcolor,'#') . "\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_highlightcolor\" class=\"input\" style=\"background-color: $highlightcolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].highlightcolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";		
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Disable highlight:</td><td style=\"text-align : left;\"><input type=\"checkbox\" name=\"shophighlight\" value=\"true\" $shophighlight_checked class=\"input\" /></td></tr>\n";	
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Shop text color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"textcolor\" class=\"input\" value=\"" . trim($textcolor,'#') . "\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_textcolor\" class=\"input\" style=\"background-color: $textcolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].textcolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Shop link color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"linkcolor\" class=\"input\" value=\"" . trim($linkcolor,'#') . "\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_linkcolor\" class=\"input\" style=\"background-color: $linkcolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].linkcolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "<tr onmouseover=\"this.bgColor='$highlightcolor';\" onmouseout=\"this.bgColor='$shopcolor';\"><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Price text color:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"pricecolor\" class=\"input\" value=\"" . trim($pricecolor,'#') . "\" maxlength=\"6\" size=\"8\" onfocus=\"javascript:boxname=this.name;colorbox(this);\" /> <input type=\"text\" name=\"colorsample_pricecolor\" class=\"input\" style=\"background-color: $pricecolor\" readonly=\"readonly\" size=\"7\" onclick=\"javascript:ExpandDiv('chart');document.forms[0].pricecolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>";
	echo "</table>\n";
	echo "<div id=\"chart\" style=\"display : none;padding-left : 160px;\"><table class=\"tablechart\">\n";
	echo "<tr><td style=\"background-color: #FFFFFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFFFFF</td><td style=\"background-color: #FFFFCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFFFCC</td><td style=\"background-color: #FFFF99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFFF99</td><td style=\"background-color: #FFFF66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFFF66</td><td style=\"background-color: #FFFF33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFFF33</td><td style=\"background-color: #FFFF00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFFF00</td><td style=\"background-color: #FFCCFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFCCFF</td><td style=\"background-color: #FFCCCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFCCCC</td><td style=\"background-color: #FFCC99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFCC99</td><td style=\"background-color: #FFCC66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFCC66</td><td style=\"background-color: #FFCC33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFCC33</td><td style=\"background-color: #FFCC00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FFCC00</td></tr>\n";
	echo "<tr><td style=\"background-color: #FF99FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF99FF</td><td style=\"background-color: #FF99CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF99CC</td><td style=\"background-color: #FF9999\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF9999</td><td style=\"background-color: #FF9966\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF9966</td><td style=\"background-color: #FF9933\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF9933</td><td style=\"background-color: #FF9900\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF9900</td><td style=\"background-color: #FF66FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF66FF</td><td style=\"background-color: #FF66CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF66CC</td><td style=\"background-color: #FF6699\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF6699</td><td style=\"background-color: #FF6666\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF6666</td><td style=\"background-color: #FF6633\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF6633</td><td style=\"background-color: #FF6600\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF6600</td></tr>\n";
	echo "<tr><td style=\"background-color: #FF33FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF33FF</td><td style=\"background-color: #FF33CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF33CC</td><td style=\"background-color: #FF3399\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF3399</td><td style=\"background-color: #FF3366\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF3366</td><td style=\"background-color: #FF3333\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF3333</td><td style=\"background-color: #FF3300\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF3300</td><td style=\"background-color: #FF00FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF00FF</td><td style=\"background-color: #FF00CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF00CC</td><td style=\"background-color: #FF0099\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF0099</td><td style=\"background-color: #FF0066\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF0066</td><td style=\"background-color: #FF0033\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF0033</td><td style=\"background-color : #FF0000\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">FF0000</td></tr>\n";
	echo "<tr><td style=\"background-color: #CCFFFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCFFFF</td><td style=\"background-color: #CCFFCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCFFCC</td><td style=\"background-color: #CCFF99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCFF99</td><td style=\"background-color: #CCFF66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCFF66</td><td style=\"background-color: #CCFF33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCFF33</td><td style=\"background-color: #CCFF00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCFF00</td><td style=\"background-color: #CCCCFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCCCFF</td><td style=\"background-color: #CCCCCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCCCCC</td><td style=\"background-color: #CCCC99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCCC99</td><td style=\"background-color: #CCCC66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCCC66</td><td style=\"background-color: #CCCC33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCCC33</td><td style=\"background-color: #CCCC00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CCCC00</td></tr>\n";
	echo "<tr><td style=\"background-color: #CC99FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC99FF</td><td style=\"background-color: #CC99CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC99CC</td><td style=\"background-color: #CC9999\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC9999</td><td style=\"background-color: #CC9966\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC9966</td><td style=\"background-color: #CC9933\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC9933</td><td style=\"background-color: #CC9900\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC9900</td><td style=\"background-color: #CC66FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC66FF</td><td style=\"background-color: #CC66CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC66CC</td><td style=\"background-color: #CC6699\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC6699</td><td style=\"background-color: #CC6666\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC6666</td><td style=\"background-color: #CC6633\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC6633</td><td style=\"background-color: #CC6600\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC6600</td></tr>\n";
	echo "<tr><td style=\"background-color: #CC33FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC33FF</td><td style=\"background-color: #CC33CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC33CC</td><td style=\"background-color: #CC3399\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC3399</td><td style=\"background-color: #CC3366\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC3366</td><td style=\"background-color: #CC3333\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC3333</td><td style=\"background-color: #CC3300\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC3300</td><td style=\"background-color: #CC00FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC00FF</td><td style=\"background-color: #CC00CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC00CC</td><td style=\"background-color: #CC0099\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC0099</td><td style=\"background-color: #CC0066\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC0066</td><td style=\"background-color: #CC0033\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC0033</td><td style=\"background-color: #CC0000\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">CC0000</td></tr>\n";
	echo "<tr><td style=\"background-color: #99FFFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99FFFF</td><td style=\"background-color: #99FFCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99FFCC</td><td style=\"background-color: #99FF99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99FF99</td><td style=\"background-color: #99FF66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99FF66</td><td style=\"background-color: #99FF33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99FF33</td><td style=\"background-color: #99FF00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99FF00</td><td style=\"background-color: #99CCFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99CCFF</td><td style=\"background-color: #99CCCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99CCCC</td><td style=\"background-color: #99CC99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99CC99</td><td style=\"background-color: #99CC66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99CC66</td><td style=\"background-color: #99CC33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99CC33</td><td style=\"background-color: #99CC00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">99CC00</td></tr>\n";
	echo "<tr><td style=\"background-color: #9999FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9999FF</td><td style=\"background-color: #9999CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9999CC</td><td style=\"background-color: #999999\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">999999</td><td style=\"background-color: #999966\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">999966</td><td style=\"background-color: #999933\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">999933</td><td style=\"background-color: #999900\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">999900</td><td style=\"background-color: #9966FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9966FF</td><td style=\"background-color: #9966CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9966CC</td><td style=\"background-color: #996699\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">996699</td><td style=\"background-color: #996666\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">996666</td><td style=\"background-color: #996633\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">996633</td><td style=\"background-color: #996600\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">996600</td></tr>\n";
	echo "<tr><td style=\"background-color: #9933FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9933FF</td><td style=\"background-color: #9933CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9933CC</td><td style=\"background-color: #993399\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">993399</td><td style=\"background-color: #993366\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">993366</td><td style=\"background-color: #993333\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">993333</td><td style=\"background-color: #993300\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">993300</td><td style=\"background-color: #9900FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9900FF</td><td style=\"background-color: #9900CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">9900CC</td><td style=\"background-color: #990099\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">990099</td><td style=\"background-color: #990066\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">990066</td><td style=\"background-color: #990033\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">990033</td><td style=\"background-color: #990000\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">990000</td></tr>\n";
	echo "<tr><td style=\"background-color: #66FFFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66FFFF</td><td style=\"background-color: #66FFCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66FFCC</td><td style=\"background-color: #66FF99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66FF99</td><td style=\"background-color: #66FF66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66FF66</td><td style=\"background-color: #66FF33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66FF33</td><td style=\"background-color: #66FF00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66FF00</td><td style=\"background-color: #66CCFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66CCFF</td><td style=\"background-color: #66CCCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66CCCC</td><td style=\"background-color: #66CC99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66CC99</td><td style=\"background-color: #66CC66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66CC66</td><td style=\"background-color: #66CC33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66CC33</td><td style=\"background-color: #66CC00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">66CC00</td></tr>\n";
	echo "<tr><td style=\"background-color: #6699FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6699FF</td><td style=\"background-color: #6699CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6699CC</td><td style=\"background-color: #669999\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">669999</td><td style=\"background-color: #669966\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">669966</td><td style=\"background-color: #669933\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">669933</td><td style=\"background-color: #669900\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">669900</td><td style=\"background-color: #6666FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6666FF</td><td style=\"background-color: #6666CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6666CC</td><td style=\"background-color: #666699\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">666699</td><td style=\"background-color: #666666\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">666666</td><td style=\"background-color: #666633\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">666633</td><td style=\"background-color: #666600\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">666600</td></tr>\n";
	echo "<tr><td style=\"background-color: #6633FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6633FF</td><td style=\"background-color: #6633CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6633CC</td><td style=\"background-color: #663399\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">663399</td><td style=\"background-color: #663366\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">663366</td><td style=\"background-color: #663333\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">663333</td><td style=\"background-color: #663300\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">663300</td><td style=\"background-color: #6600FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6600FF</td><td style=\"background-color: #6600CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">6600CC</td><td style=\"background-color: #660099\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">660099</td><td style=\"background-color: #660066\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">660066</td><td style=\"background-color: #660033\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">660033</td><td style=\"background-color: #660000\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">660000</td></tr>\n";
	echo "<tr><td style=\"background-color: #33FFFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33FFFF</td><td style=\"background-color: #33FFCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33FFCC</td><td style=\"background-color: #33FF99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33FF99</td><td style=\"background-color: #33FF66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33FF66</td><td style=\"background-color: #33FF33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33FF33</td><td style=\"background-color: #33FF00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33FF00</td><td style=\"background-color: #33CCFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33CCFF</td><td style=\"background-color: #33CCCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33CCCC</td><td style=\"background-color: #33CC99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33CC99</td><td style=\"background-color: #33CC66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33CC66</td><td style=\"background-color: #33CC33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33CC33</td><td style=\"background-color: #33CC00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">33CC00</td></tr>\n";
	echo "<tr><td style=\"background-color: #3399FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3399FF</td><td style=\"background-color: #3399CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3399CC</td><td style=\"background-color: #339999\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">339999</td><td style=\"background-color: #339966\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">339966</td><td style=\"background-color: #339933\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">339933</td><td style=\"background-color: #339900\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">339900</td><td style=\"background-color: #3366FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3366FF</td><td style=\"background-color: #3366CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3366CC</td><td style=\"background-color: #336699\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">336699</td><td style=\"background-color: #336666\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">336666</td><td style=\"background-color: #336633\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">336633</td><td style=\"background-color: #336600\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">336600</td></tr>\n";
	echo "<tr><td style=\"background-color: #3333FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3333FF</td><td style=\"background-color: #3333CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3333CC</td><td style=\"background-color: #333399\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">333399</td><td style=\"background-color: #333366\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">333366</td><td style=\"background-color: #333333\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">333333</td><td style=\"background-color: #333300\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">333300</td><td style=\"background-color: #3300FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3300FF</td><td style=\"background-color: #3300CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">3300CC</td><td style=\"background-color: #330099\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">330099</td><td style=\"background-color: #330066\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">330066</td><td style=\"background-color: #330033\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">330033</td><td style=\"background-color: #330000\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">330000</td></tr>\n";
	echo "<tr><td style=\"background-color: #00FFFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00FFFF</td><td style=\"background-color: #00FFCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00FFCC</td><td style=\"background-color: #00FF99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00FF99</td><td style=\"background-color: #00FF66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00FF66</td><td style=\"background-color: #00FF33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00FF33</td><td style=\"background-color: #00FF00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00FF00</td><td style=\"background-color: #00CCFF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00CCFF</td><td style=\"background-color: #00CCCC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00CCCC</td><td style=\"background-color: #00CC99\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00CC99</td><td style=\"background-color: #00CC66\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00CC66</td><td style=\"background-color: #00CC33\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00CC33</td><td style=\"background-color: #00CC00\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">00CC00</td></tr>\n";
	echo "<tr><td style=\"background-color: #0099FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0099FF</td><td style=\"background-color: #0099CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0099CC</td><td style=\"background-color: #009999\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">009999</td><td style=\"background-color: #009966\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">009966</td><td style=\"background-color: #009933\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">009933</td><td style=\"background-color: #009900\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">009900</td><td style=\"background-color: #0066FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0066FF</td><td style=\"background-color: #0066CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0066CC</td><td style=\"background-color: #006699\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">006699</td><td style=\"background-color: #006666\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">006666</td><td style=\"background-color: #006633\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">006633</td><td style=\"background-color: #006600\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">006600</td></tr>\n";
	echo "<tr><td style=\"background-color: #0033FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0033FF</td><td style=\"background-color: #0033CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0033CC</td><td style=\"background-color: #003399\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">003399</td><td style=\"background-color: #003366\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">003366</td><td style=\"background-color: #003333\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">003333</td><td style=\"background-color: #003300\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">003300</td><td style=\"background-color: #0000FF\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0000FF</td><td style=\"background-color: #0000CC\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">0000CC</td><td style=\"background-color: #000099\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">000099</td><td style=\"background-color: #000066\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">000066</td><td style=\"background-color: #000033\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">000033</td><td style=\"background-color: #000000\" onclick=\"selectcolor(this)\" onmouseover=\"this.style.cursor='pointer'\">000000</td></tr>\n";
	echo "</table></div>\n";
	echo "<table width=\"100%\"><tr><td>&nbsp;</td></tr><tr><td style=\"font-size : 10px;text-align : center;\">*) Page reload will be required to show new border (F5 or Apple+R)</td></tr>\n";
	echo "<tr><td>&nbsp;</td></tr><tr><td style=\"text-align : center;\"><input type=\"hidden\" name=\"enablelayout\" value=\"true\" /><input type=\"submit\" value=\"Save changes\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /> <input type=\"button\" value=\"Reset Colors\" class=\"button\" onclick=\"javascript:document.forms[0].pagecolor.value='D0DEEE';document.forms[0].pagecolor.focus();document.forms[0].shopcolor.value='FAFAFA';document.forms[0].shopcolor.focus();document.forms[0].highlightcolor.value='F0F0F0';document.forms[0].highlightcolor.focus();document.forms[0].linkcolor.value='3366FF';document.forms[0].linkcolor.focus();document.forms[0].textcolor.value='555555';document.forms[0].textcolor.focus();document.forms[0].pricecolor.value='000000';document.forms[0].pricecolor.focus();\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "</table>\n";
	html_footer();
	
} else if (isset($_REQUEST['manualsale'])) {	
	
	// Add a manual sale
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";
	if ($_REQUEST['manualsale']==2) {
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Manual sale processed, email(s) forwarded.</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"button\" value=\"Continue\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;manualsale=1');\" onmouseover=\"this.style.cursor='pointer'\" /><tr><td colspan=\"2\">&nbsp;</td></tr>\n";		
	} else {
		// Available files
		$query="SELECT id, name, type, rname FROM digitalshop";$result=mysql_query($query);$selectfile='';
		if ($result && mysql_num_rows($result)) {
			$selectfile="<select name=\"fileid\" class=\"input\" onchange=\"this.blur();document.forms[0].ordercode.value=document.forms[0].ordercode.value + this.form.fileid.options[this.form.fileid.options.selectedIndex].value + '-';\"><option value=\"\">Please select file(s)</option>";
			while ($result && $row=mysql_fetch_array($result)) {
				if ($row[type]=='Directory') {
					if (!file_exists($moveto . $row[rname] . '/photoalbum.php') && !file_exists($moveto . $row[rname] . '/mp3album.php'))
						$selectfile.="<option value=\"" . $row[id] . "\">" . $row[name] . "</option>";	
				} else {
					$selectfile.="<option value=\"" . $row[id] . "\">" . $row[name] . "</option>";	
				}
			}
			$selectfile.='</select>';
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Transaction ID:</td><td style=\"font-size : 10px;text-align : left;\"><input type=\"text\" name=\"txn_id\" class=\"input\" maxlength=\"17\" value=\"" . time() . "\" /> (or use the transaction ID)</td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Customer email address:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"payer_email\" onfocus=\"clearadminform();\" class=\"input\" value=\"\" /></td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Customer country:</td><td style=\"font-weight : bold;text-align : left;\"><select name=\"country\" class=\"input\" /><option value=\"--\">--</option>\n";
			foreach($countries as $key => $value) {
				echo "<option value=\"$key\">$value</option>";
			}
			echo "</select></td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Order code*:</td><td style=\"font-weight : bold;text-align : left;\">$selectfile</td></tr>\n";
			echo "<tr><td>&nbsp;</td><td style=\"text-align : left;\"><input type=\"text\" name=\"ordercode\" maxlength=\"120\" size=\"24\" onfocus=\"clearadminform();\" class=\"input\" value=\"\" /></td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Send invoice:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"checkbox\" name=\"sendinvoice\" onclick=\"this.form.tax.disabled=!this.checked;\" class=\"input\" value=\"true\" /></td></tr>\n";
        		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Add tax:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"checkbox\" name=\"tax\" onclick=\"this.form.taxamount.disabled=!this.checked;\" value=\"true\" disabled=\"true\" class=\"input\" /></td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Tax amount:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"taxamount\" size=\"7\" class=\"input\" value=\"0.00\" disabled=\"true\" /> %</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			echo "<tr><td colspan=\"2\" style=\"font-size : 10px;text-align : center;\">*) Enter the File-ID or the 5 digit track or photocode<br />Use '-' as separator for multiple items<br />It is <b>not</b> possible to use a coupon -or aid code</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"hidden\" name=\"manualsale\" value=\"0\" /><input type=\"button\" name=\"submitadmin\" onclick=\"validateadminform();\" value=\"Add manual sale\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		} else {
			echo "<tr><td colspan=\"2\" style=\"font-weight: bold;text-align : center;\">No products available in the shop</td></tr>\n";	
		}
	}
	echo "</table>\n";
	html_footer();

} else if (isset($_REQUEST['buynow'])) {	

	// Show email form
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";
        if (!isset($_REQUEST['buynowcode'])) {
	// Available files
        	$query="SELECT id, name, type, rname FROM digitalshop";$result=mysql_query($query);$selectfile='';
        	if ($result && mysql_num_rows($result)) {
        		$selectfile="<select name=\"buynowid\" class=\"input\" onchange=\"this.blur();\">";
        		while ($result && $row=mysql_fetch_array($result)) {
        			if ($row[type]=='Directory') {
        				if (!file_exists($moveto . $row[rname] . '/photoalbum.php') && !file_exists($moveto . $row[rname] . '/mp3album.php'))
        					$selectfile.="<option value=\"" . $row[id] . "\">" . $row[name] . "</option>";	
        			} else {
        				$selectfile.="<option value=\"" . $row[id] . "\">" . $row[name] . "</option>";	
        			}
        		}
        		$selectfile.='</select>';
        		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Buy Now Button for:</td><td style=\"text-align : left;\">$selectfile</td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Thank you URL:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"thankyou\" class=\"input\" value=\"\" /></td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Cancel URL:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"cancel\" class=\"input\" value=\"\" /></td></tr>\n";
			echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
        		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"hidden\" name=\"buynowcode\" value=\"true\" /><input type=\"hidden\" name=\"buynow\" value=\"true\" /><input type=\"submit\" name=\"createbutton\" value=\"Create button code\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
			echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
			echo "<tr><td colspan=\"2\" style=\"font-size : 9px;\">Note: Coupon, affiliate, free download and Moneybookers tax functionality are all disabled when using a buy now button.<br />Buy now buttons for Authorize.net need to be configured in your online account.<br />Buy now buttons for Bank Transfers are not possible (no check out service).</td></tr>\n";
        	} else {
        		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">No files in database</td></tr>\n";
        	}
	} else {
		$id=intval($_REQUEST['buynowid']);
		$query="SELECT name, price, disc FROM digitalshop WHERE id = '$id'";
		$result=mysql_query($query);
		if ($result && mysql_num_rows($result)) {
			$row=mysql_fetch_array($result);
			$filename=html_entity_decode($row[name]);
			$price=$row[price];
			if ($row[disc]>0)
                                $price=floatval(str_replace(',','',$row[price]))-(floatval(str_replace(',','',$row[price]))*($row[disc]/100));
		}	
		$paypal="<form method=\"post\" action=\"https://www.paypal.com/cgi-bin/webscr\">\n";
		$image=$shopurl.'/shopgfx/logo.gif';
		$accepted=$_REQUEST['thankyou'];
		$cancelled=$_REQUEST['cancel'];
		$ordercode='DS'.intval($id);
		$amount=floatval($price);
		if ($ipn_url=='') {$paid=$shopurl.'/ipn.php';} else {$paid=$ipn_url;}	
		// Paypal
		$paypal.="<input type=\"hidden\" name=\"cmd\" value=\"_xclick\" />\n";
		$paypal.="<input type=\"hidden\" name=\"business\" value=\"$pp_business\" />\n";
		$paypal.="<input type=\"hidden\" name=\"return\" value=\"$accepted\" />\n";
		$paypal.="<input type=\"hidden\" name=\"cbt\" value=\"$lang_95\" />\n";
		$paypal.="<input type=\"hidden\" name=\"cancel_return\" value=\"$cancelled\" />\n";
		if ($enable_notify_url) {$paypal.="<input type=\"hidden\" name=\"notify_url\" value=\"$paid\" />\n";}
		if (floatval($amount)==0.01)
			$paypal.="<input type=\"text\" size=\"6\" name=\"amount\" value=\"$lang_160\" onclick=\"if(this.value=='$lang_160')this.value='';\" /><br />\n";		
		else
			$paypal.="<input type=\"hidden\" name=\"amount\" value=\"$amount\" />\n";
		$paypal.="<input type=\"hidden\" name=\"quantity\" value=\"1\" />\n";
		$paypal.="<input type=\"hidden\" name=\"item_name\" value=\"" .  $filename . "\" />\n";
		$paypal.="<input type=\"hidden\" name=\"item_number\" value=\"$ordercode\" />\n";
		$paypal.="<input type=\"hidden\" name=\"image_url\" value=\"$image\" />\n";	
		$paypal.="<input type=\"hidden\" name=\"no_note\" value=\"1\" />\n";
		$paypal.="<input type=\"hidden\" name=\"no_shipping\" value=\"1\" />\n";	
		$paypal.="<input type=\"hidden\" name=\"currency_code\" value=\"$currency\" />\n";	
		$paypal.="<input type=\"image\" src=\"$shopurl/shopgfx/buynow.gif\" border=\"0\" name=\"button\" /></form>\n";		
		// Moneybookers
		$moneybookers="<form method=\"post\" action=\"https://www.moneybookers.com/app/payment.pl\">\n";
		$moneybookers.="<input type=\"hidden\" name=\"pay_to_email\" value=\"$mb_business\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"recipient_description\" value=\"$shopname\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"return_url\" value=\"$accepted\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"cancel_url\" value=\"$cancelled\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"status_url\" value=\"$shopurl/mb_ipn.php\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"language\" value=\"EN\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"confirmation_note\" value=\"$lang_51 $lang_52\" />\n";
		if (floatval($amount)==0.01)
			$moneybookers.="<input type=\"text\" size=\"6\" name=\"amount\" value=\"$lang_160\" onclick=\"if(this.value=='$lang_160')this.value='';\" /><br />\n";		
		else
			$moneybookers.="<input type=\"hidden\" name=\"amount\" value=\"$amount\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"currency\" value=\"$currency\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"detail1_description\" value=\"$lang_02\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"detail1_text\" value=\"" .  $filename . "\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"merchant_fields\" value=\"item_number,residence_country\" />\n";	
		$moneybookers.="<input type=\"hidden\" name=\"item_number\" value=\"$ordercode\" />\n";
		$moneybookers.="<input type=\"hidden\" name=\"residence_country\" value=\"--\" />\n";
		$moneybookers.="<input type=\"image\" src=\"$shopurl/shopgfx/buynow_mb.gif\" border=\"0\" name=\"button\" onclick=\"document.forms[0].amount2.value=document.forms[0].amount.value;}\" /></form>\n";
		echo "<tr><td colspan=\"2\" style=\"font-weight:bold;\">Moneybookers: </td></tr>\n";		
		echo "<tr><td colspan=\"2\"><textarea class=\"input\" name=\"moneybookers\" cols=\"35\" rows=\"10\">" . stripslashes($moneybookers) . "</textarea></td></tr>\n";		
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"font-weight:bold;\">PayPal: </td></tr>\n";		
		echo "<tr><td colspan=\"2\"><textarea class=\"input\" name=\"paypal\" cols=\"35\" rows=\"10\">" . stripslashes($paypal) . "</textarea></td></tr>\n";		
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"font-size : 9px;\">Copy the code (CTRL-A + CTRL-C) and paste it (CTRL+V) in your webpage.</td></tr>\n";
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"button\" value=\"Create a new button\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;buynow=1&amp;start=1');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	}
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	html_footer();

} else if (isset($_REQUEST['massemail'])) {	

	// Show email form
	html_header();
        if (isset($_SESSION['emailto'])) {
                echo "<div id=\"throbberdiv\"><table class =\"contenttable\" style=\"width : 100%;height : 200px;\"><tr><td style=\"vertical-align : middle;text-align : center;\">\n";
                echo "<div id=\"alternativecontent\"><img src=\"3dgfx/throbber_blue.gif\" alt=\"throbber\" style=\"border : 0px;\" /></div>\n";
                echo "</td></tr><tr><td style=\"text-align : center;\">Please wait ...</td></tr><tr><td style=\"font-style : italic;text-align : center;\">Emails remaining in queue:". count($_SESSION['emailto']) . "<input type=\"hidden\" name=\"massemail\" value=\"true\" /><input type=\"hidden\" name=\"emailmessage\" value=\"true\" /></td></tr></table></div>\n";
        } else {
        	echo "<div id=\"emaildiv\"><table class=\"contenttable\" style=\"width : 100%;\">\n";
        	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";
        	if ($emailstatus!='')
        		echo "<tr><td colspan=\"2\" style=\"color : #FF0000;font-weight : bold;text-align : center;\">$emailstatus</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>\n";
        	// Available files
		if ($mailbcc=='') {$testmail=$shopcontact;} else {$testmail=$mailbcc;}
        	$query="SELECT id, name, type, rname FROM digitalshop";$result=mysql_query($query);$selectfile='';
        	if ($result && mysql_num_rows($result)) {
        		$selectfile="<select name=\"emailid\" class=\"input\" onchange=\"this.blur();\"><option value=\"-1\">TEST email to: $testmail</option><option value=\"-2\">Email ALL customers</option><option value=\"-3\">Email ALL affiliates</option>";
        		while ($result && $row=mysql_fetch_array($result)) {
        			if ($row[type]=='Directory') {
        				if (!file_exists($moveto . $row[rname] . '/photoalbum.php') && !file_exists($moveto . $row[rname] . '/mp3album.php'))
        					$selectfile.="<option value=\"" . $row[id] . "\">Email customers for: " . $row[name] . "</option>";	
        			} else {
        				$selectfile.="<option value=\"" . $row[id] . "\">Email customers for:" . $row[name] . "</option>";	
        			}
        		}
        		$selectfile.='</select>';
        		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Email customers for:</td><td style=\"text-align : left;\">$selectfile</td></tr>\n";
        		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Subject:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"subject\" class=\"input\" value=\"" . stripslashes($subject) . "\" /></td></tr>\n";
        		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Reactivate keys:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"checkbox\" name=\"renewkeysmassemail\" value=\"true\" class=\"input\" /></td></tr>\n";
        		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Include an individual coupon:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"checkbox\" name=\"createcoupon\" onclick=\"this.form.couponvalue.disabled=!this.checked;this.form.couponexpire.disabled=!this.checked;\" value=\"true\" class=\"input\" /></td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Coupon value:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"couponvalue\" size=\"7\" class=\"input\" value=\"0.00\" disabled=\"true\" /> $currency</td></tr>\n";
			echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Coupon expires in:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"couponexpire\" size=\"7\" class=\"input\" value=\"240\" disabled=\"true\" /> hrs</td></tr>\n";
			echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
        		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">Email Message:</td></tr>\n";
			if ($wysiwyg_editor ) {
				echo "<tr><td colspan=\"2\" style=\"padding-left : 55px;text-align : center;\">\n";
				echo "<script language=\"JavaScript\" type=\"text/javascript\">\n";
				echo "<!--\n";
				echo "initRTE('inc/cbrte/images/', 'inc/cbrte/', '', true);\n";
				echo "var rte1 = new richTextEditor('emailmessage');\n";
				$content = rteSafe($emailmessage);
				echo "rte1.html = '$content';\n";
				echo "rte1.width = 760;\n";
				echo "rte1.height = 300;\n";	
				echo "rte1.cmdJustifyLeft = false;\n";
				echo "rte1.cmdJustifyCenter = false;\n";
				echo "rte1.cmdJustifyRight = false;\n";
				echo "rte1.cmdInsertHorizontalRule = false;\n";
				echo "rte1.cmdInsertTable = false;\n";
				echo "rte1.build();\n";
				echo "//-->\n";
				echo "</script>\n";
				echo "</td></tr>\n";
			} else {
				echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><textarea class=\"input\" name=\"emailmessage\" cols=\"80\" rows=\"15\">" . stripslashes($emailmessage) . "</textarea></td></tr>\n";
			}
			echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
        		echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"hidden\" name=\"massemail\" value=\"true\" /><input type=\"submit\" name=\"send\" value=\"Send email(s)\" class=\"button\" onclick=\"CollapseDiv('emaildiv');ExpandDiv('throbberdiv');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
        		echo "</table></div>\n";
        	} else {
        		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">No customers in database</td></tr>\n";
        		echo "</table></div>\n";
        	}
        	echo "<div id=\"throbberdiv\" style=\"display: none\"><table class=\"contenttable\" style=\"width : 100%;height : 200px;\"><tr><td style=\"vertical-align : middle;text-align : center;\">\n";
        	echo "<div id=\"alternativecontent\"><img src=\"3dgfx/throbber_blue.gif\" alt=\"throbber\" style=\"border : 0px;\" /></div>\n";
        	echo "</td></tr><tr><td style=\"text-align : center;\">Please wait ...</td></tr><tr><td style=\"font-style : italic;text-align : center;\">Sending emails</td></tr></table></div>\n";        
        }
	html_footer();

} else if (isset($_REQUEST['rssfeed'])) {

	require_once('inc/rsscontent.php');
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	if (isset($_REQUEST['writerssfeed'])) {
		echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">RSS Feed Updated, $rss_lastbuilddate</td></tr>\n";	
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	}
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Feed Title:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"rss_title\" size=\"32\" class=\"input\" value=\"$rss_title\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">Feed Description:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"rss_description\" size=\"32\" class=\"input\" value=\"$rss_description\" /></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">RSS item title:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"rss_itemtitle\" size=\"32\" class=\"input\" value=\"$rss_itemtitle\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 20px;\">RSS item link:</td><td style=\"font-weight : bold;text-align : left;\"><input type=\"text\" name=\"rss_itemlink\" size=\"32\" class=\"input\" value=\"$rss_itemlink\" /></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;\">RSS item description:</td></tr>\n";
	echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><textarea class=\"input\" name=\"rss_itemdescription\" cols=\"60\" rows=\"10\">$rss_itemdescription</textarea></td></tr>\n";
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"hidden\" name=\"rssfeed\" value=\"true\" /><input type=\"hidden\" name=\"writerssfeed\" value=\"true\" /><input type=\"submit\" name=\"rssupdate\" value=\"Update RSS Feed\" class=\"button\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";
	echo "</table>\n";
	html_footer();

} else {

	// File upload ok
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td>&nbsp;</td></tr>\n";
	if (isset($_REQUEST['editshop']) || isset($_REQUEST['overwrite'])) {
		if (isset($_REQUEST['renewkeys'])) {$renew='- users notified by email';} else {$renew='';}
		if ($errormessage!='') {
			echo "<tr><td style=\"font-weight : bold;text-align : center;\">Error</td></tr>\n";
			echo "<tr><td style=\"color : #FF0000;font-weight : bold;text-align : center;\">$errormessage</td></tr>\n";
		} else {
			echo "<tr><td style=\"font-weight : bold;text-align : center;\">Successfully updated $renew</td></tr>\n";
		}
		echo "<tr><td>&nbsp;</td></tr>\n";
		echo "<tr><td style=\"text-align : center;\"><input type=\"button\" value=\"Continue\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1&amp;showdigitalshop=1');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
		
	} else {
		if ($errormessage!='') {
			echo "<tr><td style=\"font-weight : bold;text-align : center;\">Error</td></tr>\n";
			echo "<tr><td style=\"color : #FF0000;font-weight : bold;text-align : center;\">$errormessage</td></tr>\n";
		} else {
			echo "<tr><td style=\"font-weight : bold;text-align : center;\">Successfully stored!</td></tr>\n";
		}
		echo "<tr><td>&nbsp;</td></tr>\n";
		echo "<tr><td style=\"text-align : center;\"><input type=\"button\" value=\"Store another file\" class=\"button\" onclick=\"location.href=('digitaladmin.php?requirelogin=1');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	}		
	echo "</table>\n";
	html_footer();

}

// Functions

function html_header() {
	
	global $lang_06,$lang_07,$lang_58,$lang_71,$verified_logo,$show_header,$transparentshop;
	global $pagecolor,$shopcolor,$textcolor,$linkcolor,$verified_logo,$shopname,$shopurl,$background,$iframe,$enablebackground;
	header("Content-Type: text/html; charset=UTF-8");
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?><!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\"><html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\">\n";
	echo "<head><link rel=\"stylesheet\" type=\"text/css\" href=\"inc/digitalshop.css\" />\n";
	echo "<title>Administrator $shopname</title>\n";
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" />\n";
	echo "<script type=\"text/javascript\" src=\"inc/digitaladmin.js\"></script>\n";
	echo "<script type=\"text/javascript\" src=\"inc/swfobject.js\"></script>\n";
	echo "<script type=\"text/javascript\" src=\"inc/cbrte/html2xhtml.js\"></script>\n";
	echo "<script type=\"text/javascript\" src=\"inc/cbrte/richtext_compressed.js\"></script>\n";
	echo "<script type=\"text/javascript\">\n";
	echo " swfobject.embedSWF(\"shopgfx/throbber.swf\",\"alternativecontent\",\"100\",\"100\",\"6.0.65\",\"inc/expressInstall.swf\",{},{BGCOLOR:\"$shopcolor\"},{});\n";
	echo "</script>\n";
	echo "<style type=\"text/css\">\n";
	echo "body {\n";
	if (!$iframe)
		echo " background-color : $pagecolor;\n";
	else
		echo " background-color : transparent;\n";
	echo " color            : $textcolor;\n";
	if ($background!='' && !$iframe && $enablebackground) {
		echo " background-image :url('$shopurl/$background'); \n";
	}
	echo "}\n";
	echo ".contenttable {\n";
	echo " color            : $textcolor;\n";
	if (!$transparentshop)
		echo " background-color : $shopcolor;\n";
	else
		echo " background-color : transparent;\n";
	echo "}\n";
	echo "a:link {\n";
	echo " color            : $linkcolor;\n";	
	echo "}\n";	
	echo "a:visited {\n";
	echo "color             : $linkcolor;\n";	
	echo "}\n";
	echo "</style>\n"; 
	if (isset($_SESSION['emailto'])) {
		echo "</head><body onload=\"setTimeout('document.forms[0].submit();',3000);\">\n";     
	} else {
		echo "</head><body>\n"; 
	}
	echo "<form method=\"post\" onsubmit=\"return submitForm();\" action=\"digitaladmin.php?requirelogin=1\" enctype=\"multipart/form-data\">";
	echo "<table style=\"width : 1140px;border : 0px;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td style=\"width : 190px;vertical-align : top;\">\n";
	topborder();
	require_once('inc/adminmenu.php');
	bottomborder();
	echo "</td><td style=\"width : 950px;vertical-align : top;\">\n";
	topborder();
	echo "<table class=\"contenttable\" style=\"width : 100%;\"><tr><td style=\"text-align : center;vertical-align : middle;\">\n";
	echo "<table style=\"width : 100%;\"><tr><td style=\"text-align : center;\">\n";
	echo "<img src=\"shopgfx/header.png\" style=\"border : 0px;padding-bottom : 10px;\" alt=\"Header image\" />\n";
	echo "</td></tr></table>\n";
	
}

function html_footer() {
	
	global $lang_27,$show_footer,$lang_73;
	echo "</td></tr></table>\n";
	bottomborder();
	echo "<div class=\"footer\">" . $_ENV["SERVER_NAME"] . " &copy; 2008-" . date("Y",time()) . " - $lang_73</div>\n";
	echo "</td></tr>\n";
	echo "</table></form></body></html>\n";	
	
}

function require_login() {
	
	global $center_form,$show_footer,$show_header,$shopcolor,$shopwidth,$captchaerror,$usecaptcha;
	html_header();
	echo "<table class=\"contenttable\" style=\"width : 100%;\">\n";
	echo "<tr><td style=\"width : 50%;\">&nbsp;</td><td>&nbsp;</td></tr>\n";		
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Username:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"new_user\" class=\"input\" /></td></tr>\n";
	echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Password:</td><td style=\"text-align : left;\"><input type=\"password\" name=\"new_password\" class=\"input\" /></td></tr>\n";
	if ($usecaptcha) {
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Code:</td><td style=\"text-align : left;\"><img src=\"digitaladmin.php?captchaimage=1\" alt=\"code\" style=\"border : 1px;border-color : #000000;border-style : solid;width : 178px;height : 42px;\" /></td></tr>\n";
		echo "<tr><td style=\"font-weight : bold;text-align : right;padding-right : 10px;\">Repeat code:</td><td style=\"text-align : left;\"><input type=\"text\" name=\"captcha\" class=\"input\" value=\"\" size=\"10\" maxlength=\"5\" /></td></tr>\n";   
		echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		if ($captchaerror!='') {
			echo "<tr><td colspan=\"2\" style=\"font-weight : bold;text-align : center;color : #FF0000;\">$captchaerror</td></tr>\n";        
			echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";            
		}
	} else {
		echo "<tr><td colspan=\"2\"><input type=\"hidden\" name=\"captcha\" value=\"disabled\" />&nbsp;</td></tr>\n";
		$_SESSION['digitalshopcaptchacode']='disabled';
	}
	echo "<tr><td colspan=\"2\" style=\"text-align : center;\"><input type=\"submit\" name=\"Submit\" class=\"button\" value=\"Login\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr>\n";	
	echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	echo "</table>\n";
	// Return button
	echo "<table class=\"contenttable\" style=\"width : 100%;\"><tr><td>&nbsp;</td></tr><tr><td style=\"text-align : left;\"><input type=\"button\" value=\"Return to shop\" class=\"button\" onclick=\"location.href=('digitalshop.php');\" onmouseover=\"this.style.cursor='pointer'\" /></td></tr></table>\n";
	html_footer();
	exit;
	
}

function help() {

	global $homedir,$shopcontact,$lang_44;
	html_header();
	// Insert the message
	echo "<table class=\"contenttable\" style=\"width : 100%;\"><tr><td style=\"text-align : left;\">\n";
	if ($fp=fopen($homedir."/shopinfo/help_english.txt",'r+')) {
		$help=fread($fp,filesize($homedir."/shopinfo/help_english.txt"));
		fclose($fp);
		echo nl2br($help);
	} else {
		echo "$lang_44 $shopcontact";
	}
	echo "</td></tr></table>\n";
	html_footer();
	exit;
	
}

function filemimetype($extension) {
	
	$mime_types=array("323" => "text/h323","acx" => "application/internet-property-stream","ai" => "application/postscript","aif" => "audio/x-aiff","aifc" => "audio/x-aiff","aiff" => "audio/x-aiff","asf" => "video/x-ms-asf","asr" => "video/x-ms-asf","asx" => "video/x-ms-asf","au" => "audio/basic","avi" => "video/x-msvideo","axs" => "application/olescript","bas" => "text/plain","bcpio" => "application/x-bcpio","bin" => "application/octet-stream","bmp" => "image/bmp","c" => "text/plain","cat" => "application/vnd.ms-pkiseccat","cdf" => "application/x-cdf","cer" => "application/x-x509-ca-cert","class" => "application/octet-stream",
		"clp" => "application/x-msclip","cmx" => "image/x-cmx","cod" => "image/cis-cod","cpio" => "application/x-cpio","crd" => "application/x-mscardfile","crl" => "application/pkix-crl","crt" => "application/x-x509-ca-cert","csh" => "application/x-csh","css" => "text/css","dcr" => "application/x-director","der" => "application/x-x509-ca-cert","dir" => "application/x-director","dll" => "application/x-msdownload","dms" => "application/octet-stream","doc" => "application/msword","dot" => "application/msword","dvi" => "application/x-dvi","dxr" => "application/x-director","eps" => "application/postscript","etx" => "text/x-setext",
		"evy" => "application/envoy","exe" => "application/octet-stream","fif" => "application/fractals","flr" => "x-world/x-vrml","gif" => "image/gif","gtar" => "application/x-gtar","gz" => "application/x-gzip","h" => "text/plain","hdf" => "application/x-hdf","hlp" => "application/winhlp","hqx" => "application/mac-binhex40","hta" => "application/hta","htc" => "text/x-component","htm" => "text/html","html" => "text/html","htt" => "text/webviewhtml","ico" => "image/x-icon","ief" => "image/ief","iii" => "application/x-iphone","ins" => "application/x-internet-signup","isp" => "application/x-internet-signup","jfif" => "image/pipeg",
		"jpe" => "image/jpeg","jpeg" => "image/jpeg","jpg" => "image/jpeg","js" => "application/x-javascript","latex" => "application/x-latex","lha" => "application/octet-stream","lsf" => "video/x-la-asf","lsx" => "video/x-la-asf","lzh" => "application/octet-stream","m13" => "application/x-msmediaview","m14" => "application/x-msmediaview","m3u" => "audio/x-mpegurl","man" => "application/x-troff-man","mdb" => "application/x-msaccess","me" => "application/x-troff-me","mht" => "message/rfc822","mhtml" => "message/rfc822","mid" => "audio/mid","mny" => "application/x-msmoney","mov" => "video/quicktime","movie" => "video/x-sgi-movie",
		"mp2" => "video/mpeg","mp3" => "audio/mpeg","mpa" => "video/mpeg","mpe" => "video/mpeg","mpeg" => "video/mpeg","mpg" => "video/mpeg","mpp" => "application/vnd.ms-project","mpv2" => "video/mpeg","ms" => "application/x-troff-ms","mvb" => "application/x-msmediaview","nws" => "message/rfc822","oda" => "application/oda","p10" => "application/pkcs10","p12" => "application/x-pkcs12","p7b" => "application/x-pkcs7-certificates","p7c" => "application/x-pkcs7-mime","p7m" => "application/x-pkcs7-mime","p7r" => "application/x-pkcs7-certreqresp","p7s" => "application/x-pkcs7-signature","pbm" => "image/x-portable-bitmap","pdf" => "application/pdf",
		"png" => "image/png","pfx" => "application/x-pkcs12","pgm" => "image/x-portable-graymap","pko" => "application/ynd.ms-pkipko","pma" => "application/x-perfmon","pmc" => "application/x-perfmon","pml" => "application/x-perfmon","pmr" => "application/x-perfmon","pmw" => "application/x-perfmon","pnm" => "image/x-portable-anymap","pot" => "application/vnd.ms-powerpoint","ppm" => "image/x-portable-pixmap","pps" => "application/vnd.ms-powerpoint","ppt" => "application/vnd.ms-powerpoint","prf" => "application/pics-rules","ps" => "application/postscript","pub" => "application/x-mspublisher","qt" => "video/quicktime","ra" => "audio/x-pn-realaudio",
		"ram" => "audio/x-pn-realaudio","ras" => "image/x-cmu-raster","rgb" => "image/x-rgb","rmi" => "audio/mid","roff" => "application/x-troff","rtf" => "application/rtf","rtx" => "text/richtext","scd" => "application/x-msschedule","sct" => "text/scriptlet","setpay" => "application/set-payment-initiation","setreg" => "application/set-registration-initiation","sh" => "application/x-sh","shar" => "application/x-shar","sit" => "application/x-stuffit","snd" => "audio/basic","spc" => "application/x-pkcs7-certificates","spl" => "application/futuresplash","src" => "application/x-wais-source","sst" => "application/vnd.ms-pkicertstore",
		"stl" => "application/vnd.ms-pkistl","stm" => "text/html","svg" => "image/svg+xml","sv4cpio" => "application/x-sv4cpio","sv4crc" => "application/x-sv4crc","t" => "application/x-troff","tar" => "application/x-tar","tcl" => "application/x-tcl","tex" => "application/x-tex","texi" => "application/x-texinfo","texinfo" => "application/x-texinfo","tgz" => "application/x-compressed","tif" => "image/tiff","tiff" => "image/tiff","tr" => "application/x-troff","trm" => "application/x-msterminal","tsv" => "text/tab-separated-values","txt" => "text/plain","uls" => "text/iuls","ustar" => "application/x-ustar","vcf" => "text/x-vcard",
		"vrml" => "x-world/x-vrml","wav" => "audio/x-wav","wcm" => "application/vnd.ms-works","wdb" => "application/vnd.ms-works","wks" => "application/vnd.ms-works","wmf" => "application/x-msmetafile","wps" => "application/vnd.ms-works","wri" => "application/x-mswrite","wrl" => "x-world/x-vrml","wrz" => "x-world/x-vrml","xaf" => "x-world/x-vrml","xbm" => "image/x-xbitmap","xla" => "application/vnd.ms-excel","xlc" => "application/vnd.ms-excel","xlm" => "application/vnd.ms-excel","xls" => "application/vnd.ms-excel","xlt" => "application/vnd.ms-excel","xlw" => "application/vnd.ms-excel","xof" => "x-world/x-vrml",
		"xpm" => "image/x-xpixmap","xwd" => "image/x-xwindowdump","z" => "application/x-compress","zip" => "application/zip");
	if ($mime_types["$extension"]=="")
		return "application/octet-stream";
	else
		return $mime_types["$extension"];
	
}

function createkey($fileid,$email,$txn_id,$country,$price) {
	
	$digid=randomkey();
	$sold=time();
	$query="SELECT * FROM digitalshopkey WHERE digid = '$digid'";
	$result=mysql_query($query);
	while ($result && mysql_num_rows($result)) {
		$digid=randomkey();
		$query="SELECT * FROM digitalshopkey WHERE digid = '$digid'";
		$result=mysql_query($query);
	}
	// Store new unique key
	$query="INSERT INTO digitalshopkey (digid, email, fileid, expire, cntr, txnid, sold, country, gross, fee) VALUES ('$digid', '$email', '$fileid', '0', '0', '$txn_id', '$sold', '$country' , '$price' , '0.00')";
	mysql_query($query) or die('Error, mysql key storage failed');	
	return $digid;

}

function createcoupon($value,$expire,$maxcntr) {
	
	$coupon='C'.str_replace('-','',strtoupper(substr(randomkey(),0,7)));
	$query="SELECT * FROM digitalshopcoupon WHERE coupon = '$coupon'";
	$result=mysql_query($query);
	while ($result && mysql_num_rows($result)) {
		$coupon='C'.str_replace('-','',strtoupper(substr(randomkey(),0,7)));
		$query="SELECT * FROM digitalshopcoupon WHERE coupon = '$coupon'";
		$result=mysql_query($query);
	}
	// Store new unique coupon
	$query="INSERT INTO digitalshopcoupon (coupon, value, expire, cntr, maxcntr) VALUES ('$coupon', '$value', '$expire', '0' , '$maxcntr')";
	mysql_query($query) or die('Error, mysql insert failed');
	couponcode($coupon,$value,$expire,$maxcntr);
	return $coupon;
	
}

function randomkey() {
	
	$key='';
	$chars=array('1','2','3','4','5','6','7','8','9','0','a','b','c','d','e','f','g','h','i','j','k','l','m','n',
						'1','2','3','4','5','6','7','8','9','0','o','p','q','r','s','t','u','v','w','x','y','z',
						'1','2','3','4','5','6','7','8','9','0','A','B','C','D','E','F','G','H','I','J','K','L','M','N',
						'1','2','3','4','5','6','7','8','9','0','O','P','Q','R','S','T','U','V','W','X','Y','Z');
	$rand_keys=array_rand($chars,15);
	for ($c=0;$c<15;$c++) {
		if ($c==5) {$key=$key.'-';}
		if ($c==10) {$key=$key.'-';}
		$key=$key.$chars[$rand_keys[$c]];
	}
	return $key;

}

function digitalshopmailkey($mailto,$mailfrom,$mailbcc,$keys,$names,$txn_id) {
	
	global $lang_45,$lang_46,$lang_47,$lang_48,$lang_49,$lang_50,$shopname,$email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header,$headeremailimage,$iframe,$download_webpage;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
		if ($mailbcc!='') {$mailbcc=substr($mailbcc,0,strpos($mailbcc,'@')) . " <$mailbcc>";}
	}
	if (!$iframe) {
		$link=$shopurl . '/download.php';
	} else {
		$link=$download_webpage;
		$shopcolor='#FAFAFA';		
	}
	$linkimage=$shopurl . '/shopgfx';
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	if ($mailbcc!='') {$headers.="BCC: $mailbcc\r\n";}
	$bound_text=md5(uniqid(time()));
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."$lang_45 $txn_id\r\n"
		."$lang_46 \r\n"
		."$lang_47 $link\r\n";
		foreach($keys as $index => $key) {$message.="$lang_48 $key (". $names[$index] .")\r\n";}
		$message.="$lang_49 \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table style=\"width : 100%;\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
         $message.="<table>"
                ."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_45 $txn_id </td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_46 </td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_47 <a href=\"$link\">$link</a></td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_48</td></tr><tr><td>&nbsp;</td></tr>";
	foreach ($keys as $index => $key) {
                $message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\"><span style=\"font-weight : bold;\"><a href=\"${link}?downloadcode=$key\">$key</a></span><br />". $names[$index] ."</td></tr><tr><td>&nbsp;</td></tr>";
        }
	$message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">$lang_49</td></tr><tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\" nowrap=\"nowrap\">$shopname</td></tr><tr><td>&nbsp;</td></tr>"
                ."</table>"
                ."</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"							
		."--$bound_text--\r\n\r\n";
	return mail($mailto,"$lang_50 $shopname",wordwrap($message,70),$headers);

}

function massmail($mailto,$mailfrom,$subject,$emailmessage) {
	
	global $email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header,$lang_89,$headeremailimage,$iframe,$iframe_shop,$iframe;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
	}
	$linkimage=$shopurl . '/shopgfx';
	if ($iframe)
		$shopcolor='#FAFAFA';	
	if (!$iframe)
		$link=$shopurl;
	else
		$link=$iframe_shop;
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	$bound_text=md5(uniqid(time()));
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		.stripslashes($emailmessage) . "\r\n"
		." \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table style=\"width : 100%;\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
        $message.="<table><tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; padding-left : 20px;font-size : 12px; color: $textcolor;\">" . stripslashes(nl2br($emailmessage)) . "</td></tr></table>";
	if (isset($_SESSION['masscoupons'])) {
		$coupon=createcoupon($_SESSION['masscoupons'][0],$_SESSION['masscoupons'][1],1);
		$message.="<table style=\"width : 100%;\"><tr><td style=\"text-align : center;width : 100%;\"><a href=\"$link\"><img src=\"$linkimage/coupons/$coupon.png\" style=\"padding-top : 20px;padding-bottom : 20px;border : 0px;\" alt=\"$lang_89 $coupon\" title=\"$lang_89 $coupon\" /></a></td></tr></table>";
	}
                $message.="</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"							
		."--$bound_text--\r\n\r\n";
	return mail($mailto,$subject,wordwrap($message,70),$headers);
        
}

function digitalshopmailinvoice($mailto,$mailfrom,$mailbcc,$keys,$names,$txn_id,$prices,$amount,$checkamount,$country,$tax) {
	
	global $lang_45,$lang_46,$lang_47,$lang_48,$lang_49,$lang_50,$shopname,$email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header;
	global $currency,$location,$lang_01,$lang_03,$lang_34,$lang_83,$lang_84,$lang_85,$headeremailimage,$iframe,$shopcontact;
	$originaladdress=$mailto;
	$originalfromaddress=$mailfrom;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
		if ($mailbcc!='') {$mailbcc=substr($mailbcc,0,strpos($mailbcc,'@')) . " <$mailbcc>";}
	}
	$linkimage=$shopurl . '/shopgfx';
	if ($iframe)
		$shopcolor='#FAFAFA';
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	if ($mailbcc!='') {$headers.="BCC: $mailbcc\r\n";}
	$bound_text=md5(uniqid(time()));
	if ($tax>0) {
		$amount=number_format(floatval($checkamount*($tax/100)),2,'.',',');
		$checkamount=floatval(str_replace(',','',$amount)) + floatval(str_replace(',','',$checkamount));
		$checkamount=number_format(floatval($checkamount),2,'.',',');
		$lang_84=str_replace('[tax]',number_format(floatval($tax),2,'.',',').'%',$lang_84);
	}
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."$lang_83 $txn_id \r\n"
		."$originaladdress \r\n"
		."$country \r\n"
		."$lang_01 $lang_03 $currency \r\n";
		foreach($keys as $index => $key) {$message.="$names[$index] $prices[$index] \r\n";}
		if ($tax>0) {
			$message.="+ ___________ \r\n";
			$message.="$lang_84 $currency ". number_format(floatval($amount),2,'.',',') ." \r\n";
		}	
		$message.="+ ___________ \r\n";
		$message.="$lang_34 $currency ". number_format(floatval($checkamount),2,'.',',') ." \r\n"
		."$shopcontact \r\n"
		."$location \r\n"
		."$lang_49 \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table width=\"100%\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
         $message.="<table style=\"width : 100%;\">"
                ."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;font-weight : bold;padding-right : 20px;\" nowrap=\"nowrap\">$lang_83 $txn_id</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$originaladdress</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$country</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\" nowrap=\"nowrap\">$lang_01</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;font-weight : bold;padding-right : 20px;\" nowrap=\"nowrap\">$lang_03 $currency</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>";
	foreach ($keys as $index => $key) {
                $message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">". $names[$index] ."</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">". $prices[$index] ."</td></tr>";
        }
	$message.="<tr><td>&nbsp; </td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">+ ___________</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>";		
		if ($tax>0) {
			$message.="<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$lang_84</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">". number_format(floatval($amount),2,'.',',') ."</td></tr>";
			$message.="<tr><td>&nbsp;</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;padding-right : 20px;\" nowrap=\"nowrap\">+ ___________</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>";		
		}
		$message.="<tr><td>&nbsp;</td><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;text-align : right;font-weight : bold;padding-right : 20px;\" nowrap=\"nowrap\">$lang_34 $currency ". number_format(floatval($checkamount),2,'.',',') . "</td></tr>"
		."<tr><td colspan=\"2\" >&nbsp;</td></tr><tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$originalfromaddress</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$location</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
		."<tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\" nowrap=\"nowrap\">$lang_49</td></tr><tr><td colspan=\"2\" style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\" nowrap=\"nowrap\">$shopname</td></tr><tr><td colspan=\"2\">&nbsp;</td></tr>"
                ."</table>"
                ."</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"						
		."--$bound_text--\r\n\r\n";
	return mail($mailto,"$lang_85 $shopname",wordwrap($message,70),$headers);

}

function digitalshopmailcommission($mailto,$mailfrom,$mailbcc,$aid,$credit,$debet,$aid_emailpay,$aid_bank) {
	
	global $currency,$commission,$shopname,$email_rewrite,$shopcolor,$pagecolor,$textcolor,$shopurl,$show_header,$headeremailimage,$iframe;
	if ($email_rewrite) {
		$mailto=substr($mailto,0,strpos($mailto,'@')) . " <". $mailto . ">";
		$mailfrom=substr($mailfrom,0,strpos($mailfrom,'@')) . " <$mailfrom>";
		if ($mailbcc!='') {$mailbcc=substr($mailbcc,0,strpos($mailbcc,'@')) . " <$mailbcc>";}
	}
	$linkimage=$shopurl . '/shopgfx';
	if ($iframe)
		$shopcolor='#FAFAFA';	
	$headers="From: $mailfrom\r\n";
	$headers.="Reply-to: $mailfrom\r\n";
	if ($mailbcc!='') {$headers.="BCC: $mailbcc\r\n";}
	$bound_text=md5(uniqid(time()));
	$headers.="MIME-Version: 1.0\r\n" . "Content-Type: multipart/alternative; boundary=\"$bound_text\"\r\n";
	$message="--$bound_text\r\n"
		."Content-Type: text/plain; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."Dear $shopname Administrator,\r\n"
		."Affiliate with ID A$aid has reached the commission threshold.\r\n"
		."Current balance is " . number_format(floatval($credit-$debet),2,'.',',')  ." $currency.\r\n"
		."Please proceed with payment of " . number_format(floatval($commission),2,'.',',')  ." $currency to PayPal account: $aid_emailpay\r\n"
		."and register this affiliate payment in Digital Shop accordingly.\r\n"
		."$shopname \r\n\r\n"
		."--$bound_text\r\n"	
		."Content-Type: text/html; charset=\"UTF-8\"\r\n"
		."Content-Transfer-Encoding: 7bit\r\n\r\n"	
		."<html><head><title></title></head><body><center>"
		."<table  border=\"0\" width=\"630\" cellpadding=\"0\" cellspacing=\"0\" style=\"max-width:630px; margin: 0 auto;\"><tr><td>"
                ."<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lt.gif\" >&nbsp;</td><td height=\"39px\" background=\"$linkimage/tabletop.gif\" >&nbsp;</td>"
                ."<td width=\"39px\" height=\"39px\" background=\"$linkimage/rt.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" background=\"$linkimage/tableleft.gif\" >&nbsp;</td><td style=\"background-color : $shopcolor\">";
        if ($show_header)
                $message.="<table width=\"100%\"><tr><td style=\"text-align : center;width : 100%;\"><img src=\"$linkimage/$headeremailimage\" style=\"padding-bottom : 20px;border : 0px;\" /></td></tr></table>";
         $message.="<table>"
                ."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold\">Dear $shopname Administrator,</td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">Affiliate with ID <b>A$aid</b> has reached the commission threshold.</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">Current balance is <b>" . number_format(floatval($credit-$debet),2,'.',',')  ."</b> $currency.</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">Please pay <b>" . number_format(floatval(floor(($credit-$debet)/$commission)*$commission),2,'.',',')  ." $currency</b> to $aid_bank account: $aid_emailpay </td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;\">and register this affiliate payment in Digital Shop accordingly.</td></tr><tr><td>&nbsp;</td></tr>"
		."<tr><td style=\"font-family: Verdana, Helvetica, Arial, sans-serif; font-size : 12px; color: $textcolor;padding-left : 20px;font-weight : bold;\">$shopname</td></tr><tr><td>&nbsp;</td></tr>"
                ."</table>"
                ."</td><td width=\"39px\" background=\"$linkimage/tableright.gif\" >&nbsp;</td></tr><tr><td width=\"39px\" height=\"39px\" background=\"$linkimage/lb.gif\" >&nbsp;</td>"
                ."<td height=\"39px\" background=\"$linkimage/tablebottom.gif\" >&nbsp;</td><td width=\"39px\" height=\"39px\" background=\"$linkimage/rb.gif\" >&nbsp;</td></tr></table>"        
                ."</td></tr></table></center></body></html>\r\n\r\n"							
		."--$bound_text--\r\n\r\n";
	return mail($mailto,"Commission due for affiliate A$aid",wordwrap($message,70),$headers);

}

function topborder() {
	
        global $shopcolor,$transparentshop;
        echo "<table style=\"border : 0px;width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n";
        echo "<td style=\"width : 39px;height : 39px;background-image : url('shopgfx/lt.gif');\">&nbsp;</td>\n";
        echo "<td style=\"background-image : url('shopgfx/tabletop.gif');\">&nbsp;</td>\n";
        echo "<td style=\"width : 39px;background-image : url('shopgfx/rt.gif');\">&nbsp;</td></tr>\n";
        echo "<tr><td style=\"background-image : url('shopgfx/tableleft.gif');\">&nbsp;</td>\n";
	if (!$transparentshop)
		echo "<td style=\"text-align : center;background-color : $shopcolor\">\n";
	else
		echo "<td style=\"text-align : center;background-color : transparent\">\n";
	
}

function bottomborder() {
	
        echo "</td><td style=\"background-image : url('shopgfx/tableright.gif');\">&nbsp;</td></tr>\n";
        echo "<tr><td style=\"height : 39px;background-image : url('shopgfx/lb.gif');\">&nbsp;</td>\n";
        echo "<td style=\"background-image : url('shopgfx/tablebottom.gif');\">&nbsp;</td>\n";
        echo "<td style=\"background-image : url('shopgfx/rb.gif');\">&nbsp;</td>\n";
        echo "</tr></table>\n";
	
}

function couponcode($coupon,$value,$expire,$maxcntr) {

	global $currency,$shopurl,$shopname,$lang_87,$lang_89,$lang_90,$lang_91,$lang_92,$coupontitlecolor,$coupontextcolor,$couponcodecolor,$iframe,$iframe_shop;
	$im=imagecreatefrompng('shopgfx/coupon.png');
	$color=imagecolorallocate($im,hexdec(substr($coupontextcolor,1,2)),hexdec(substr($coupontextcolor,3,2)),hexdec(substr($coupontextcolor,5,2)));
	$titlecolor=imagecolorallocate($im,hexdec(substr($coupontitlecolor,1,2)),hexdec(substr($coupontitlecolor,3,2)),hexdec(substr($coupontitlecolor,5,2)));
	$codecolor=imagecolorallocate($im,hexdec(substr($couponcodecolor,1,2)),hexdec(substr($couponcodecolor,3,2)),hexdec(substr($couponcodecolor,5,2)));
        // Title
        $fontsize=40;
        $pos_longest=imagettfbbox($fontsize,0,'shopfonts/filetype.ttf',$shopname.' '.$lang_87);
	while (($pos_longest[2]-$pos_longest[0])>imagesx($im)*0.93) {
		$fontsize=$fontsize-1;
		$pos_longest=imagettfbbox($fontsize,0,'shopfonts/filetype.ttf',$shopname.' '.$lang_87);
	}
	$width=imagettfbbox($fontsize,0,'shopfonts/filetype.ttf',$shopname.' '.$lang_87);$x=floor((imagesx($im)-$width[2])/2);
        imagettftext($im,$fontsize,0,$x,50,$titlecolor,'shopfonts/filetype.ttf',$shopname.' '.$lang_87);
        // Discount
	$width=imagettfbbox(48,0,'shopfonts/pricefont.ttf',$value . ' '. $currency);$x=floor((imagesx($im)-$width[2])/2);
	imagettftext($im,48,0,$x,125,$color,'shopfonts/pricefont.ttf',number_format(floatval($value*-1),2,'.','') . ' '. $currency);
	// Code
	$width=imagettfbbox(36,0,'shopfonts/filetype.ttf',$lang_89 . ' '. $coupon);$x=floor((imagesx($im)-$width[2])/2);
	imagettftext($im,36,0,$x,170,$codecolor,'shopfonts/filetype.ttf',$lang_89 . ' '. $coupon);
	imagestring($im,2,20,240,$lang_89 . ': '. $coupon,$color);
	// URL
        $fontsize=30;
	if (!$iframe)
		$link=$shopurl;
	else
		$link=$iframe_shop;
	
        $pos_longest=imagettfbbox($fontsize,0,'shopfonts/filetype.ttf',$link);
	while (($pos_longest[2]-$pos_longest[0])>imagesx($im)*0.93) {
		$fontsize=$fontsize-1;
		$pos_longest=imagettfbbox($fontsize,0,'shopfonts/filetype.ttf',$link);
	}       
	$width=imagettfbbox($fontsize,0,'shopfonts/filetype.ttf',$link);$x=floor((imagesx($im)-$width[2])/2);
	imagettftext($im,$fontsize,0,$x,210,$color,'shopfonts/filetype.ttf',$link);	
	// Terms
	if ($maxcntr>1) {
		$text=str_replace('[maxcntr]',$maxcntr,$lang_91);
		imagestring($im,2,20,255,$lang_90 . ' ' . date('Y-m-d H:i',$expire) . ' ' . date('T') . ' ' . $text,$color);
		imagestring($im,2,20,270,$lang_92,$color);
	} else {
		imagestring($im,2,20,255,$lang_90 . ' ' . date('Y-m-d H:i',$expire) . ' ' . date('T'),$color);
		imagestring($im,2,20,270,$lang_92,$color);
	}
	imagepng($im,'shopgfx/coupons/'.$coupon.'.png');
	
}

function createcaptcha() {

	$chars=array('a','b','c','d','e','f','h','i','j','k','m','n','p','r','s','u','w','y','3','5','6','7','8');
	$rand_keys=array_rand($chars,5);$code=$chars[$rand_keys[0]].$chars[$rand_keys[1]].$chars[$rand_keys[2]].$chars[$rand_keys[3]].$chars[$rand_keys[4]];
	$_SESSION['digitalshopcaptchacode']=$code;
	$im=imagecreate(178,42);
	$white=imagecolorallocate($im,255,255,255);$black=imagecolorallocate($im,0,0,0);$grey=imagecolorallocate($im,128,128,128);
	imagefilledrectangle($im,0,0,178,42,$white);	
	for ($c=0;$c<5;$c++) {
		$xpos=10+$c*35;
		$fontangle=rand(-20,20);
		imagettftext($im,36,$fontangle,$xpos+4,28,$grey,'shopfonts/filetype.ttf',substr($code,$c,1));
		imagettftext($im,36,$fontangle,$xpos,24,$black,'shopfonts/filetype.ttf',substr($code,$c,1));
	}	
	imageline($im,0,10,178,10,$grey);imageline($im,0,20,178,20,$black);imageline($im,0,30,178,30,$grey);
	header("Content-type: image/png");
	imagepng($im);
	imagedestroy($im);
	
}

function rteSafe($strText) {

	$tmpString = $strText;
	$tmpString = str_replace(chr(145), chr(39), $tmpString);
	$tmpString = str_replace(chr(146), chr(39), $tmpString);
	$tmpString = str_replace("'", "&#39;", $tmpString);
	$tmpString = str_replace(chr(147), chr(34), $tmpString);
	$tmpString = str_replace(chr(148), chr(34), $tmpString);
	$tmpString = str_replace(chr(10), " ", $tmpString);
	$tmpString = str_replace(chr(13), " ", $tmpString);
	return $tmpString;
	
}

function createicon($filename,$size,$id,$type) {
	
	global $shop_fileinfocolor,$shop_filenamecolor,$fileinfosize,$filenamesize,$fileinfoy,$filenamey;
        if ($type=='Directory') {
                $extension='*.*';$filename=strtoupper($filename);
        } else {
                $extension=strtoupper(substr($filename,strrpos($filename,'.'),strlen($filename)));$filename=strtoupper(substr($filename,0,strlen($filename)-strlen($extension)));
        }
	$im=imagecreatefrompng('shopgfx/filetype.png');
	$fileinfocolor=imagecolorallocate($im,hexdec(substr($shop_fileinfocolor,1,2)),hexdec(substr($shop_fileinfocolor,3,2)),hexdec(substr($shop_fileinfocolor,5,2)));
	$filenamecolor=imagecolorallocate($im,hexdec(substr($shop_filenamecolor,1,2)),hexdec(substr($shop_filenamecolor,3,2)),hexdec(substr($shop_filenamecolor,5,2)));
        $width=imagettfbbox($fileinfosize,0,'shopfonts/filetype.ttf',$size);$x=floor((imagesx($im)-$width[2])/2);
        imagettftext($im,$fileinfosize,0,$x,$fileinfoy,$fileinfocolor,'shopfonts/filetype.ttf',$size);
        $width=imagettfbbox($filenamesize,0,'shopfonts/filetype.ttf','W');$fw=$width[2]+0.5;$h=$width[5]*-1;
        $txt=explode("\n",wordwrap($filename,ceil(imagesx($im)/$fw),"\n",true));$y=$filenamey;
        foreach ($txt as $text) {
          $width=imagettfbbox($filenamesize,0,'shopfonts/filetype.ttf',$text);$x=floor((imagesx($im)-$width[2])/2);
          imagettftext($im,$filenamesize,0,$x,$y,$filenamecolor,'shopfonts/filetype.ttf',$text);$y=$y+floor($h*1.5);
        }
	imagepng($im,"gfx/$id.png");
	
}

function priceicon($price) {
	
	global $tagx,$tagy,$tagsize,$pricecolor,$write_text,$lang_80,$lang_05,$lang_160;
        if ($price=='0.00') {$price=$lang_80;}
	if ($price=='0.01') {$price=$lang_160;}
	$im=imagecreatefrompng('shopgfx/pricetag.png');$tagcolor=imagecolorallocate($im,hexdec(substr($pricecolor,1,2)),hexdec(substr($pricecolor,3,2)),hexdec(substr($pricecolor,5,2)));
	$width=imagettfbbox($tagsize,0,'shopfonts/pricefont.ttf',$price);$x=ceil((imagesx($im)-$width[2])/2);
	imagettftext($im,$tagsize,0,$x+$tagx,$tagy,$tagcolor,'shopfonts/pricefont.ttf',$price);
	if ($write_text) {
		// Buy now! tag
		$lines=explode(' ',$lang_05);
		for ($c=0;$c<count($lines);$c++) {
			imagestring($im,2,5,imagesy($im)-((count($lines)-$c)*15),$lines[$c],$tagcolor);
		}
	}
	imagepng($im,"gfx/$price.png");
	
}

?>
